package CodeGen;

/**
 * This type was created in VisualAge.
 *
 * Version 0.1 - Created from agentMom transform version 0.4.
 *      creates the agent class shells, datatype shells, and 
 *		conversation classes for and agentTool Agent Diagram and its
 *		associated Conversation Diagrams.  It does not fill in any of
 *		the Agent class information outside of the default "write"
 *		method.
 *
 * Not yet implemented:
 *  1. actions on transitions
 *     -- to include special "return" action
 *  2. fill in "handleMessage" for each agent - can be automated
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
import system.*;
import java.util.*;
import java.io.*;
public class Carolina {
	String version = " - Carolina transform ver 0.1";
	String outDirName = "C:/Windows/Desktop/Test";
	Vector combinedTypes;
	Vector initialVariables;
	Vector localVariables;
	Vector methods;
	boolean debug = false;
	MessageGUI gui;
/**
 * Carolina constructor comment.
 */
public Carolina() {
	super();
}
/**
 * This method was created in VisualAge.
 * @param out java.io.PrintWriter
 * @param stInit afit.system.ATstatetable
 */
private void addCombinedParams(PrintWriter out, String[] tokens) {
	// isVoid denotes whether or not the first parameter is a variable to which
	// the result of an assignment is made (e.g., x = funct(param1, param2, ...))
	// or a void function call (e.g., funct(param1, param2, ...))

	String className = "";
	String objectName = "";
	int i = 0;
	int firstParam = 1;
	boolean returnValue = false;
	int eqLoc = -1;

	/* determine if there is a return value by finding
	 * the location of the = sign, reset the location of
	 * the first parameter to the token beyond the = sign */
	for (int k = 0; k < tokens.length; k++)
		if (tokens[k].equals("=")) {
			returnValue = true;
			eqLoc = k;
			firstParam = k + 1;
		}

		/* loop through transitions */
	if (tokens.length > firstParam + 1) {
		/* get className and strip off "_Type" at end */
		className = getParameterClassName(tokens);
		if (!className.equals("")) {
			objectName = className.substring(0, className.length() - 5);

			if ((initialVariables.indexOf(objectName) < 0) && (localVariables.indexOf(objectName) < 0)) {
				combinedTypes.addElement(objectName);
				localVariables.addElement(objectName);
				out.println("\t" + className + " " + objectName + " = new " + className + "();");
				createParameterClass(tokens);
			}
		}
	}
}
/**
 * This method was created in VisualAge.
 * @param out java.io.PrintWriter
 * @param stInit int
 */
private void addStateConstants(PrintWriter out, ATstatetable stInit)
{
	int i = 1;
	String stateName = "";
	Vector v = new Vector(3);

	/* print definitions */
	out.println("\n\t/* state constant definitions */");
	out.println("\tfinal int StartState = 0;");

	// loop through states
	Enumeration stateEnum = stInit.returnStates();
	while (stateEnum.hasMoreElements())
	{
		try
		{
			stateName = ((ATstate) stateEnum.nextElement()).getName();
			if (v.indexOf(stateName) < 0)
			{
				v.addElement(stateName);
				out.println("\tfinal int " + stateName + " = " + i++ +";");
			}
		} catch (ClassCastException e)
		{
			// skip start and end states ???
		}
	}

	// loop through transitions
	Enumeration transEnum = stInit.returnTrans();
	while (transEnum.hasMoreElements())
	{
		try
		{
			stateName = ((ATtransition) transEnum.nextElement()).getCurrentState().getName() + "_out";
			if (v.indexOf(stateName) < 0)
			{
				v.addElement(stateName);
				out.println("	final int " + stateName + " = " + i++ +";");
			}
		} catch (ClassCastException e)
		{
			// skip start and end states ???
		}
	} //
}
/**
 * This method was created in VisualAge.
 * @param out java.io.PrintWriter
 * @param stInit afit.system.ATstatetable
 */
private void addVariableDeclarations(PrintWriter out, String[] tokens) {
	int firstParam = getFirstParamLocation(tokens);

	/* print variable declarations if they have not been declared before */

	for (int i = firstParam; i < tokens.length; i++) {
		String var = ((tokens[i].replace('<', ' ')).replace('>', ' ')).trim();
		if ((initialVariables.indexOf(var) < 0) && (localVariables.indexOf(var) < 0))
			if (!var.equals("=")) {
				out.println("\t" + "Object " + var + " = null;");
				localVariables.addElement(var);
			}
			/* if we found an = sign, skip adding the next token since it is an actin name */
			else
				i++;
	}
}
/**
 * This method was created in VisualAge.
 */
public void combineReceiveParameters(PrintWriter out, String[] receiveTokens, int depth) {
	int i, j;
	String current;
	String paramName = "";

	/* compute parameter name */
	if (receiveTokens.length == 2)
		paramName = receiveTokens[1];
	else
		if (receiveTokens.length > 2) {
			for (i = 1; i < receiveTokens.length - 1; i++)
				paramName = paramName + receiveTokens[i] + "_";
			paramName = paramName + receiveTokens[receiveTokens.length - 1];
		}

		/* define statement */
	if (receiveTokens.length > 1) {
		for (i = 1; i <= depth; i++)
			out.print("\t");
		if (receiveTokens.length == 2) {
			out.println(paramName + " = m.getMessageObject();");
		}
		if (receiveTokens.length > 2) {
			out.println(paramName + " = (" + paramName + "_Type) " + "m.getMessageOObject();");
			for (i = 1; i < receiveTokens.length; i++) {
				for (j = 1; j <= depth; j++)
					out.print("\t");
				current = receiveTokens[i];
				out.println(current + " = " + paramName + "." + current + ";");
			}
		}
	}
}
/**
 * This method was created in VisualAge.
 */
public String combineSendParameters(PrintWriter out, String[] actionTokens, int depth) {
	int i, j;
	String current;
	String content = "";

	// if there are multiple parameters
	if (actionTokens.length > 2) {
		for (i = 1; i < actionTokens.length; i++) {
			for (j = 1; j <= depth; j++)
				out.print("\t");
			current = actionTokens[i];
			for (j = 1; j < actionTokens.length - 1; j++)
				out.print(actionTokens[j] + "_");
			out.print(actionTokens[actionTokens.length - 1] + "." + current);
			out.println(" = " + current + ";");
		}
	}

	// build content string
	if (actionTokens.length > 1) {
		for (i = 1; i < actionTokens.length - 1; i++)
			content = content + actionTokens[i] + "_";
		content = content + actionTokens[actionTokens.length - 1];
	} else
		content = "\" \"";
		
	return content;
}
/**
 * This method was created in VisualAge.
 * @param tokens java.lang.String[]
 */
private String createParameterClass(String[] tokens)
{
	int i;
	int firstParam = getFirstParamLocation(tokens);
	String className = getParameterClassName(tokens);

	/* open the file */
	try
	{
		File outFile = new File(outDirName, className + ".java");
		FileOutputStream outFileStream = new FileOutputStream(outFile);
		PrintWriter out = new PrintWriter(outFileStream);

		/* print file header info */
		out.println("/*");
		out.println("*");
		out.println("* Data Type class: " + className + ".");
		out.println("*");
		out.println("* automatically generated by agentTool" + version);
		out.println("*");
		out.println("*/");
		out.println("import afit.mom.*;");

		// print class info
		out.println("public class " + className);
		out.println("{");
		for (i = firstParam; i < tokens.length; i++)
			out.println("	Object " + tokens[i] + ";");
		out.println("}");
		out.close();
	} catch (java.io.IOException e)
	{
		gui.write(" * * Error trying to open file " + outDirName + className + ".java ");
	}
	return className;
}
/**
 * This method was created in VisualAge.
 * @param a afit.system.ATagent
 */
private void genAgentCode(ATagent a, ATsystem sys) {
	String className = a.getName();
	try {
		gui.write("generating code for agent " + className);
		File outFile = new File(outDirName, className + ".java");
		FileOutputStream outFileStream = new FileOutputStream(outFile);
		PrintWriter out = new PrintWriter(outFileStream);

		/* class definition */
		// header
		out.println("/*");
		out.println("*");
		out.println("* Class for agent " + className);
		out.println("*");
		out.println("* automatically generated by agentTool" + version);
		out.println("*");
		out.println("*/");

		// import statements
		out.println("import java.net.*;");
		out.println("import java.io.*;");
		out.println("import java.awt.*;");
		out.println("import java.util.*;");
		out.println("import carolina.*;");
		out.println("");
		out.println("/* do I need to import package here for agent or shared data ??? */ ");
		out.println("");
		
		// actual definiton
		out.println("public class " + className + " extends BaseAgentExtended");
		out.println("{");

		/* default constructor */
		out.println("\n/*");
		out.println("*");
		out.println("* Constructor for agent.");
		out.println("* ");
		out.println("* automatically generated by agentTool" + version);
		out.println("* ");
		out.println("*/");
		out.println("public " + className + " () ");
		out.println("{ ");
		out.println("\tsuper(\"" + className + "\");");
		out.println("}");

		/* Arrival method */
		out.println("\n/*");
		out.println("*");
		out.println("* Arrival method for agent.  This must be completed by user.");
		out.println("* ");
		out.println("* automatically generated by agentTool" + version);
		out.println("* ");
		out.println("*/");
		out.println("\npublic void arrival() ");
		out.println("{");
		out.println("}");

		/* Birth method */
		out.println("\n/*");
		out.println("*");
		out.println("* Birth method for agent.  This must be completed by user.");
		out.println("* ");
		out.println("* automatically generated by agentTool" + version);
		out.println("* ");
		out.println("*/");
		out.println("\npublic void birth() ");
		out.println("{");
		out.println("}");

		/* Death method */
		out.println("\n/*");
		out.println("*");
		out.println("* Death method for agent.  This must be completed by user.");
		out.println("* ");
		out.println("* automatically generated by agentTool" + version);
		out.println("* ");
		out.println("*/");
		out.println("\npublic void death() ");
		out.println("{");
		out.println("}");

		/* Leave method */
		out.println("\n/*");
		out.println("*");
		out.println("* Leave method for agent.  This must be completed by user.");
		out.println("* ");
		out.println("* automatically generated by agentTool" + version);
		out.println("* ");
		out.println("*/");
		out.println("\npublic void leave() ");
		out.println("{");
		out.println("}");

		/* Job method */
		out.println("\n/*");
		out.println("*");
		out.println("* Job method for agent.  This must be completed by user.");
		out.println("* ");
		out.println("* automatically generated by agentTool" + version);
		out.println("* ");
		out.println("* NOTE: This is code for a generic agent that simply responds to");
		out.println("*       messages ... your agent may be MUCH more complex!");
		out.println("*/");
		out.println("\npublic void job()");
		out.println("{");
		out.println("\tMessage msg = null;");
		out.println("\twhile (true)");
		out.println("\t{");
		out.println("\t\tmsg = (Message) getMessageByID();");
		out.println("\t\tif (msg != null) handleMessage(msg);");
		out.println("\t");
		out.println("\t\tsleep(100);");
		out.println("\t}");
		out.println("}");

		/* Write method */
		out.println("\n/*");
		out.println("*");
		out.println("* Write method - used to write conversation error messages to output.");
		out.println("* ");
		out.println("* automatically generated by agentTool" + version);
		out.println("* ");
		out.println("*/");
		out.println("\npublic void write(String s) ");
		out.println("{");
		out.println("\tSystem.out.println(s);");
		out.println("}");

		/* HandleMessage method - required for Carolina */
		out.println("\n/*");
		out.println("*");
		out.println("* Required method for Carolina framework - must be completed by user.");
		out.println("* ");
		out.println("* automatically generated by agentTool" + version);
		out.println("* ");
		out.println("*/ ");
		out.println("\npublic void handleMessage(Message m) ");
		out.println("{");
		out.println("\tint i;");
		out.println("\tThread t;");
		out.println("");
		out.println("\t//Determine if a new connection is needed");
		out.println("\tif (m.inReply == null){");
		out.println("");
		out.println("\t\tDate date = new Date();			");
		out.println("\t\tString convID = new Long(date.getTime()).toString();");
		out.println("\t\tm.inReply = convID;");
		out.println("");
	/* this is a place for looking up conversation that can be started ... can be done automatically */
		out.println("// fill in appropriate code for each possible conversation");
		out.println("//\t\tif (m.getPerformative().equals(\"register\")){");
		out.println("//\t\t\t//write(\"Starting register responder\");");
		out.println("//\t\t\tt = new Thread(new Register_SearchSystem_R(this, m, convID));");
		out.println("//\t\t\tt.start();");
		out.println("//\t\t}");
		out.println("//\t\telse {");
		out.println("//\t\t\t//write(\"Trying to start an unknown conversation\");");
		out.println("//\t\t\tt = new Thread(new Sorry(this, m));");
		out.println("//\t\t\tt.start();");
		out.println("//\t\t}");
		out.println("");	
		out.println("\t}");
		out.println("\telse {");
		out.println("\t\tpostMessage(m);");
		out.println("");
		out.println("\t}");
		out.println("");
		out.println("}");
		out.println("");
		if (debug)
			gui.write("Looking for methods referenced in conversations.");

		/* find methods referenced in conversation that must be implmented in the agent */

		/* keep track so we don't duplicate method names */
		methods = new Vector(5);
		methods.addElement("arrival");
		methods.addElement("birth");
		methods.addElement("death");
		methods.addElement("leave");
		methods.addElement("job");
		methods.addElement("handleMessage");
		methods.addElement("write");

		/* loop through each conversation */
		Enumeration convsEnum = sys.returnConvs();
		while (convsEnum.hasMoreElements()) {
			ATconversation c = (ATconversation) convsEnum.nextElement();
			for (int initResp = 1; initResp <= 2; initResp++) {
				ATstatetable stInit = c.getStateTable(initResp);

				/* if this conversation is for this agent */
				if (className.equals(stInit.getParticipant().getName())) {
					// loop through states ... and check actions
					Enumeration enum = stInit.returnStates();
					while (enum.hasMoreElements()) {
						try {
							ATstate s = (ATstate) enum.nextElement();
							Vector v = (Vector) s.getActions();
							Enumeration actions = v.elements();
							while (actions.hasMoreElements()) {
								String action = (String) actions.nextElement();
								if (!action.equals("")) {
									if (debug)
										gui.write("Generating method for " + action);
									String[] tokens = parseAction2(action);
									if (debug)
										for (int j = 0; j < tokens.length; j++)
											gui.write(" *** Token[" + j + "] = " + tokens[j]);

										// do we have to assign a value to the return value
									boolean returnValue = false;
									int eqLoc = 0;
									for (int k = 0; k < tokens.length; k++)
										if (tokens[k].equals("=")) {
											returnValue = true;
											eqLoc = k;
										}

										// a return value exists
									if (returnValue) {
										// the default return type is Object
										String typeName = "Object";

										// are we returning multiple values (i.e., <x, y> = doit(...)).
										if (eqLoc > 1) {
											String outTokens[] = new String[eqLoc + 1];
											// start at 1 since the first token is skipped in createParameterClass
											for (int l = 1; l < eqLoc + 1; l++) {
												outTokens[l] = ((tokens[l - 1].replace('<', ' ')).replace('>', ' ')).trim();
												if (debug)
													gui.write("outTokens[" + l + "] = |" + outTokens[l] + "|");
											}
											typeName = createParameterClass(outTokens);
										}
										if (tokens[eqLoc + 1].equals("run") 
											|| tokens[eqLoc + 1].equals("arrival") || tokens[eqLoc + 1].equals("birth")
											|| tokens[eqLoc + 1].equals("death") || tokens[eqLoc + 1].equals("leave")
											|| tokens[eqLoc + 1].equals("job") || tokens[eqLoc + 1].equals("handleMessage") 
											|| tokens[eqLoc + 1].equals("write")) {
											gui.writeError("Action " + tokens[eqLoc + 1] + " is reserved name for Carolina agent class!");
										}

										/* check to make sure we haven't already added a method by that name */
										else
											if (methods.indexOf(tokens[eqLoc + 1]) >= 0) {
												gui.write("* Warning * Action " + tokens[eqLoc + 1] + " has already been defined!");
											}

											/* add the new method */
											else {
												methods.addElement(tokens[eqLoc + 1]);
												out.println("\n/*");
												out.println("*");
												out.println("* Method " + tokens[eqLoc + 1] + " referenced in conversation - must be completed by user.");
												out.println("* ");
												out.println("* automatically generated by agentTool" + version);
												out.println("* ");
												out.println("*/ ");
												if (tokens.length == eqLoc + 2)
													out.println("\npublic " + typeName + " " + tokens[eqLoc + 1] + " ()");
												else {
													out.print("\npublic " + typeName + " " + tokens[eqLoc + 1] + " (");
													for (int j = eqLoc + 2; j < tokens.length; j++)
														if (j == eqLoc + 2) {
															out.print("Object " + tokens[j]);
															if (tokens.length == eqLoc + 3)
																out.println(")");
														} else
															if (j == tokens.length - 1)
																out.println(", Object " + tokens[j] + ") ");
															else
																out.print(", Object " + tokens[j]);
												}
												out.println("{");
												out.println("\treturn null;");
												out.println("}");
											}
									}

									// void method
									if (!returnValue)
										if (methods.indexOf(tokens[0]) >= 0) {
											gui.write("* Warning * Action " + tokens[0] + " has already been defined!");
										}

										/* build method */
										else {
											methods.addElement(tokens[0]);
											out.println("\n/*");
											out.println("*");
											out.println("* Method " + tokens[0] + " referenced in conversation - must be completed by user.");
											out.println("* ");
											out.println("* automatically generated by agentTool" + version);
											out.println("* ");
											out.println("*/ ");
											if (tokens.length == 1)
												out.println("\npublic void " + tokens[0] + " ()");
											else {
												out.print("\npublic void " + tokens[0] + " (");
												for (int j = 1; j < tokens.length; j++)
													if (j == 1) {
														out.print("Object " + tokens[j]);
														if (tokens.length == 2)
															out.println(")");
													} else
														if (j == tokens.length - 1)
															out.println(", Object " + tokens[j] + ") ");
														else
															out.print(", Object " + tokens[j]);
											}
											out.println("{");
											out.println("}");
										}
									if (debug)
										gui.write("Done generating method for " + action);
								}
							}
						} catch (ClassCastException e) {
							// skip start and end states
						}
					}
				}
				if (debug)
					gui.write("Done with conversation " + c.getName() + " - VALID FOR THIS AGENT!");
			}
			if (debug)
				gui.write("Done with conversation " + c.getName());
		}
		if (debug)
			gui.write("Done looking at all conversations ");

		/* end of agent definition */
		out.println("\n}");
		out.close();
		if (debug)
			gui.write("Done with agent ... ");
	} catch (java.io.IOException e) {
		gui.write("** Error trying to open file " + outDirName + className + ".java ");
	}
}
/**
 * Insert the method's description here.
 * Creation date: (8/3/00 1:58:23 PM)
 */
private void genBaseAgentCode() {
	try {
		gui.write("generating code for agent BaseAgentExtended");
		File outFile = new File(outDirName, "BaseAgentExtended.java");
		FileOutputStream outFileStream = new FileOutputStream(outFile);
		PrintWriter out = new PrintWriter(outFileStream);

		/* class definition */
		// header
		out.println("");


		/* start code */

		out.println("/**");
		out.println("*  This is an abstract parent class to all agents generated");
		out.println("*  by agentMom ... ");
		out.println("*");
		out.println("*  Change History");
		out.println("*  Date        Initials     Description");
		out.println("*  ------------------------------------------------------------------");
		out.println("*  23 MAY 2000  SAO Added PostMessage(Message) for Conversation");
		out.println("*					 also added three vectors for conversation and");
		out.println("*					 message information.");
		out.println("*  ------------------------------------------------------------------");
		out.println("*/");
		out.println("import  java.util.*;");
		out.println("import  java.util.Date;");
		out.println("import  java.net.*; //sao 20 MAY 00");
		out.println("import  java.io.*;  //sao 20 MAY 00");
		out.println("");
		out.println("import  carolina.*;");
		out.println("");
		out.println("abstract public class BaseAgentExtended extends BaseAgent implements java.io.Serializable {");
		out.println("");
		out.println("	//Keeps track of messages awaiting pickup (Mailbox)");
		out.println("	public Vector Messages = new Vector();			//sao 23 MAY 00");
		out.println("	public Vector MessageIdentifiers = new Vector(); 	//sao 23 MAY 00");
		out.println("");
		out.println("/**");
		out.println("*  main constructor for every agent");
		out.println("*/");
		out.println("public BaseAgentExtended(String _type) {");
		out.println("");
		out.println("	super(_type);");
		out.println("		   ");
		out.println("}");
		out.println("/**");
		out.println("*  abstract function when the agent gets a new start");
		out.println("*  after the agent has reached a new server");
		out.println("*/");
		out.println("abstract public void arrival();");
		out.println("");
		out.println("/**");
		out.println("*  abstract function when the agent is created");
		out.println("*  Constructor extension.");
		out.println("*/");
		out.println("abstract public void birth();");
		out.println("");
		out.println("/**");
		out.println("*  function called when an agent is dying");
		out.println("*/	");
		out.println("abstract public void death();");
		out.println("");
		out.println("/**");
		out.println("*  Finalize method for agent");
		out.println("*/");
		out.println("protected void finalize() throws java.lang.Throwable {");
		out.println("	AP = null;");
		out.println("}");
		out.println("");
		out.println("abstract public void handleMessage(Message m);");
		out.println("");
		out.println("/**");
		out.println("*  abstract function when the agent gets a new start");
		out.println("*  after the agent has reached a new server");
		out.println("*/");
		out.println("abstract public void job();");
		out.println("");
		out.println("/**");
		out.println("*  abstract function when the agent gets a new start");
		out.println("*  after the agent has reached a new server");
		out.println("*/");
		out.println("abstract public void leave();");
		out.println("");
		out.println("public synchronized Message nonblockedReadMessage(String convID){");
		out.println("	int index;");
		out.println("	int counter = 0;");
		out.println("	do{");
		out.println("		index = MessageIdentifiers.indexOf(convID);");
		out.println("		counter++;");
		out.println("		sleep(10);");
		out.println("	}");
		out.println("	while ((index == -1)&&(counter <= 10));");
		out.println("");
		out.println("	Message m;");
		out.println("	");
		out.println("	if (index == -1)");
		out.println("		 m = null;");
		out.println("	else {");
		out.println("			m = (Message) Messages.elementAt(index);");
		out.println("			Messages.removeElementAt(index);");
		out.println("			MessageIdentifiers.removeElementAt(index);");
		out.println("	}");
		out.println("	return m;");
		out.println("}");
		out.println("");
		out.println("/***");
		out.println(" *");
		out.println(" * Method for adding messages to the \" Mail Box \"");
		out.println(" *");
		out.println(" * sao 23 MAY 00");
		out.println(" */");
		out.println("public void postMessage(Message m){");
		out.println("");
		out.println("	int index = Messages.size();");
		out.println("	MessageIdentifiers.insertElementAt(m.inReply, index);");
		out.println("	Messages.insertElementAt(m, index);");
		out.println("		");
		out.println("}");
		out.println("");
		out.println("public synchronized Message readMessage(String convID){");
		out.println("	int index = -1;");
		out.println("	do{");
		out.println("		index = MessageIdentifiers.indexOf(convID);");
		out.println("		sleep(10);");
		out.println("	}");
		out.println("	while (index == -1);");
		out.println("	");
		out.println("	Message m = (Message) Messages.elementAt(index);");
		out.println("	Messages.removeElementAt(index);");
		out.println("	MessageIdentifiers.removeElementAt(index);");
		out.println("	return m;");
		out.println("}");
		out.println("}");
		/* end of agent definition */

		out.close();
		if (debug)
			gui.write("Done with agent ... ");
	} catch (java.io.IOException e) {
		gui.write("** Error trying to open file " + outDirName + "BaseAgentExtended.java ");
	}
}
/**
 * Insert the method's description here.
 * Creation date: (8/3/00 1:58:23 PM)
 */
private void genConversationCode() {
	try {
		gui.write("generating code for agent Conversation");
		File outFile = new File(outDirName, "Conversation.java");
		FileOutputStream outFileStream = new FileOutputStream(outFile);
		PrintWriter out = new PrintWriter(outFileStream);

		/* class definition */
		// header
		out.println("");


		/* start code */

		out.println("/**");
		out.println(" * AFIT");
		out.println(" *");
		out.println(" *");
		out.println(" * Abstract Conversation class.");
		out.println(" */");
 		out.println("");
		out.println("import java.net.*;");
		out.println("import java.io.*;");
		out.println("import carolina.*;");
		out.println("");
		out.println("public abstract class Conversation extends Thread {");
		out.println("	protected BaseAgentExtended parent;");
		out.println("");
		out.println("	protected Message m;");
		out.println("");
		out.println("	protected String convID;");
		out.println("	");
		out.println("");
		out.println("/**");
		out.println(" * Initiator Conversation constructor.");
		out.println(" * @param a agent");
		out.println(" */");
		out.println("public Conversation(BaseAgentExtended a) {");
		out.println("	super();");
		out.println("	parent = a;");
		out.println("}");
		out.println("/**");
		out.println(" * Responder Conversation constructor.");
		out.println(" * @param a agent");
		out.println(" */");
		out.println("public Conversation(BaseAgentExtended a, Message m1) {");
		out.println("	super();");
		out.println("	parent = a;");
		out.println("	m = m1;");
		out.println("}");
		out.println("public Message createMessageByID(String perform, Object content, String rID, String rLoc, String realLoc, String replyTo, String inReply){");
		out.println("");
		out.println("	Message m = new Message();");
		out.println("");
		out.println("	m.setPerformative(perform);");
		out.println("	m.setMessageObject(content);");
		out.println("	m.setReceiverID(rID);");
		out.println("	m.setReceiverLocation(rLoc);");
		out.println("	m.realFromLocation = realLoc.toUpperCase();");
		out.println("	m.replyTo = replyTo;");
		out.println("	m.inReply = inReply;");
		out.println("");
		out.println("	return m;");
		out.println("");
		out.println("}");
		out.println("public Message createMessageByType(String perform, Object content, String rType, String rLoc, String realLoc, String replyTo, String inReply){");
		out.println("");
		out.println("	Message m = new Message();");
		out.println("");
		out.println("	m.setPerformative(perform);");
		out.println("	m.setMessageObject(content);");
		out.println("	m.setReceiverType(rType);");
		out.println("	m.setReceiverLocation(rLoc);");
		out.println("	m.realFromLocation = realLoc.toUpperCase();");
		out.println("	m.replyTo = replyTo;");
		out.println("	m.inReply = inReply;");
		out.println("");
		out.println("	return m;");
		out.println("");
		out.println("}");
		out.println("/**");
		out.println(" * This method was created in VisualAge.");
		out.println(" */");
		out.println("public abstract void run();");
		out.println("}");
		
		/* end of agent definition */

		out.close();
		if (debug)
			gui.write("Done with agent ... ");
	} catch (java.io.IOException e) {
		gui.write("** Error trying to open file " + outDirName + "Conversation.java ");
	}
}
/**
 * This method was created in VisualAge.
 */
public void genConversations(ATsystem sys) {
	ATagent a;
	ATconversation c;
	String outFileName = "";
	int i = 0;
	String[] param = null;
	ATtransition startTrans = null;
	ATtransition t;
	String stateName = "";
	String convClassName = "";
	gui = new MessageGUI("agentTool Code Generation ");
	gui.write("Starting code generation " + version);
	outDirName = gui.getSaveDirectory(outDirName);
	gui.write("Code generation directory is " + outDirName);

	/* start - generate abstract classes needed for Carolina */
	genBaseAgentCode();
	genConversationCode();
	
	/* generate code for each agent */
	Enumeration agentsEnum = sys.returnAgents();
	while (agentsEnum.hasMoreElements())
		genAgentCode((ATagent) agentsEnum.nextElement(), sys);

	/* enumerate each conversation */
	Enumeration convsEnum = sys.returnConvs();
	while (convsEnum.hasMoreElements()) {
		c = (ATconversation) convsEnum.nextElement();

		/* Generate code for Initiator & Respondent classes */
		for (int initResp = 1; initResp <= 2; initResp++) {
			/* initialize globals for each conversation side */
			combinedTypes = new Vector(3);
			initialVariables = new Vector(1);
			ATstatetable stInit = c.getStateTable(initResp);


			// create file for this half of the conversation
			try {
				/* define class specific names */
				String agentName = stInit.getParticipant().getName();
				String convName = c.getName();
				if (initResp == 1)
					convClassName = convName + "_" + agentName + "_I";
				else
					convClassName = convName + "_" + agentName + "_R";
				gui.write("generating code for conversation " + convClassName);
				File outFile = new File(outDirName, convClassName + ".java");
				FileOutputStream outFileStream = new FileOutputStream(outFile);
				PrintWriter out = new PrintWriter(outFileStream); //

				/* print file header info */
				out.println("/*");
				out.println("*");
				out.println("* Conversation class for " + convClassName + ".");
				out.println("*");
				out.println("* automatically generated by agentTool" + version);
				out.println("*");
				out.println("*/");
				out.println("import java.util.Date;");
				out.println("import java.util.*;"); 
				out.println("import java.net.*;");
				out.println("import java.io.*;");
				out.println("import carolina.*;");
				out.println("public class " + convClassName + " extends Conversation");
				out.println("{");
				out.println("	" + agentName + " parent; // override parent definition in Agent");
				out.println("	String responderName;");
				out.println("	String responderHost;");

				// find data types sent on 1st message
				Enumeration transEnum = stInit.returnTrans();
				while (transEnum.hasMoreElements()) {
					try {
						t = (ATtransition) transEnum.nextElement();
						if (t.getCurrentState().getName().equals("StartState"))
							startTrans = t;
					} catch (ClassCastException e) {
					}
				} //

				/* print out objects needed to hold initial message contents */
				param = parseInitialObjects(startTrans.getTransMessage());
				for (i = 0; i < param.length; i++) {
					out.println("	Object " + param[i] + ";");
					initialVariables.addElement(param[i]);
				}

				/* generate constuctor */
				/* initiator */
				if (initResp == 1) {
					out.println("\n/*");
					out.println("*");
					out.println("* Constructor for  " + convClassName + ".");
					out.println("*");
					out.println("* automatically generated by agentTool" + version);
					out.println("*");
					out.println("*/");
					out.print("public " + convClassName + "(" + agentName + " a, String n, String h");
					for (i = 0; i < param.length; i++)
						out.print(", Object " + param[i] + "_in");
					out.println(")");

					// constructor body
					out.println("{");
					out.println("	super(a);");
					out.println("	parent = a;");
					out.println("	responderName = n;");
					out.println("	responderHost = h;");

					// declare input variables
					out.println("\n	// save input variables to class attributes");
					for (i = 0; i < param.length; i++)
						out.println("	" + param[i] + " = " + param[i] + "_in ;");

					out.println("}");
				}
				
				/* responder */
				else {
					out.println("\n/*");
					out.println("*");
					out.println("* Constructor for  " + convClassName + ".");
					out.println("*");
					out.println("* automatically generated by agentTool" + version);
					out.println("*");
					out.println("*/");
					out.print("public " + convClassName + "(" + agentName + " a, Message m1, String c)");

					// constructor body
					out.println("{");
					out.println("	super(a, m1);");
					out.println("	parent = a;");
					out.println("  	convID = c;");
					out.println("}");
				}


				/* generate RUN method */
				localVariables = new Vector(3);
				printRunOpening(out, stInit, initResp);

				// RUN - conversation body 
				printConvBody(out, stInit, initResp);

				out.println("} /* end class */");
				out.close(); //

			} catch (java.io.IOException e) {
				gui.write("*** ERROR - cannot save to file:" + outDirName + outFileName);
				e.printStackTrace(System.out);
				return;
			}
		}
	}
	gui.write("Complete code generation.");
}
/**
 * This method was created in VisualAge.
 */
private void genConvState(PrintWriter out, ATstate state, ATstatetable stInit, int initResp) {
	ATtransition t;
	boolean receive;

	// print out simple state case
	out.println("\t\t\t\tcase " + state.getName() + " :");

	/* define actions in the state  */
	Vector v = (Vector) state.getActions();
	Enumeration actions = v.elements();
	while (actions.hasMoreElements()) {
		String[] vars = {};
		String var = "";
		String a = (String) actions.nextElement();
		if (!a.equals("")) {
			int eqLoc = a.indexOf('=');
			if (eqLoc >= 0) {
				out.print("\t\t\t\t\t");
				vars = parseTuple(a.substring(0, eqLoc));
				var = vars[0];
				for (int j = 1; j < vars.length; j++)
					var = var + "_" + vars[j];
				out.print(var);
				out.println(" = parent." + a.substring(eqLoc + 1, a.length()).trim() + ";");
			} else
				out.println("\t\t\t\t\tparent." + a + ";");
		}
		
		/* now decompose tuple into its parts */
		if (vars.length > 1)
			for (int j = 0; j < vars.length; j++)
				out.println("\t\t\t\t\t" + vars[j] + " = " + var + "." + vars[j] + ";");
	}



	/* goto next state */
	out.println("\t\t\t\t\tstate = " + state.getName() + "_out;");
	out.println("\t\t\t\t\tbreak;");


	/* begin case */
	out.println("\t\t\t\tcase " + state.getName() + "_out :");

	// step through transitions
	Enumeration te = stInit.returnTrans();
	boolean transmit = false;
	boolean received = false;
	while (te.hasMoreElements()) {
		t = (ATtransition) te.nextElement();
		if (t.getCurrentState().getName().equals(state.getName()))
		{
			if (!t.getTransMessage().equals("")) transmit = true;
			if (!t.getRecMessage().equals("")) received = true;
			
		}
	}
	boolean complexState = transmit && received;
	
	// step through transitions
	Enumeration transEnum = stInit.returnTrans();
	receive = false;
	while (transEnum.hasMoreElements()) {
		t = (ATtransition) transEnum.nextElement();
		if (t.getCurrentState().getName().equals(state.getName()))
			receive = genConvTrans(out, t, receive, initResp, complexState);
	}
	if (complexState)
	out.println("\t\t\t\t\tstate = "+state.getName()+";");
	out.println("\t\t\t\t\tbreak; ");
}
/**
 * This method was created in VisualAge.
 */
private boolean genConvTrans(PrintWriter out, ATtransition t, boolean receive, int initResp, boolean complexState) {
	String guard = t.getGuardCondition();
	guard = OCLtoJava(guard);
	if (debug) {
		//		gui.write("For transition " + t.getRecMessage() + "[" + guard + "]" + "/" + t.getActions() + "^" + t.getTransMessage());
		gui.write("    t.getTransMessage().equals(\"\") = " + !t.getTransMessage().equals(""));
		gui.write("  guard.equals(\"\") = " + guard.equals(""));
		gui.write("      t.getRecMessage().equals(\"\") = " + t.getRecMessage().equals(""));
	}

	// turn this off temporarily	
	//	if (t.getActions() != null)
	//		if (!t.getActions().equals("")) {
	//			gui.writeError("transition actions not supported by this transformation!");
	//			gui.write("\tfound transition " + t.getRecMessage() + " [" + guard + "] / " + t.getActions() + " ^ " + t.getTransMessage());
	//		}

	/* xmit - no guard - no receive */
	if ((!t.getTransMessage().equals("")) && (guard.equals("")) && (t.getRecMessage().equals(""))) {
		String[] actionTokens = parseAction(t.getTransMessage());
		if (actionTokens.length >= 0) {
			String content = combineSendParameters(out, actionTokens, 5);
			out.println("\t\t\t\t\tm = createMessageByID(\"" + actionTokens[0] + "\", ");
			out.println("\t\t\t\t\t                      " + content + ", ");
			if (initResp == 1)
				out.println("\t\t\t\t\t                      responderName, responderHost, ");
			else
				out.println("\t\t\t\t\t                      recipient, recipientLoc, ");
			out.println("\t\t\t\t\t                      parent.getLocalHostName().toUpperCase(), replyTo, inReply);");
			out.println("\t\t\t\t\tparent.sendMessage(m);");
			if (t.getNextState().getName().equals("EndState"))
				out.println("\t\t\t\t\t\tnotDone = false;");
			else
				out.println("\t\t\t\t\tstate = " + t.getNextState().getName() + ";");
		}
	}
	/* xmit - guard - no receive */
	if ((!t.getTransMessage().equals("")) && (!guard.equals("")) && (t.getRecMessage().equals(""))) {
		String[] actionTokens = parseAction(t.getTransMessage());
		if (actionTokens.length >= 0) {
			out.println("\t\t\t\t\tif (" + guard + ")");
			out.println("\t\t\t\t\t{");
			String content = combineSendParameters(out, actionTokens, 6);
			out.println("\t\t\t\t\t\tm = createMessageByID(\"" + actionTokens[0] + "\", ");
			out.println("\t\t\t\t\t\t                      " + content + ", ");
			if (initResp == 1)
				out.println("\t\t\t\t\t\t                      responderName, responderHost, ");
			else
				out.println("\t\t\t\t\t\t                      recipient, recipientLoc, ");
			out.println("\t\t\t\t\t\t                      parent.getLocalHostName().toUpperCase(), replyTo, inReply);");
			out.println("\t\t\t\t\t\tparent.sendMessage(m);");
			if (t.getNextState().getName().equals("EndState"))
				out.println("\t\t\t\t\t\tnotDone = false;");
			else
				out.println("\t\t\t\t\t\tstate = " + t.getNextState().getName() + ";");
			out.println("\t\t\t\t\t}");
		}
	}
	/* no xmit - no guard - no receive */
	if ((t.getTransMessage().equals("")) && (guard.equals("")) && (t.getRecMessage().equals(""))) {
		if (t.getNextState().getName().equals("EndState"))
			out.println("\t\t\t\t\tnotDone = false;");
		else
			out.println("\t\t\t\t\tstate = " + t.getNextState().getName() + ";");
	}
	/* no xmit - guard - no receive */
	if ((t.getTransMessage().equals("")) && (!guard.equals("")) && (t.getRecMessage().equals(""))) {
		out.println("\t\t\t\t\tif (" + guard + ")");
		if (t.getNextState().getName().equals("EndState"))
			out.println("\t\t\t\t\tnotDone = false;");
		else
			out.println("\t\t\t\t\tstate = " + t.getNextState().getName() + ";");
	}

	/* xmit - guard - receive */
	if ((!t.getTransMessage().equals("")) && (!guard.equals("")) && (!t.getRecMessage().equals(""))) {
		String[] actionTokens = parseAction(t.getTransMessage());
		if (actionTokens.length >= 0) {
			if (!receive && (initResp == 0 || !t.getCurrentState().getName().equals("StartState")))
				if (complexState)
					out.println("\t\t\t\t\tm = parent.nonblockedReadMessage(convID);");
				else
					out.println("\t\t\t\t\tm = parent.readMessage(convID);");
			String[] receiveTokens = parseAction(t.getRecMessage());
			if (actionTokens.length >= 0) {
				out.println("\t\t\t\t\tif (m.getPerformative().equals(\"" + receiveTokens[0] + "\") && (" + guard + "))");
				out.println("\t\t\t\t\t{");
				combineReceiveParameters(out, receiveTokens, 6);
				String content = combineSendParameters(out, actionTokens, 6);
				out.println("\t\t\t\t\t\tm = createMessageByID(\"" + actionTokens[0] + "\", ");
				out.println("\t\t\t\t\t\t                      " + content + ", ");
				if (initResp == 1)
					out.println("\t\t\t\t\t\t                      responderName, responderHost, ");
				else
					out.println("\t\t\t\t\t\t                      recipient, recipientLoc, ");
				out.println("\t\t\t\t\t\t                      parent.getLocalHostName().toUpperCase(), replyTo, inReply);");
				out.println("\t\t\t\t\t\tparent.sendMessage(m);");
				if (t.getNextState().getName().equals("EndState"))
					out.println("\t\t\t\t\t\tnotDone = false;");
				else
					out.println("\t\t\t\t\t\tstate = " + t.getNextState().getName() + ";");
				out.println("\t\t\t\t\t}");
			}
		}
	}
	/* no xmit - no guard - receive */
	if ((t.getTransMessage().equals("")) && (guard.equals("")) && (!t.getRecMessage().equals(""))) {
		if (!receive && (initResp == 1 || !t.getCurrentState().getName().equals("StartState")))
			if (complexState)
				out.println("\t\t\t\t\tm = parent.nonblockedReadMessage(convID);");
			else
				out.println("\t\t\t\t\tm = parent.readMessage(convID);");
		String[] receiveTokens = parseAction(t.getRecMessage());
		if (receiveTokens.length >= 0) {
			out.println("\t\t\t\t\tif (m.getPerformative().equals(\"" + receiveTokens[0] + "\"))");
			out.println("\t\t\t\t\t{");
			combineReceiveParameters(out, receiveTokens, 6);
			if (t.getNextState().getName().equals("EndState"))
				out.println("\t\t\t\t\t\tnotDone = false;");
			else
				out.println("\t\t\t\t\t\tstate = " + t.getNextState().getName() + ";");
			out.println("\t\t\t\t\t}");
		}
	}
	/* no xmit - guard - receive */
	if ((t.getTransMessage().equals("")) && (!guard.equals("")) && (!t.getRecMessage().equals(""))) {
		if (!receive && (initResp == 1 || !t.getCurrentState().getName().equals("StartState")))
			if (complexState)
				out.println("\t\t\t\t\tm = parent.nonblockedReadMessage(convID);");
			else
				out.println("\t\t\t\t\tm = parent.readMessage(convID);");
		String[] receiveTokens = parseAction(t.getRecMessage());
		if (receiveTokens.length >= 0) {
			out.println("\t\t\t\t\tif (m.getPerformative().equals(\"" + receiveTokens[0] + "\") && (" + guard + "))");
			out.println("\t\t\t\t\t{");
			combineReceiveParameters(out, receiveTokens, 6);
			if (t.getNextState().getName().equals("EndState"))
				out.println("\t\t\t\t\t\tnotDone = false;");
			else
				out.println("\t\t\t\t\t\tstate = " + t.getNextState().getName() + ";");
			out.println("\t\t\t\t\t}");
		}
	}
	if (t.getTransMessage().equals(""))
		receive = true;
	return receive;
}
/**
 * This method was created in VisualAge.
 * @param tokens java.lang.String[]
 *
 * tokens can represent either of the following strings:
 *  <x, ... y> = action(p1, .. pn)
 *  x = action(p1, .. pn)
 *  x = action()
 *  action(p1, .. pn)
 */

private int getFirstParamLocation(String[] tokens) {
	int firstParam = 1;

	/* find end of output tuples (<x, y, z> = action(param1 ... paramn)) 
	   ... if they exist */

	if (tokens.length > 1) {
		if (tokens[0] != null) {
			if (tokens[0].startsWith("<")) {
				for (int i = 1; i < tokens.length; i++)
					if (tokens[i].endsWith(">"))
						if (tokens[i + 1].equals("="))
							firstParam = i + 3;
						else
							firstParam = i + 2;
			}

			/* check for x = action(p1 .. pn) */
			else
				if (tokens[1].equals("="))
					firstParam = 3;
		}
	}
	return firstParam;
}
/**
 * This method was created in VisualAge.
 * @param tokens java.lang.String[]
 */
private String getParameterClassName(String[] tokens) {
	int i;
	String className = "";
	int firstParam = getFirstParamLocation(tokens);

	/* print tokens if in debug mode */
	if (debug) {
		for (i = 0; i < tokens.length; i++)
			gui.write("Token[" + i + "] = " + tokens[i]);
		gui.write("firstParam = " + firstParam);
	}

	/* determine name */
	if (tokens.length > firstParam + 1) {
		for (i = firstParam; i < tokens.length - 1; i++)
			className = className + tokens[i] + "_";
		className = className + tokens[tokens.length - 1] + "_Type";
	}
	return className;
}
/**
 * Insert the method's description here.
 * Creation date: (6/6/00 3:54:27 PM)
 * @return java.lang.String
 */
public String OCLtoJava(String s)
{
	int i;
	s = s.trim();
	while ((i = s.indexOf(" AND ")) >= 0)
	{
		s = new String(s.substring(0, i - 1) + " && " + s.substring(i + 5));
	}
	while ((i = s.indexOf(" OR ")) >= 0)
	{
		s = new String(s.substring(0, i - 1) + " || " + s.substring(i + 4));
	}
	while ((i = s.indexOf("NOT")) >= 0)
	{
		if (i == 0)
			s = new String("!" + s.substring(i + 3));
		else
			s = new String(s.substring(0, i - 1) + "!" + s.substring(i + 3));
	}
	return s;
}
/**
 * This method was created in VisualAge.
 *
 * This method parses with = as a delimter.
 */
private String[] parseAction(String s)
{
	String delimiters = "\n\t\r(,)= ";
	StringTokenizer tokens = new StringTokenizer(s, delimiters);
	if (tokens.countTokens() > 0)
	{
		if (debug) gui.write("Parsing the string |" + s + "|");
		String x[] = new String[tokens.countTokens()];
		int i = 0;
		while (tokens.hasMoreTokens())
		{
			x[i++] = tokens.nextToken();
			if (debug) gui.write("     Token " + (i-1) + " = " + x[i-1]);
		}

		/* return the vector of elements */
		return x;
	} else
		return new String[0];
}
/**
 * This method was created in VisualAge.
 *
 * This method parses WITHOUT using = as a delimter.
 */
private String[] parseAction2(String s)
{
	String delimiters = "\n\t\r(,) ";
	StringTokenizer tokens = new StringTokenizer(s, delimiters);
	if (tokens.countTokens() > 0)
	{
		if (debug) gui.write("Parsing the string |" + s + "|");
		String x[] = new String[tokens.countTokens()];
		int i = 0;
		while (tokens.hasMoreTokens())
		{
			x[i++] = tokens.nextToken();
			if (debug) gui.write("     Token " + (i-1) + " = " + x[i-1]);
		}

		/* return the vector of elements */
		return x;
	} else
		return new String[0];
}
/**
 * This method was created in VisualAge.
 * @return java.util.Vector
 * @param s java.lang.String
 */
private String[] parseInitialObjects(String s)
{
	String delimiters = "\n\t\r(,) ";
	StringTokenizer tokens = new StringTokenizer(s, delimiters);
	if (tokens.countTokens() > 1)
	{
		String x[] = new String[tokens.countTokens() - 1];

		/* store all tokens (except the first) in the array */
		String dummy = tokens.nextToken();
		int i = 0;
		while (tokens.hasMoreTokens())
			x[i++] = tokens.nextToken();

		/* return the vector of elements */
		return x;
	} else
		return new String[0];
}
/**
 * This method was created in VisualAge.
 *
 * This method parses tuple notation such as <x, y, z>
 */
private String[] parseTuple(String s)
{
	String delimiters = "\n\t\r<,>= ";
	StringTokenizer tokens = new StringTokenizer(s, delimiters);
	if (tokens.countTokens() > 0)
	{
		if (debug) gui.write("Parsing the string |" + s + "|");
		String x[] = new String[tokens.countTokens()];
		int i = 0;
		while (tokens.hasMoreTokens())
		{
			x[i++] = tokens.nextToken();
			if (debug) gui.write("     Token " + (i-1) + " = " + x[i-1]);
		}

		/* return the vector of elements */
		return x;
	} else
		return new String[0];
}
/**
 * This method was created in VisualAge.
 * @param out java.io.PrintWriter
 * @param stInit system.ATstatetable
 */
private void printConvBody(PrintWriter out, ATstatetable stInit, int initResp) {
	out.println("		while (notDone)");
	out.println("		{");
	out.println("			switch (state)");
	out.println("			{");

	// start with the start state first
	ATstate start = new ATstate(1,0);
	start.setName("StartState");
	start.setAction("");
	genConvState(out, start, stInit, initResp);

	// step through states
	Enumeration stateEnum = stInit.returnStates();
	while (stateEnum.hasMoreElements()) {
		try {
			genConvState(out, (ATstate) stateEnum.nextElement(), stInit, initResp);
		} catch (ClassCastException e) {
			// skip start and end states ???
		}
	}
	out.println("			}");
	out.println("		}");
	out.println("}");
}
/**
 * This method was created in VisualAge.
 * @param out java.io.PrintWriter
 */
private void printRunClosing(PrintWriter out, String classname)
{
	// print out closing code

	out.println("}");
}
/**
 * This method was created in VisualAge.
 * @param out java.io.PrintWriter
 */
private void printRunOpening(PrintWriter out, ATstatetable stInit, int initResp) {
	out.println("\n/*");
	out.println("*");
	out.println("* Conversation run method - controls conversation.");
	out.println("*");
	out.println("* automatically generated by agentTool" + version);
	out.println("*");
	out.println("*/");
	out.println("public void run()");
	out.println("{");
	out.println("	Message m = new Message();");
	if (initResp == 2) {
		out.println("	String replyTo = m.inReply;");
		out.println("	String inReply = m.replyTo;");
		out.println("	String recipient = m.getSenderID();");
		out.println("	String recipientLoc = m.realFromLocation;");
	}
	out.println("	int state = 0;");
	out.println("	boolean notDone = true;");

	/* add state constant definitions here ... */
	addStateConstants(out, stInit);

	/* add combined parameter definitions */
	out.println("\n\t/* combined parameter definitions */");
	Enumeration transEnum = stInit.returnTrans();
	while (transEnum.hasMoreElements()) {
		ATtransition t = ((ATtransition) transEnum.nextElement());
		addCombinedParams(out, parseAction2(t.getRecMessage()));
		addCombinedParams(out, parseAction2(t.getTransMessage()));
	}

	/* add variable declarations used in transitions */
	out.println("\n\t/* variables used in transitions */");
	transEnum = stInit.returnTrans();
	while (transEnum.hasMoreElements()) {
		ATtransition t = ((ATtransition) transEnum.nextElement());
		addVariableDeclarations(out, parseAction2(t.getRecMessage()));
		addVariableDeclarations(out, parseAction2(t.getTransMessage()));
		if (t.getRecMessage().indexOf('=') > 0) {
			String x[] = parseAction2(t.getRecMessage());
			if (x.length > 0)
				if (!x[0].equals("=")) {
					String var = ((x[0].replace('<', ' ')).replace('>', ' ')).trim();
					if (localVariables.indexOf(var) < 0) {
						out.println("\t" + "Object " + var + " = null;");
						localVariables.addElement(var);
					}
				}
		}
		if (t.getTransMessage().indexOf('=') > 0) {
			String x[] = parseAction2(t.getTransMessage());
			if (x.length > 0)
				if (!x[0].equals("=")) {
					String var = ((x[0].replace('<', ' ')).replace('>', ' ')).trim();
					if (localVariables.indexOf(var) < 0) {
						out.println("\t" + "Object " + var + " = null;");
						localVariables.addElement(var);
					}
				}
		}
	}

	/* add state action variable declarations */
	out.println("\n\t/* state variable declarations */");
	Enumeration stateEnum = stInit.returnStates();
	while (stateEnum.hasMoreElements()) {
		try {
			ATstate s = ((ATstate) stateEnum.nextElement());
			Vector v = (Vector) s.getActions();
			Enumeration actions = v.elements();
			while (actions.hasMoreElements()) {
				String a = (String) actions.nextElement();
				addVariableDeclarations(out, parseAction2(a));

				// add declaration for output parameters
				int eqLoc = a.indexOf('=');
				if (eqLoc >= 0) {
					String[] vars = parseTuple(a.substring(0, eqLoc));
					String var = vars[0];

					/* check individual variables */
					for (int j = 0; j < vars.length; j++)
						if (localVariables.indexOf(vars[j]) < 0) {
							out.println("\tObject " + vars[j] + " = null;");
							localVariables.addElement(vars[j]);
						}

						/* build composite name if multiple output values */
					if (vars.length > 1) {
						for (int j = 1; j < vars.length; j++)
							var = var + "_" + vars[j];
						if (localVariables.indexOf(var) < 0) {
							out.println("\t" + var + "_Type " + var + " = null;");
							localVariables.addElement(var);
						}
					}
				}
			}
		} catch (ClassCastException e) {
			// skip start and end states
		}
	}

	/* add startup stuff */
	out.println("");

	/* initiator only */
	if (initResp == 1) {
		out.println("\tDate date = new Date();");
		out.println("\tconvID = new Long(date.getTime()).toString();");
		out.println("\tString replyTo = convID;");
		out.println("\tString inReply = null;");
		out.println("");
	}
	out.println("	//set up conversation");
}
}
