package Editor;

/**
 * This is a Scroll Pane that contains an AgentPanel.
 * This class is used instead of seperate scrollpanes in the
 * ATeditor because the ATeditor has a vector of AgentPanels,
 * so it needs an infinate number of them, and all other scroll
 * panes in ATeditor are set.
 * Creation date: (12/16/99 10:35:11 AM)
 * @author: Jennifer Mifflin
  *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
public class ATcompScrollPane extends javax.swing.JScrollPane {
	//agent panel contained in this scrollpane
	private AgentPanel ivjarchPanel = null;
	//component that is the comp of the agentPanel
	private system.ATagentComponent comp;
	private system.ATagent agent;
	double version;
	
/**
 * ATcompScrollPane constructor comment.
 */
public ATcompScrollPane(double v) {
	super();
	version = v;
	initialize();


/*  Unused constructors.  I removed them in order to make changes to the 
	constructor that is actually used.

	public ATcompScrollPane(int vsbPolicy, int hsbPolicy, double v) {
		super(vsbPolicy, hsbPolicy);
		version = v;
	}

	public ATcompScrollPane(java.awt.Component view, int vsbPolicy, int hsbPolicy, double v) {
		super(view, vsbPolicy, hsbPolicy);
		version = v;
	}

	public ATcompScrollPane(java.awt.Component view, double v) {
		super(view);
		version = v;
	}
	
*/
}
/**
 * Return the archPanel property value.
 * @return Editor.AgentPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
 AgentPanel getarchPanel() {
	 //if there is no ivjarchPanel, create one, then return it-
	 //otherwise, just return it
	if (ivjarchPanel == null) {
		try {
			ivjarchPanel = new AgentPanel(version);
			ivjarchPanel.setName("archPanel");
			ivjarchPanel.setLocation(0, 0);
			ivjarchPanel.setBackground(java.awt.SystemColor.window);
			
			//ivjarchPanel.setAgent(agent);
			ivjarchPanel.setComp(comp);
			
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjarchPanel;
}
/**
 * Insert the method's description here.
 * Creation date: (1/11/00 10:05:14 AM)
 * @return system.ATagentComponent
 */
public system.ATagentComponent getComp() {
	//return the component
	return comp;
}
/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(java.lang.Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	// System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	// exception.printStackTrace(System.out);
}
/**
 * Initialize the class.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initialize() {
	//initialize the scorllpane
	try {
		setName("ATcompScrollPane");
		setSize(391, 292);
		setViewportView(getarchPanel());
	} catch (java.lang.Throwable ivjExc) {
		handleException(ivjExc);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (12/1/00 4:06:28 PM)
 */
public void setAgent(system.ATagent a) {
	this.agent = agent;
	getarchPanel().setAgent(agent);
}
/**
 * Insert the method's description here.
 * Creation date: (1/4/00 12:41:34 PM)
 * @param comp system.ATagentComponent
 */
public void setComp(system.ATagentComponent comp) {
	//set the component
	this.comp = comp;
	getarchPanel().setComp(comp);
}
}
