package Editor;

import java.util.*;
import agentBase.*;
import system.*;
import java.io.*;
/**
 * This type was created in VisualAge.
 * The main Window of agentTool.
 * @author: Jennifer Mifflin
  *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */

import java.awt.*;
import java.awt.print.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.Vector;
public class ATeditor extends JFrame 
implements ActionListener, KeyListener, MouseListener, MouseMotionListener, ChangeListener, Printable {

	private JPanel ivjATeditorPanel = null; //Main Panel
	private FrameLayout frameLayout = new FrameLayout();
	private JTabbedPane ivjATTabbedPane = null; //TabbedPane
	private JLabel ivjCurrentObjectLabel = null; //Label with Name of CurrentlySelectedObject
	private JTextField ivjCurrentObjectField = null; 

	//Buttons
	private JButton ivjButtonOne = null;
	private JButton ivjButtonTwo = null;
	private JButton ivjButtonThree = null;

	//Menus
	private JMenuBar ivjATeditorFrameJMenuBar = null;
	private JMenu ivjVerifyMenu = null;
	private JMenu ivjFileMenu = null;
	private JMenu ivjKBFiles = null;
	private JMenu ivjCodeGenMenu = null;
	private JMenu ivjTransformation = null;

	//Menu Items
	private JMenuItem ivjFileLoadSystem = null;
	private JMenuItem ivjFileSaveSystem = null;
	private JMenuItem ivjVerifySynch = null;
	private JMenuItem ivjVerifyAsynch = null;
	private JMenuItem ivjAgentMomGen = null;
	private JMenuItem ivjCarolinaGen = null;	
	private JMenuItem ivjStoreSystem = null;
	private JMenuItem ivjLoadSystem = null;
	private JMenuItem ivjStoreObject = null;
	private JMenuItem ivjLoadObject = null;
	private JMenuItem ivjStoreArchitecture = null;
	private JMenuItem ivjLoadArchitecture = null;
	private JMenuItem ivjClearSystem = null;
	private JMenuItem ivjClearPanel = null;
	private JMenuItem ivjExit = null;
	private JMenuItem ivjPrint = null;
	private JMenuItem ivjPrintpage = null;
	private JMenuItem ivjDataDictionary = null;
	private JMenuItem ivjAgentComponents = null;
	private JMenuItem ivjAnnotateCState = null;
	private JMenuItem ivjCreateConversions = null;
	private JMenuItem ivjCreateAgentComponent = null;
	private JMenuItem ivjAgentComponentMobility = null;
	private JMenuItem ivjComponentMobility = null;
	
	//TextArea that outputs what is needed from user or has been done by user (little yellow box)
	private TextArea ivjSysMsgArea = null;

	//various panels needed
	private AgentDiagramPanel ivjAgentDiagramPage = null;
	private ConversationPanel ivjInitiatorPage = null;
	private ConversationPanel ivjResponderPage = null;
	private ConversationPanel CompDiagram = null; //ComponentDiagram
	private ConversationPanel TaskDiagram = null;
	private AgentPanel agentPanel = null;
	private RolePanel ivjRolePanel = null;
	private GoalPanel ivjGoalPanel = null;
	private UseCasePanel ivjUseCasePanel = null;
	private SeqDiagPanel ivjSeqDiagPanel = null;
	private DeploymentPanel ivjDeploymentPanel = null;
	
	//currentPanel keeps track of which panel is currently being used
	private ATpanel currentPanel = null; 

	private int x,y; //used for position of mouse at various times
	
	protected ATsystem sys;  //The main storage system.  Keeps track of agents and conversations.

	private Transforms.TSystem tSystem = null;  //The transformation system.  Used in the transformation process.
	
	//keeps track if changes have been made since the last save
	private boolean change = false;
	
	//Used to keep track of which panels are presently up and may need to be removed
	//as well as which panels need to be added- currentlySelectedObject = object currenly selected in currentPanel
	private ATobject currentlySelectedObject = null,
				   lastSelectedObject = null,
				   lastSelectedAgent = null,
				   lastSelectedComp = null,
				   lastSelectedConv = null;

	//Keeps track of the last selected Agent
	private ATagent agent_last = null;

	//Current version number- needed for saving & restoring
	public static final String VERSION_NUMBER = "1.8";
	public static final double version = 1.8;
	
	private Vector ErrorVector = null;

	//each ScrollPane contains a panel
	private JScrollPane jscrollpane1; //AgentDiagram
	private JScrollPane jscrollpane2; //AgentPage
	private JScrollPane jscrollpane3; //InitiatorPage
	private JScrollPane jscrollpane4; //ResponderPage
	private JScrollPane jscrollpane5; //ComponentDiagramPage
	private JScrollPane jscrollpane6; //Role Diagram
	private JScrollPane jscrollpane7; //Task Diagram
	private JScrollPane jscrollpane8; //Goal Diagram
	private JScrollPane jscrollpane9; //Use Case Panel
	private JScrollPane jscrollpane10; //Seq Diag Panel
	private JScrollPane jscrollpane11; //Deployment Panel

	//a vector of ATcompScrollPanes
	//Builds as user goes deeper into defining componet's architectures
	//if user goes back, the vector deletes the ATcompScrollPanes after the selected ATcompScrollPane
	private Vector archVector = null;

	private boolean inPanel = false;

	//used in printing
	private int c[];
	Image printImage;

	
	
	class FocusListener1 extends FocusAdapter{
		public void focusGained(FocusEvent e){
			repaint();
		}
		public void focusLost(FocusEvent e){
		}
	}
/**
 * Constructor
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public ATeditor() {
	super();
	initialize();
}
/**
 * ATeditor constructor comment.
 * @param title java.lang.String
 */
public ATeditor(String title) {
	super(title);
}
/**
 * Method to handle events for the ActionListener interface.
 * @param e java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public void actionPerformed(java.awt.event.ActionEvent e)
{
	if ((e.getSource() == getButtonOne()))		//if Button One
	{
		change = true;
		if (getATTabbedPane().getSelectedComponent() == getScrollPane1()) //if CurrentPanel = AgentDiagramPage
		{
			addAgentPushed(e);  //Add an agent
		}else if (getATTabbedPane().getSelectedComponent() == getScrollPane6()){
			addRole();
		}
		else if ((getATTabbedPane().getSelectedComponent() == getScrollPane3()) //CurrentPanel = InitiatorPage
				|| (getATTabbedPane().getSelectedComponent() == getScrollPane4()) //CurrentPanel = ResponderPage
				|| (getATTabbedPane().getSelectedComponent() == getScrollPane5()) //CurrentPanel = CompDiag
				|| (getATTabbedPane().getSelectedComponent() == getScrollPane7()))
		{
			addConvStatePushed(e);
		} else if (getATTabbedPane().getSelectedComponent() == getScrollPane8()){
			 addGoal();
		} else if (getATTabbedPane().getSelectedComponent() == getScrollPane9()){
			 addUseCase();
		} else if (getATTabbedPane().getSelectedComponent() == getScrollPane10()){
			 addRole2seqDiag();
		} else if (getATTabbedPane().getSelectedComponent() == getScrollPane11()){
			 addAgent2Deployment();
		} else //Current Panel = architecture of some component
		{
			Enumeration archs = archVector.elements();
			ATcompScrollPane next;
			//find which componet-architecture = CurrentPanel 
			while (archs.hasMoreElements()){
				next = (ATcompScrollPane)archs.nextElement();
				if(getATTabbedPane().getSelectedComponent() instanceof Editor.ATcompScrollPane){
					if((ATcompScrollPane)(getATTabbedPane().getSelectedComponent())==next){
						currentPanel = next.getarchPanel();								
					}
				}
			}
			addComponentPushed(e);//add a Component to that architecture
		}
	}
	else if ((e.getSource() == getButtonTwo())) //if Button Two
	{
		change = true;
		if (getATTabbedPane().getSelectedComponent() == getScrollPane1())//CurrentPanel = AgentDiagramPage
		{
			addConvPushed(e); //Add a conversation
		} else if (((getATTabbedPane().getSelectedComponent()) == (getScrollPane3()))||
				   ((getATTabbedPane().getSelectedComponent()) == (getScrollPane4()))||
				   ((getATTabbedPane().getSelectedComponent()) == (getScrollPane5()))||
				   ((getATTabbedPane().getSelectedComponent()) == (getScrollPane7()))){//CurrentPanel = InitiatorPage
			addConvTransitionPushed(); //Add Trasition
		} else if (getATTabbedPane().getSelectedComponent() == getScrollPane2()){//CurrentPanel = AgentPage
			addConnPushed(e); //Add a Connection 
		} else if(getATTabbedPane().getSelectedComponent() == getScrollPane6()){
			addTask();
		} else if(getATTabbedPane().getSelectedComponent() == getScrollPane9()){
			deleteUseCase();
		} else if(getATTabbedPane().getSelectedComponent() == getScrollPane10()){
			addMessage();
		} else if(getATTabbedPane().getSelectedComponent() == getScrollPane11()){
			getDeploymentPanel().beginAddConv();
		} else{  //Component's Architecture is selected
			addConnPushed(e); 
		} 
	} else if ((e.getSource() == getButtonThree())) //if Button Three
	{ 
		if(getATTabbedPane().getSelectedComponent() == getScrollPane6()){
			getRolePanel().addProtocol(sys.getProtocolCount() + 1);/*nextProtNumber*/
			//nextProtNumber++;
		} else if(getATTabbedPane().getSelectedComponent() == getScrollPane11()){
			addSystem();
		}
	}
	else if (e.getSource() == getVerifySynch())
	{
		verifyConversationsSynch();
	}
	else if (e.getSource() == getVerifyAsynch())
	{
		AsynchWindow AW = new AsynchWindow(sys);
		AW.setSysMsgArea(ivjSysMsgArea);
		AW.show();
	}
	else if (e.getSource() == getFileLoadSystem())
	{
		//loadFile();
	//	getUseCasePanel().setList2Empty();
/*		ivjUseCasePanel = new UseCasePanel(getSeqDiagPanel());
		jscrollpane9 = null;
		getScrollPane9();
		*/loadMAML();
	}
	else if (e.getSource() == getFileSaveSystem())
	{
		//saveFile();
		saveMAML();
		change = false;
	}
	else if (e.getSource() == getDataDictionary()){
		saveDataDict();
	}
	else if (e.getSource() == getStoreSystem())
	{
		sysMsg("System Store Engaging");
		ConnectionAgent CAgent =  new ConnectionAgent("connectionAgent", 3001);
		System.out.println(" ** Agent name now is : " +  CAgent.name);
		System.out.println(" ** Agent port now is : " +  CAgent.port);
 		CAgent.run();
		CAgent.store(sys);
		change = false;

	}
	else if (e.getSource() == getStoreObject())
	{
		sysMsg("Object Store Engaging");
		//ATconversation AC = new ATconversation(version);
		ConnectionAgent CAgent =  new ConnectionAgent("connectionAgent", 3001);
		System.out.println(" ** Agent name now is : " +  CAgent.name);
		System.out.println(" ** Agent port now is : " +  CAgent.port);
 		CAgent.run();
		CAgent.store(getSelected());		
	}
	else if (e.getSource() == getLoadSystem())
	{
		sysMsg("System Restore Engaging");
		ConnectionAgent CAgent =  new ConnectionAgent("connectionAgent", 3000);
		System.out.println(" ** Agent name now is : " +  CAgent.name);
		System.out.println(" ** Agent port now is : " +  CAgent.port);
 		CAgent.run();
 		CAgent.load(sys, this);
	}
	else if (e.getSource() == getLoadObject())
	{
		sysMsg("Object Restore Engaging");
		//ATconversation AC = new ATconversation();
		ConnectionAgent CAgent =  new ConnectionAgent("connectionAgent", 3000);
		System.out.println(" ** Agent name now is : " +  CAgent.name);
		System.out.println(" ** Agent port now is : " +  CAgent.port);
 		CAgent.run();
 		CAgent.load(getSelected(), this);
	}
	else if (e.getSource() == getStoreArchitecture())
	{
		sysMsg("Architecture Store Engaging");
		ConnectionAgent CAgent =  new ConnectionAgent("connectionAgent", 3001);
		System.out.println(" ** Agent name now is : " +  CAgent.name);
		System.out.println(" ** Agent port now is : " +  CAgent.port);
		if (getSelected() instanceof system.ATagent)
		{
 		  CAgent.run();
		  CAgent.store((ATarchitecture)(((ATagent)getSelected()).getArchitecture()));
		}
	}
	else if (e.getSource() == getLoadArchitecture())
	{
		sysMsg("Architecture Load Engaging");
		//ATconversation AC = new ATconversation();
		ConnectionAgent CAgent =  new ConnectionAgent("connectionAgent", 3000);
		System.out.println(" ** Agent name now is : " +  CAgent.name);
		System.out.println(" ** Agent port now is : " +  CAgent.port);
		if (getSelected() instanceof system.ATagent)
		{	
 		  CAgent.run();
 		  CAgent.load((ATarchitecture)(((ATagent)getSelected()).getArchitecture()), this);
		}  
	}
	else if (e.getSource() == getagentMomGen())
	{
//		this.generateCode();
		CodeGen.AgentMom codeGenerator = new CodeGen.AgentMom();
		codeGenerator.genConversations(sys);
	}
	else if (e.getSource() == getCarolinaGen())
	{
//		this.generateCode();
		CodeGen.Carolina codeGenerator = new CodeGen.Carolina();
		codeGenerator.genConversations(sys);
	}
	else if (e.getSource() == getClearSystem()){
		sys = new system.ATsystem(version);
		ATseqDiag sD = null;
		removeAllArchs();
		removeTabsFrom(1);
		getGoalPanel().GoalNum = 0;
		getGoalPanel().setSys(sys);
		getSeqDiagPanel().setSeqDiag(sD);
		ivjUseCasePanel = new UseCasePanel(getSeqDiagPanel(), version);
		jscrollpane9 = null;
		ivjATTabbedPane.addTab("Use Cases", getScrollPane9());
		ivjATTabbedPane.addTab("Seq Diagram", getScrollPane10());
		ivjATTabbedPane.addTab("Role Diagram", getScrollPane6());
		ivjATTabbedPane.addTab("Agent Diagram", getScrollPane1());
		ivjATTabbedPane.addTab("Deployment", getScrollPane11());
		ivjATTabbedPane.setSelectedIndex(0);
		//nextAgentNumber = 1;
		//nextCompNumber = 1;
		//nextConvNumber = 1;
		//nextProtNumber = 1;
		//nextRoleNumber = 1;
		//nextStateNumber = 1;
		//nextTaskNumber = 1;
		//nextTransNumber = 1;
		change = false;
		tSystem = null;
	}
	else if (e.getSource() == getClearPanel()){
		java.util.Enumeration enum;
		//these 6 panels have child panels that must be dealt with before the parent
		if(currentPanel == ivjGoalPanel) {
			if(ivjRolePanel != null) {
				enum = sys.returnRoles();
				while(enum.hasMoreElements()) {
					ATRole role = (ATRole)enum.nextElement();
					role.clearGoals();
				}
			}
			ivjGoalPanel.clear(sys);
		}
		else if(currentPanel == ivjUseCasePanel) {
		//	if(ivjSeqDiagPanel != null) {
				//enum = ivjUseCasePanel.returnUseCases();
			//	while(enum.hasMoreElements()) {
				//	ivjSeqDiagPanel.clear();
			//	}
			//}
			//cycle through useCases
				//cycle through seqDiags
					//delete seq diags
			//delete useCases
			//if(ivjSeqDiagPanel != null) {
			//	ivjSeqDiagPanel.clear();
		//	}
		//	ivjUseCasePanel.clear(); //needs to be written
		}
		else if(currentPanel == ivjRolePanel) {
			if(TaskDiagram  != null) {
				TaskDiagram.clear();
				removeTabsFrom(4);
				ivjATTabbedPane.addTab("Agent Diagram", getScrollPane1());
				ivjATTabbedPane.addTab("Deployment", getScrollPane11());
			}
			ivjRolePanel.clear(sys);
		}
		else if(currentPanel == ivjAgentDiagramPage) {
			if(ivjDeploymentPanel != null) {
				ivjDeploymentPanel.clear();
				//deployment.clear needs work gets rid of agent diagram panel
			}
			//check for convinit, convresp
			if(ivjInitiatorPage != null) {//if the initiator page is there so is the responder
				ivjInitiatorPage.clear();
				ivjResponderPage.clear();
				//remove their tabs
			}
			//check for agentpanel
			if(agentPanel != null) {
				if(CompDiagram != null) { 
					CompDiagram.clear();
					//remove it's tab
				}
				agentPanel.clear();
				//remove it's tab
			}
			currentPanel.clear();
		}
		else if(currentPanel == agentPanel) {
		//check for subarchitecture; delete it if it exist(recursive?)
		//go through all components and clear their statDiagrams
			if(CompDiagram != null) {
				CompDiagram.clear();
				if(TaskDiagram == null) removeTabsFrom(6);
				else removeTabsFrom(7);
				ivjATTabbedPane.addTab("Deployment", getScrollPane11());
			}
			agentPanel.clear();
		}
		//all other panels can just be cleared since they do not have dependencies elsewhere
		else {
			currentPanel.clear();
		}

		
		//old code start
		/*	if( (currentPanel == ivjAgentDiagramPage) || (currentPanel == getRolePanel()) ){
			sys = new system.ATsystem(version);
//			removeTabsFrom(2);
			ivjATTabbedPane = null;
			initialize();
			nextAgentNumber = 1;
			nextConvNumber = 1;
			nextStateNumber = 1;
			nextTransNumber = 1;
			nextRoleNumber = 1;
			change = false;
		}
		else{
			int index = getATTabbedPane().getSelectedIndex();
			currentPanel.clear();
			if(currentPanel.getClass().getName().equals("Editor.AgentPanel")){
				removeTabsFrom(index+1);
			}
		}*///old code end		
	}
	else if (e.getSource() == getExit()){
		if(change == true){
			ExitWindow win = new ExitWindow();
			win.show();
			System.out.println("save first");
		} else {
			this.dispose();
			System.exit(0);
		}
	}
	else if(e.getSource() == getPrint() || e.getSource() == getPrintpage()){
		if(e.getSource() == getPrintpage()) { currentPanel.fullsize = false; }

		PrinterJob job = PrinterJob.getPrinterJob();
		job.setPrintable(this);
		
		c = currentPanel.getPages();
		printImage = currentPanel.formPrintImage();

		//ScaledPrint sp = new ScaledPrint(currentPanel, printImage);
		//sp.show();
		
		if(job.printDialog()){
			try{
				job.print();
			}
			catch(Exception k){
				System.out.println("ERROR in Printing");
			}
	 	}
		currentPanel.fullsize = true;
	}

	else if(e.getSource() == getAgComp()) {
		Transforms.Stage1 s1;
		tSystem = new Transforms.TSystem(sys, this, version);
		s1 = new Transforms.Stage1(tSystem);
	}
	else if(e.getSource() == getAnCState()) {
		Transforms.Stage1 s1;
		Transforms.Stage2 s2;
		if(tSystem == null)
			tSystem = new Transforms.TSystem(sys, this, version);
		if(!tSystem.phaseOneStarted)
			s1 = new Transforms.Stage1(tSystem);
		s2 = new Transforms.Stage2(tSystem);
	}
	else if(e.getSource() == getCrConv()) {
		Transforms.Stage1 s1;
		Transforms.Stage2 s2;
		Transforms.Stage3 s3;
		if(tSystem == null)
			tSystem = new Transforms.TSystem(sys, this, version);
		if(!tSystem.phaseOneStarted)
			s1 = new Transforms.Stage1(tSystem);
		if(!tSystem.phaseTwoStarted)
			s2 = new Transforms.Stage2(tSystem);
		s3 = new Transforms.Stage3(tSystem);
	}
	else if(e.getSource() == getCreateAgentComponent()) {
		
		Transforms.ACTransform1 act1;		
		tSystem = new Transforms.TSystem(sys, this, version);
		act1 = new Transforms.ACTransform1(tSystem);

		Transforms.ACTransform2 act2;
		tSystem = new Transforms.TSystem(sys, this, version);
		act2 = new Transforms.ACTransform2(tSystem);

		Transforms.ACTransform3 act3;
		tSystem = new Transforms.TSystem(sys, this, version);
		act3 = new Transforms.ACTransform3(tSystem);

		Transforms.ACTransform4 act4;
		tSystem = new Transforms.TSystem(sys, this, version);
		act4 = new Transforms.ACTransform4(tSystem);

		Transforms.ACTransform5 act5;
		tSystem = new Transforms.TSystem(sys, this, version);
		act5 = new Transforms.ACTransform5(tSystem);

		Transforms.ACTransform6 act6;
		tSystem = new Transforms.TSystem(sys, this, version);
		act6 = new Transforms.ACTransform6(tSystem);

		Transforms.ACTransform7 act7;
		tSystem = new Transforms.TSystem(sys, this, version);
		act7 = new Transforms.ACTransform7(tSystem);

		Transforms.ACTransform8 act8;
		tSystem = new Transforms.TSystem(sys, this, version);
		act8 = new Transforms.ACTransform8(tSystem);
		
		Transforms.ACTransform9 act9;
		tSystem = new Transforms.TSystem(sys, this, version);
		act9 = new Transforms.ACTransform9(tSystem);
		
	} else if(e.getSource() == getAgentComponentMobility()) {

		Transforms.ACMTransform1 acmt1;
		tSystem = new Transforms.TSystem(sys, this, version);
		acmt1 = new Transforms.ACMTransform1(tSystem);		

		Transforms.ACMTransform2 acmt2;
		tSystem = new Transforms.TSystem(sys, this, version);
		acmt2 = new Transforms.ACMTransform2(tSystem);		

		Transforms.ACMTransform3 acmt3;
		tSystem = new Transforms.TSystem(sys, this, version);
		acmt3 = new Transforms.ACMTransform3(tSystem);		
		
		Transforms.ACMTransform4 acmt4;
		tSystem = new Transforms.TSystem(sys, this, version);
		acmt4 = new Transforms.ACMTransform4(tSystem);		
		
		Transforms.ACMTransform5 acmt5;
		tSystem = new Transforms.TSystem(sys, this, version);
		acmt5 = new Transforms.ACMTransform5(tSystem);		
		
		Transforms.ACMTransform6 acmt6;
		tSystem = new Transforms.TSystem(sys, this, version);
		acmt6 = new Transforms.ACMTransform6(tSystem);		
		
	} else if(e.getSource() == getComponentMobility()) {
		
		Transforms.CMTransform1 cmt1;
		tSystem = new Transforms.TSystem(sys, this, version);
		cmt1 = new Transforms.CMTransform1(tSystem);
		
		Transforms.CMTransform2 cmt2;
		tSystem = new Transforms.TSystem(sys, this, version);
		cmt2 = new Transforms.CMTransform2(tSystem);
		
		Transforms.CMTransform3 cmt3;
		tSystem = new Transforms.TSystem(sys, this, version);
		cmt3 = new Transforms.CMTransform3(tSystem);

		Transforms.CMTransform4 cmt4;
		tSystem = new Transforms.TSystem(sys, this, version);
		cmt4 = new Transforms.CMTransform4(tSystem);

		Transforms.CMTransform5 cmt5;
		tSystem = new Transforms.TSystem(sys, this, version);
		cmt5 = new Transforms.CMTransform5(tSystem);

		Transforms.CMTransform6 cmt6;
		tSystem = new Transforms.TSystem(sys, this, version);
		cmt6 = new Transforms.CMTransform6(tSystem);

		Transforms.CMTransform7 cmt7;
		tSystem = new Transforms.TSystem(sys, this, version);
		cmt7 = new Transforms.CMTransform7(tSystem);
		
		Transforms.CMTransform8 cmt8;
		tSystem = new Transforms.TSystem(sys, this, version);
		cmt8 = new Transforms.CMTransform8(tSystem);
		
		Transforms.CMTransform9 cmt9;
		tSystem = new Transforms.TSystem(sys, this, version);
		cmt9 = new Transforms.CMTransform9(tSystem);
		
		Transforms.CMTransform10ComponentSelection cmt10cs;
		tSystem = new Transforms.TSystem(sys, this, version);
		cmt10cs = new Transforms.CMTransform10ComponentSelection(tSystem);

		Transforms.CMTransform11 cmt11;
		tSystem = new Transforms.TSystem(sys, this, version);
		cmt11 = new Transforms.CMTransform11(tSystem);
		
	}

	
	String command = e.getActionCommand();
	int x = getATTabbedPane().getSelectedIndex();
	if (x == 0)
	{
		currentPanel = getGoalPanel();
	}
}
/**
 * This method was created in VisualAge.
 */
public void addAgent() {

	int nextAgentNumber = sys.getAgentCount() + 1;
	system.ATagent a = new system.ATagent(version,sys.getNextKey()); //new Agent
	a.setName("Agent" + nextAgentNumber);
	a.setCoordinates(50 + ((nextAgentNumber-2) % 10)* 75,50 + ((nextAgentNumber-2) / 10)* 75,50,50);
	
	((AgentDiagramPanel)currentPanel).stopConvAdd();
	sys.addAgent(a); //Add Agent to System.
	
	repaint();

	sysMsg("Agent Template added");  //Tell user agent was added
	return;
}
/**
 * Insert the method's description here.
 * Creation date: (6/16/00 10:52:47 AM)
 */
public void addAgent2Deployment() {
	SelectAgent selectAgent = new SelectAgent(sys.returnAgentsVector(), sys, version);
	selectAgent.requestFocus();
	selectAgent.show();
	repaint();

}
/**
 * connEtoC1:  (SendButton.action.actionPerformed(java.awt.event.ActionEvent) --> Tester1.sendButton_ActionPerformed(Ljava.awt.event.ActionEvent;)V)
 * @param arg1 java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void addAgentPushed(java.awt.event.ActionEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.addAgent();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		System.out.println(ivjExc);		
		// user code end
		handleException(ivjExc);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (12/16/99 10:41:48 AM)
 */
 /*add another architecture panel to the vector, so it can be referenced*/
public ATcompScrollPane addArch() {
//	ATcompScrollPane New = new ATcompScrollPane(agent_last,version);

	ATcompScrollPane New = new ATcompScrollPane(version); 
	archVector.addElement(New);
	//Initialize new ATcompScrollPane
	New.setComp((system.ATagentComponent)currentlySelectedObject);
	New.getarchPanel().addMouseListener(this);
	New.getarchPanel().addMouseMotionListener(this);
	New.getarchPanel().setSysMsgArea(getSysMsgArea());
	return New;
}
public void addComponent(system.ATagent a) {
	//add a componenet
	int nextCompNumber = a.getComponentCount() + 1;

	String cname = "Generic " + Integer.toString(nextCompNumber);
	int i=nextCompNumber;
	while(a.repeatName(cname)) {
		cname = "Generic " + Integer.toString(++i);
	}
	
	((AgentPanel)currentPanel).addComponent(nextCompNumber,cname);
	
	repaint();
	
	//nextCompNumber++;
	//tell user
	
	sysMsg("Component added");
	return;
}
//add component to agent
private void addComponentPushed(java.awt.event.ActionEvent arg1) {
	try {
		system.ATagent a;
		//get selected agent
		a = agentPanel.getAgent();
		//add component to agent a
		addComponent(a);
	} catch (java.lang.Throwable ivjExc) {
		System.out.println(ivjExc);		
		handleException(ivjExc);
	}
}
/**
 * This method was created in VisualAge.
 */
public void addConn() {
	
	//there must be at least one component to be able to add a connection
	if (agent_last.getComponentCount() > 0) {
		sysMsg("Adding Connection");
		system.ATconnection c = new system.ATconnection(version, sys.getNextKey());
		((AgentPanel)currentPanel).startConnAdd(c);

	} else {//if No Components Exist
		sysMsg("Must add a Component first");
	}	
}
private void addConnPushed(java.awt.event.ActionEvent arg1) {
	try {
		this.addConn();
	} catch (java.lang.Throwable ivjExc) {
		System.out.println(ivjExc);		
		handleException(ivjExc);
	}
}
/**
 * This method was created in VisualAge.
 */
public void addConv() {

	//there must be at least one agent to be able to add a conversation
	if (sys.getAgentCount() > 0) {
		sysMsg("Adding Conversation");
		system.ATconversation c = new system.ATconversation(version,sys.getNextKey());
		((AgentDiagramPanel)currentPanel).startConvAdd(c);

		sys.addConvs(c);
		c.setName("Conv" + sys.getConvCount() + 1);
	} else {
		sysMsg("Must add an agent first");
	}	
}
private void addConvPushed(java.awt.event.ActionEvent arg1) {
	try {
		this.addConv();
	} catch (java.lang.Throwable ivjExc) {
		System.out.println(ivjExc);		
		handleException(ivjExc);
	}
}
/**
 * connEtoC1:  (SendButton.action.actionPerformed(java.awt.event.ActionEvent) --> Tester1.sendButton_ActionPerformed(Ljava.awt.event.ActionEvent;)V)
 * @param arg1 java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void addConvStatePushed(java.awt.event.ActionEvent arg1) {
	try {
		
		ATstate s = new ATstate(version,sys.getNextKey());
		//initialize state's Name, Action, and Placement
		int nextStateNumber = ((ConversationPanel)currentPanel).getStateCount() + 1;
		s.setName("State" + nextStateNumber);
		s.setAction("");
		s.setCoordinates(50 + ((nextStateNumber-2) % 10)* 75,50 + ((nextStateNumber-2) / 10)* 75,50,50);

		((ConversationPanel)currentPanel).addState(s);
		
		repaint();
/*		
		if(getATTabbedPane().getSelectedComponent() == getScrollPane3()){

			addConvState(getAgentDiagramPage().conv, afit.system.ATsystem.INITIATOR);			
		} else if(getATTabbedPane().getSelectedComponent() == getScrollPane4()){

			addConvState(getAgentDiagramPage().conv, system.ATsystem.RESPONDER);				
		} else if(getATTabbedPane().getSelectedComponent() == getScrollPane5()){
			addConvState((ATagentComponent)(currentlySelectedObject));//getAgentPage().getSelectedObject()));
		} else if(getATTabbedPane().getSelectedComponent() == getScrollPane7()){
			addConvState((ATTask)(currentlySelectedObject));
		}*/
	} catch (java.lang.Throwable ivjExc) {
		System.out.println(ivjExc);
		handleException(ivjExc);
	}
}
private void addConvTransitionPushed() {
	try {
		sysMsg("adding Transition");
		system.ATtransition t = new system.ATtransition(version,sys.getNextKey());
		((ConversationPanel)currentPanel).startTransAdd(t);
	} catch (java.lang.Throwable ivjExc) {
		System.out.println(ivjExc);		
		handleException(ivjExc);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (11/2/00 3:27:37 PM)
 */
public void addGoal() {
	ATGoal g = new ATGoal(version,sys.getNextKey());
	g.setCoordinates(400,50,50,50);
	getGoalPanel().addGoal(g, sys);
	repaint();
}
/**
 * Insert the method's description here.
 * Creation date: (6/19/00 11:55:38 AM)
 */
public void addMessage() {
	if(getSeqDiagPanel().seqDiag == null){
		sysMsg("select Sequence Diagram from Use Cases Panel\n");
	} else {
		getSeqDiagPanel().addMessage();
	}
}
/**
 * This method was created in VisualAge.
 */
public void addRole() {

	system.ATRole r = new system.ATRole(version,sys.getNextKey()); //new Agent
	int nextRoleNumber = sys.getRoleCount() + 1;
	r.setName("Role" + nextRoleNumber);
	r.setCoordinates(50 + ((nextRoleNumber-1) % 10)* 75,50 + ((nextRoleNumber-1) / 10)* 75,50,50);
	
	getSeqDiagPanel().cancelAddMessage();
	sys.addRole(r); //Add Agent to System.
	repaint();

	sysMsg("Role added");  //Tell user agent was added
	return;
}
/**
 * Insert the method's description here.
 * Creation date: (6/16/00 10:52:47 AM)
 */
public void addRole2seqDiag() {
	if(getSeqDiagPanel().seqDiag == null){
		sysMsg("select Sequence Diagram from Use Cases Panel\n");
	} else {
		SelectRole selectRole = new SelectRole(getSeqDiagPanel(), sys, version);
//	compDialog.setComp(selectedComponent);
		selectRole.requestFocus();
		selectRole.show();
	}
	//nextRole2Number++;
}
/**
 * Insert the method's description here.
 * Creation date: (7/12/00 4:07:39 PM)
 */
public void addSystem() {
	int nextSystemNumber = sys.getSystemCount() + 1;	
	
	String name = "System " + nextSystemNumber;
	ATsys system = new ATsys(version,sys.getNextKey());
	system.setName(name);
	getDeploymentPanel().addSystem(system);
//	System.out.println("added System : " + name);
	}
/**
 * This method was created in VisualAge.
 */
public void addTask() {

	ATTask t = new ATTask(version,sys.getNextKey()); //new Agent
//	sys.addTask(t);
	int nextTaskNumber = sys.getTaskCount() + 1;
	t.setName("Task" + nextTaskNumber);
	t.setCoordinates(50,50,50,50);
	
	getRolePanel().addTask(t); //Add Agent to System.
	repaint();
	return;
}
/**
 * Insert the method's description here.
 * Creation date: (6/14/00 9:30:42 AM)
 */
public void addUseCase() {
	ATuseCase uC = new ATuseCase(version,sys.getNextKey());
	int nextUseCaseNumber = sys.getUseCaseCount() + 1;
	uC.setName("Use Case " + nextUseCaseNumber);
//	getUseCasePanel().addUseCase(uC);
	sys.addUseCase(uC);
	getUseCasePanel().setUseCases(sys.getUseCasesVector());
	}
/**
 * Insert the method's description here.
 * Creation date: (11/2/00 2:13:51 PM)
 */
public void cancelAllOps() {
	
	if(ivjGoalPanel != null) ivjGoalPanel.cancelAddGoal();
	if(agentPanel != null) agentPanel.stopConnAdd();
	if(ivjRolePanel != null) {
		ivjRolePanel.cancelAddTask();
		ivjRolePanel.cancelAddProtocol();
	}
	if(ivjSeqDiagPanel != null) ivjSeqDiagPanel.cancelAddMessage();

	if(TaskDiagram != null) TaskDiagram.stopTransAdd();
	if(ivjInitiatorPage != null) ivjInitiatorPage.stopTransAdd();
	if(ivjResponderPage != null) ivjResponderPage.stopTransAdd();
	if(CompDiagram != null) CompDiagram.stopTransAdd();
	
	if(ivjAgentDiagramPage != null) ivjAgentDiagramPage.stopConvAdd();
	
	//if(ivjDeploymentPanel != null) ;
		
}
/**
 * connEtoC1:  (JPanel1.mouse.mousePressed(java.awt.event.MouseEvent) --> ThisIsIt.jPanel1_MousePressed(Ljava.awt.event.MouseEvent;)V)
 * @param arg1 java.awt.event.MouseEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connMouseDown() {
	try {
		if(inPanel){
			currentPanel.mouseDown(x,y,sys);// user code begin {2}
	//		updateSelectedObject();
		}
	} catch (java.lang.Throwable ivjExc) {
		handleException(ivjExc);
	}
}
/**
 * connEtoC1:  (JPanel1.mouse.mousePressed(java.awt.event.MouseEvent) --> ThisIsIt.jPanel1_MousePressed(Ljava.awt.event.MouseEvent;)V)
 * @param arg1 java.awt.event.MouseEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connMouseDragged() {
	try {
		currentPanel.mouseDrag(x,y,sys);// user code begin {2}
		change = true;
	} catch (java.lang.Throwable ivjExc) {
		handleException(ivjExc);
	}
}
/**
 * connEtoC1:  (JPanel1.mouse.mousePressed(java.awt.event.MouseEvent) --> ThisIsIt.jPanel1_MousePressed(Ljava.awt.event.MouseEvent;)V)
 * @param arg1 java.awt.event.MouseEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connMouseUp() {
	try {
		currentPanel.mouseUp(x,y,sys);// user code begin {2}
	} catch (java.lang.Throwable ivjExc) {
		handleException(ivjExc);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (6/14/00 9:30:42 AM)
 */
public void deleteUseCase() {
	ATuseCase uC;
	int index = getUseCasePanel().getJList1().getSelectedIndex();
	if(index != -1) {
		uC = (ATuseCase)(getUseCasePanel().getUseCases().elementAt(index));
		getUseCasePanel().deleteUseCase(uC);
		sys.deleteUseCase(uC);
	}
}
/**
 * This method was created in VisualAge.
 */
protected void generateCode() {
	CodeGen.AgentMom codeGenerator = new CodeGen.AgentMom();
	codeGenerator.genConversations(sys);
}
/**
 * Insert the method's description here.
 * Creation date: (11/7/00 4:22:12 PM)
 * @return javax.swing.JMenuItem
 */
private JMenuItem getAgComp() {
	if (ivjAgentComponents == null) {
		try {
			ivjAgentComponents= new JMenuItem();
			ivjAgentComponents.setName("AddAgentComponents");
			ivjAgentComponents.setMnemonic(KeyEvent.VK_G);
			ivjAgentComponents.setText("Add Agent Components");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjAgentComponents;
}
private JMenuItem getAgentComponentMobility() {
	if (ivjAgentComponentMobility == null) {
		try {
			ivjAgentComponentMobility= new JMenuItem();
			ivjAgentComponentMobility.setName("AgentComponentMobility");
			ivjAgentComponentMobility.setText("Agent Component Mobility");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjAgentComponentMobility;
}
/**
 * Return the AgentDiagramPage property value.
 * @return Editor.AgentDiagramPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private AgentDiagramPanel getAgentDiagramPage() {
	if (ivjAgentDiagramPage == null) {
		try {
			ivjAgentDiagramPage = new Editor.AgentDiagramPanel(version);
			ivjAgentDiagramPage.setName("AgentDiagramPage");
			ivjAgentDiagramPage.setLayout(null);
			ivjAgentDiagramPage.setBackground(java.awt.SystemColor.window);			
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjAgentDiagramPage;
}
/**
 * Return the FileLoadItem property value.
 * @return com.sun.java.swing.JMenuItem
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JMenuItem getagentMomGen() {
	if (ivjAgentMomGen == null) {
		try {
			ivjAgentMomGen = new JMenuItem();
			ivjAgentMomGen.setName("agentMom");
			ivjAgentMomGen.setMnemonic(KeyEvent.VK_E);
			ivjAgentMomGen.setText("agentMom");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjAgentMomGen;
}
/**
 * Return the AgentDiagramPage property value.
 * @return Editor.AgentDiagramPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private AgentPanel getAgentPage() {
/*	if ((agentPanel == null)||
	   ((lastSelectedObject!= null)
		   &&(lastSelectedObject != agent_last)
		   &&(lastSelectedObject.getClass().getName().equals("system.ATagent")))) {
*/
	if (agentPanel == null) {
		try {
			if(currentlySelectedObject != null) {
				agent_last = (system.ATagent)currentlySelectedObject;
			}
			agentPanel = new Editor.AgentPanel(version);
			agentPanel.setAgent(agent_last);
			agentPanel.setName("AgentPage");
			agentPanel.setSystem(sys);
			agentPanel.setLayout(null);
			agentPanel.setBackground(java.awt.SystemColor.window);
			
			agentPanel.addMouseListener(this);
			agentPanel.addMouseMotionListener(this);
			agentPanel.setSysMsgArea(getSysMsgArea());
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return agentPanel;
}
/**
 * Insert the method's description here.
 * Creation date: (11/7/00 4:23:31 PM)
 * @return javax.swing.JMenuItem
 */
private JMenuItem getAnCState() {
	if (ivjAnnotateCState == null) {
		try {
			ivjAnnotateCState= new JMenuItem();
			ivjAnnotateCState.setName("AnnotateCState");
			ivjAnnotateCState.setMnemonic(KeyEvent.VK_O);
			ivjAnnotateCState.setText("Annotate Component State Diagrams");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjAnnotateCState;
}
/**
 * Return the ATeditorFrameJMenuBar property value.
 * @return com.sun.java.swing.JMenuBar
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JMenuBar getATeditorFrameJMenuBar() {
	if (ivjATeditorFrameJMenuBar == null) {
		try {
			ivjATeditorFrameJMenuBar = new JMenuBar();
			ivjATeditorFrameJMenuBar.setName("ATeditorFrameJMenuBar");
			ivjATeditorFrameJMenuBar.add(getFileMenu());
			ivjATeditorFrameJMenuBar.add(getKBFiles());
			ivjATeditorFrameJMenuBar.add(getVerifyMenu());
			ivjATeditorFrameJMenuBar.add(getCodeGenMenu());
			ivjATeditorFrameJMenuBar.add(getTransformMenu());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjATeditorFrameJMenuBar;
}
/**
 * Return the ATeditorPanel property value.
 * @return com.sun.java.swing.JPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JPanel getATeditorPanel() {
	if (ivjATeditorPanel == null) {
		try {
			ivjATeditorPanel = new JPanel();
			ivjATeditorPanel.setName("ATeditorPanel");
			ivjATeditorPanel.setLayout(null);
			ivjATeditorPanel.setBackground(java.awt.Color.lightGray);
			getATeditorPanel().add(getATTabbedPane(), getATTabbedPane().getName());
			getATeditorPanel().add(getCurrentObjectLabel(), getCurrentObjectLabel().getName());
			getATeditorPanel().add(getCurrentObjectField(), getCurrentObjectField().getName());
			getATeditorPanel().add(getButtonOne(), getButtonOne().getName());
			getATeditorPanel().add(getButtonTwo(), getButtonTwo().getName());
			getATeditorPanel().add(getButtonThree(), getButtonThree().getName());
			getATeditorPanel().add(getSysMsgArea(), getSysMsgArea().getName());			
		} catch (java.lang.Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return ivjATeditorPanel;
}
/**
 * Return the JTabbedPane1 property value.
 * @return com.sun.java.swing.JTabbedPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JTabbedPane getATTabbedPane() {
	if (ivjATTabbedPane == null) {
		try {
			ivjATTabbedPane = new JTabbedPane();
			ivjATTabbedPane.setName("ATTabbedPane");
			ivjATTabbedPane.setBackground(new java.awt.Color(204,204,204));
			ivjATTabbedPane.setBounds(113, 55, 655, 392);
			ivjATTabbedPane.addTab("Goal Hierarchy",getScrollPane8());
			ivjATTabbedPane.addTab("Use Cases",getScrollPane9());
			ivjATTabbedPane.addTab("Seq Diagram",getScrollPane10());
			ivjATTabbedPane.addTab("Role Diagram", getScrollPane6());
			ivjATTabbedPane.addTab("Agent Template Diagram", getScrollPane1());
			ivjATTabbedPane.addTab("Deployment", getScrollPane11());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjATTabbedPane;
}
/**
 * Return the JButton1 property value.
 * @return com.sun.java.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JButton getButtonOne() {
	if (ivjButtonOne == null) {
		try {
			ivjButtonOne = new JButton();
			ivjButtonOne.setName("ButtonOne");
			ivjButtonOne.setText("Add Goal");
			ivjButtonOne.setMnemonic(KeyEvent.VK_G);
			ivjButtonOne.setBounds(7, 70, 135, 25);
		} catch (java.lang.Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return ivjButtonOne;
}
/**
 * Return the AddConvButton property value.
 * @return com.sun.java.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JButton getButtonThree() {
	if (ivjButtonThree == null) {
		try {
			ivjButtonThree = new JButton();
			ivjButtonThree.setName("AddButtonThree");
			ivjButtonThree.setText("Add Protocol");
			ivjButtonThree.setBounds(7, 142, 135, 25);
			ivjButtonThree.setVisible(false);
		} catch (java.lang.Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return ivjButtonThree;
}
/**
 * Return the AddConvButton property value.
 * @return com.sun.java.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JButton getButtonTwo() {
	if (ivjButtonTwo == null) {
		try {
			ivjButtonTwo = new JButton();
			ivjButtonTwo.setName("AddButtonTwo");
			ivjButtonTwo.setText("Add Task");
			ivjButtonTwo.setBounds(7, 106, 135, 25);
			getButtonTwo().setVisible(false);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjButtonTwo;
}
/**
 * Return the FileLoadItem property value.
 * @return com.sun.java.swing.JMenuItem
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JMenuItem getCarolinaGen() {
	if (ivjCarolinaGen == null) {
		try {
			ivjCarolinaGen = new JMenuItem();
			ivjCarolinaGen.setName("Carolina");
			ivjCarolinaGen.setMnemonic(KeyEvent.VK_L);
			ivjCarolinaGen.setText("Carolina");
			ivjCarolinaGen.setEnabled(true);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjCarolinaGen;
}
/**
 * Return the FileSaveItem property value.
 * @return com.sun.java.swing.JMenuItem
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JMenuItem getClearPanel() {
	if (ivjClearPanel == null) {
		try {
			ivjClearPanel= new JMenuItem();
			ivjClearPanel.setName("clearpanel");
			ivjClearPanel.setMnemonic(KeyEvent.VK_E);
			ivjClearPanel.setText("Clear Panel");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjClearPanel;
}
/**
 * Return the FileSaveItem property value.
 * @return com.sun.java.swing.JMenuItem
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JMenuItem getClearSystem() {
	if (ivjClearSystem == null) {
		try {
			ivjClearSystem= new JMenuItem();
			ivjClearSystem.setName("ClearSystem");
			ivjClearSystem.setMnemonic(KeyEvent.VK_Y);
			ivjClearSystem.setText("Clear System");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjClearSystem;
}
/**
 * Return the JMenu2 property value.
 * @return com.sun.java.swing.JMenu
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JMenu getCodeGenMenu() {
	if (ivjCodeGenMenu == null) {
		try {
			ivjCodeGenMenu = new JMenu();
			ivjCodeGenMenu.setName("CodeGenMenu");
			ivjCodeGenMenu.setMnemonic(KeyEvent.VK_O);
			ivjCodeGenMenu.setFont(new java.awt.Font("dialog", 0, 12));
			ivjCodeGenMenu.setText("CodeGen");
			ivjCodeGenMenu.add(getagentMomGen());
			ivjCodeGenMenu.add(getCarolinaGen());				
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjCodeGenMenu;
}
/**
 * Return the CommClassPage property value.
 * @return Editor.CommClassesPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private ConversationPanel getCompDiag() {
	if (CompDiagram == null) {
		try {
			CompDiagram = new Editor.ConversationPanel(version);
			CompDiagram.setName("CommClassPage");
			CompDiagram.setLayout(null);
			CompDiagram.setBackground(java.awt.SystemColor.window);
			getCompDiag().addMouseListener(this);
			getCompDiag().addMouseMotionListener(this);
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return CompDiagram;
}
	/**
 * Insert the method's description here.
 * Creation date: (11/7/00 4:22:12 PM)
 * @return javax.swing.JMenuItem
 */
private JMenuItem getComponentMobility() {
	if (ivjComponentMobility == null) {
		try {
			ivjComponentMobility= new JMenuItem();
			ivjComponentMobility.setName("ivjComponentMobility");
			ivjComponentMobility.setText("Component Mobility");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjComponentMobility;
}
/**
 * Insert the method's description here.
 * Creation date: (11/7/00 4:23:57 PM)
 * @return javax.swing.JMenuItem
 */
private JMenuItem getCrConv() {
	if (ivjCreateConversions == null) {
		try {
			ivjCreateConversions= new JMenuItem();
			ivjCreateConversions.setName("CreateConversations");
			ivjCreateConversions.setMnemonic(KeyEvent.VK_V);
			ivjCreateConversions.setText("Create Conversations");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjCreateConversions;
}
	/**
 * Insert the method's description here.
 * Creation date: (11/7/00 4:22:12 PM)
 * @return javax.swing.JMenuItem
 */
private JMenuItem getCreateAgentComponent() {
	if (ivjCreateAgentComponent == null) {
		try {
			ivjCreateAgentComponent= new JMenuItem();
			ivjCreateAgentComponent.setName("CreateAgentComponent");
			ivjCreateAgentComponent.setText("Create Agent Component");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjCreateAgentComponent;
}
/**
 * Return the JTextField11 property value.
 * @return com.sun.java.swing.JTextField
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JTextField getCurrentObjectField() {
	if (ivjCurrentObjectField == null) {
		try {
			ivjCurrentObjectField = new JTextField();
			ivjCurrentObjectField.setName("ivjCurrentObjectField");
			ivjCurrentObjectField.setBounds(260, 12, 250, 19);			
			// user code begin {1}
			ivjCurrentObjectField.setText("");
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjCurrentObjectField;
}
/**
 * Return the CurrentObjectLabel property value.
 * @return com.sun.java.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JLabel getCurrentObjectLabel() {
	if (ivjCurrentObjectLabel == null) {
		try {
			ivjCurrentObjectLabel = new JLabel();
			ivjCurrentObjectLabel.setName("CurrentObjectLabel");
			ivjCurrentObjectLabel.setText("Currently Selected");
			ivjCurrentObjectLabel.setBounds(138, 14, 115, 15);
			ivjCurrentObjectLabel.setHorizontalAlignment(SwingConstants.RIGHT);
			ivjCurrentObjectLabel.setFont(new java.awt.Font("dialog.bold", 1, 12));
			ivjCurrentObjectLabel.setForeground(new java.awt.Color(170,20,28));
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjCurrentObjectLabel;
}
/**
 * Return the FileSaveItem property value.
 * @return com.sun.java.swing.JMenuItem
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JMenuItem getDataDictionary() {
	if (ivjDataDictionary == null) {
		try {
			ivjDataDictionary= new JMenuItem();
			ivjDataDictionary.setName("getDataDictionary");
			ivjDataDictionary.setMnemonic(KeyEvent.VK_D);
			ivjDataDictionary.setText("Save Data Dictionary");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjDataDictionary;
}
/**
 * Return the AgentDiagramPage property value.
 * @return Editor.DeploymentPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private DeploymentPanel getDeploymentPanel() {
	if (ivjDeploymentPanel == null) {
		try {
			ivjDeploymentPanel = new Editor.DeploymentPanel(version);
			ivjDeploymentPanel.setName("DeploymentPanel");
			ivjDeploymentPanel.setLayout(null);
			ivjDeploymentPanel.setBackground(java.awt.SystemColor.window);			
			ivjDeploymentPanel.initPanel(sys);	
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjDeploymentPanel;
}
/**
 * Return the FileSaveItem property value.
 * @return com.sun.java.swing.JMenuItem
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JMenuItem getExit() {
	if (ivjExit == null) {
		try {
			ivjExit= new JMenuItem();
			ivjExit.setName("Exit");
			ivjExit.setMnemonic(KeyEvent.VK_X);
			ivjExit.setText("Exit");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjExit;
}
/**
 * Return the FileLoadItem property value.
 * @return com.sun.java.swing.JMenuItem
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JMenuItem getFileLoadSystem() {
	if (ivjFileLoadSystem == null) {
		try {
			ivjFileLoadSystem = new JMenuItem();
			ivjFileLoadSystem.setName("FileLoadSystem");
			ivjFileLoadSystem.setMnemonic(KeyEvent.VK_L);
			ivjFileLoadSystem.setText("Load from File");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjFileLoadSystem;
}
private JMenu getFileMenu() {
	if (ivjFileMenu == null) {
		try {
			//Setup File Menu
			ivjFileMenu = new JMenu();
			ivjFileMenu.setName("FileMenu");
			ivjFileMenu.setMnemonic(KeyEvent.VK_F);
			ivjFileMenu.setFont(new java.awt.Font("dialog", 0, 12));
			ivjFileMenu.setText("File");
	
			ivjFileMenu.add(getFileSaveSystem());
			ivjFileMenu.add(getFileLoadSystem());
			ivjFileMenu.addSeparator();

			ivjFileMenu.add(getDataDictionary());
			ivjFileMenu.addSeparator();
			
			ivjFileMenu.add(getClearPanel());
			ivjFileMenu.add(getClearSystem());
			ivjFileMenu.add(getExit());

			ivjFileMenu.add(getPrint());
			ivjFileMenu.add(getPrintpage());
			
		} catch (java.lang.Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return ivjFileMenu;
}
/**
 * Return the FileSaveItem property value.
 * @return com.sun.java.swing.JMenuItem
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JMenuItem getFileSaveSystem() {
	if (ivjFileSaveSystem == null) {
		try {
			ivjFileSaveSystem= new JMenuItem();
			ivjFileSaveSystem.setName("FileSaveSystem");
			ivjFileSaveSystem.setMnemonic(KeyEvent.VK_V);
			ivjFileSaveSystem.setText("Save to File");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjFileSaveSystem;
}
/**
 * Return the AgentDiagramPage property value.
 * @return Editor.AgentDiagramPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private GoalPanel getGoalPanel() {
	if (ivjGoalPanel == null) {
		try {
			ivjGoalPanel = new Editor.GoalPanel(version);
			ivjGoalPanel.setName("GoalPanel");
			ivjGoalPanel.setLayout(null);
			ivjGoalPanel.setBackground(java.awt.SystemColor.window);
			ivjGoalPanel.initPanel(sys);	
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjGoalPanel;
}
/**
 * Return the CommClassPage property value.
 * @return Editor.CommClassesPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private ConversationPanel getInitiatorPage() {
	if (ivjInitiatorPage == null) {
		try {
			ivjInitiatorPage = new Editor.ConversationPanel(version);
			ivjInitiatorPage.setName("CommClassPage");
			ivjInitiatorPage.setLayout(null);
			ivjInitiatorPage.setBackground(java.awt.SystemColor.window);
			getInitiatorPage().addMouseListener(this);
			getInitiatorPage().addMouseMotionListener(this);
	
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjInitiatorPage;
}
private JMenu getKBFiles() {
	if (ivjKBFiles == null) {
		try {
			//Setup File Menu
			ivjKBFiles = new JMenu();
			ivjKBFiles.setName("Knowledge Base");
			ivjKBFiles.setMnemonic(KeyEvent.VK_K);
			ivjKBFiles.setFont(new java.awt.Font("dialog", 0, 12));
			ivjKBFiles.setText("Knowledge Base");

			ivjKBFiles.add(getStoreObject());
			ivjKBFiles.add(getLoadObject());
			ivjKBFiles.addSeparator();

			ivjKBFiles.add(getStoreArchitecture());
			ivjKBFiles.add(getLoadArchitecture());
			ivjKBFiles.addSeparator();
			
			ivjKBFiles.add(getStoreSystem());
			ivjKBFiles.add(getLoadSystem());
		//	ivjKBFiles.addSeparator();
		
		} catch (java.lang.Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return ivjKBFiles;
}
private JMenuItem getLoadArchitecture() {
	if (ivjLoadArchitecture== null) {
		try {
			ivjLoadArchitecture = new JMenuItem();
			ivjLoadArchitecture.setName("LoadArchitecture");
			ivjLoadArchitecture.setMnemonic(KeyEvent.VK_H);
			ivjLoadArchitecture.setText("Load Architecture");
		} catch (java.lang.Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return ivjLoadArchitecture;
}
private JMenuItem getLoadObject() {
	if (ivjLoadObject == null) {
		try {
			ivjLoadObject = new JMenuItem();
			ivjLoadObject.setName("LoadObject");
			ivjLoadObject.setMnemonic(KeyEvent.VK_B);
			ivjLoadObject.setText("Load Object");
		} catch (java.lang.Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return ivjLoadObject;
}
private JMenuItem getLoadSystem() {
	if (ivjLoadSystem == null) {
		try {
			ivjLoadSystem = new JMenuItem();
			ivjLoadSystem.setName("LoadSystem");
			ivjLoadSystem.setMnemonic(KeyEvent.VK_M);
			ivjLoadSystem.setText("Load System");
		} catch (java.lang.Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return ivjLoadSystem;
}
/**
 * Return the FileSaveItem property value.
 * @return com.sun.java.swing.JMenuItem
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JMenuItem getPrint() {
	if (ivjPrint == null) {
		try {
			ivjPrint= new JMenuItem();
			ivjPrint.setName("Print");
			ivjPrint.setMnemonic(KeyEvent.VK_P);
			ivjPrint.setText("Print");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjPrint;
}
/**
 * Insert the method's description here.
 * Creation date: (1/24/01 3:03:45 PM)
 */
public void getPrintImage() {

//	Dimension d = currentPanel.getVisibleArea();
	
	//printbuffer = createImage(d.width,d.height);
	//printGraphics = printbuffer.getGraphics();

//	currentPanel.print(printGraphics);
		
}
/**
 * Return the FileSaveItem property value.
 * @return com.sun.java.swing.JMenuItem
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JMenuItem getPrintpage() {
	if (ivjPrintpage == null) {
		try {
			ivjPrintpage= new JMenuItem();
			ivjPrintpage.setName("Printpage");
			ivjPrintpage.setMnemonic(KeyEvent.VK_C);
			ivjPrintpage.setText("Scaled Printing");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjPrintpage;
}
/**
 * Return the CommClassPage property value.
 * @return Editor.CommClassesPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private ConversationPanel getResponderPage() {
	if (ivjResponderPage == null) {
		try {
			ivjResponderPage = new Editor.ConversationPanel(version);
			ivjResponderPage.setName("CommClassPage");
			ivjResponderPage.setLayout(null);
			ivjResponderPage.setBackground(java.awt.SystemColor.window);
			getResponderPage().addMouseListener(this);
			getResponderPage().addMouseMotionListener(this);
	
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjResponderPage;
}
/**
 * Return the AgentDiagramPage property value.
 * @return Editor.AgentDiagramPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private RolePanel getRolePanel() {
	if (ivjRolePanel == null) {
		try {
			ivjRolePanel = new Editor.RolePanel(version);
			ivjRolePanel.setName("RolePanel");
			ivjRolePanel.setLayout(null);
			ivjRolePanel.setBackground(java.awt.SystemColor.window);
			ivjRolePanel.initPanel(sys);	
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjRolePanel;
}
/**
 * Insert the method's description here.
 * Creation date: (12/14/99 9:22:35 AM)
 * @return javax.swing.JScrollPane
 */
private JScrollPane getScrollPane1() {
	if(jscrollpane1 == null){
		jscrollpane1 = new javax.swing.JScrollPane();
		jscrollpane1.setName("JScrollPane1");
		//	ivjJScrollPane3.setBounds(273, 102, 260, 234);
		jscrollpane1.setViewportView(getAgentDiagramPage());
		jscrollpane1.getVerticalScrollBar().addMouseListener(this);	
		jscrollpane1.getVerticalScrollBar().addMouseMotionListener(this);
		jscrollpane1.getHorizontalScrollBar().addMouseListener(this);
		jscrollpane1.getHorizontalScrollBar().addMouseMotionListener(this);
	
	//	jscrollpane1 = new JScrollPane(getAgentDiagramPage());
	}
	return jscrollpane1;
}
/**
 * Insert the method's description here.
 * Creation date: (12/14/1010 10:22:35 AM)
 * @return javax.swing.JScrollPane
 */
private JScrollPane getScrollPane10() {
	if(jscrollpane10==null){
		jscrollpane10 = new JScrollPane(getSeqDiagPanel());
		jscrollpane10.getVerticalScrollBar().addMouseListener(this);	
		jscrollpane10.getVerticalScrollBar().addMouseMotionListener(this);
		jscrollpane10.getHorizontalScrollBar().addMouseListener(this);
		jscrollpane10.getHorizontalScrollBar().addMouseMotionListener(this);
	}
	return jscrollpane10;
}
/**
 * Insert the method's description here.
 * Creation date: (12/14/1010 10:22:35 AM)
 * @return javax.swing.JScrollPane
 */
private JScrollPane getScrollPane11() {
	if(jscrollpane11==null){
		jscrollpane11 = new JScrollPane(getDeploymentPanel());
		jscrollpane11.getVerticalScrollBar().addMouseListener(this);	
		jscrollpane11.getVerticalScrollBar().addMouseMotionListener(this);
		jscrollpane11.getHorizontalScrollBar().addMouseListener(this);
		jscrollpane11.getHorizontalScrollBar().addMouseMotionListener(this);
	
	}
	return jscrollpane11;
}
/**
 * Insert the method's description here.
 * Creation date: (12/14/99 9:22:35 AM)
 * @return javax.swing.JScrollPane
 */
private JScrollPane getScrollPane2() {
/*	if ((jscrollpane2 == null)||
	   ((lastSelectedObject!= null)
		   &&(lastSelectedObject != agent_last)
		   &&(lastSelectedObject.getClass().getName().equals("system.ATagent")))) {
*/
	if (jscrollpane2 == null) {

		jscrollpane2 = new JScrollPane(getAgentPage());
		jscrollpane2.getVerticalScrollBar().addMouseListener(this);	
		jscrollpane2.getVerticalScrollBar().addMouseMotionListener(this);
		jscrollpane2.getHorizontalScrollBar().addMouseListener(this);
		jscrollpane2.getHorizontalScrollBar().addMouseMotionListener(this);
	
	}
	return jscrollpane2;
}
/**
 * Insert the method's description here.
 * Creation date: (12/14/99 9:22:35 AM)
 * @return javax.swing.JScrollPane
 */
private JScrollPane getScrollPane3() {
	if(jscrollpane3 == null){
		jscrollpane3 = new JScrollPane(getInitiatorPage());
		jscrollpane3.getVerticalScrollBar().addMouseListener(this);	
		jscrollpane3.getVerticalScrollBar().addMouseMotionListener(this);
		jscrollpane3.getHorizontalScrollBar().addMouseListener(this);
		jscrollpane3.getHorizontalScrollBar().addMouseMotionListener(this);
	
	}
	return jscrollpane3;
}
/**
 * Insert the method's description here.
 * Creation date: (12/14/99 9:22:35 AM)
 * @return javax.swing.JScrollPane
 */
private JScrollPane getScrollPane4() {
	if(jscrollpane4 == null){
		jscrollpane4 = new JScrollPane(getResponderPage());
		jscrollpane4.getVerticalScrollBar().addMouseListener(this);	
		jscrollpane4.getVerticalScrollBar().addMouseMotionListener(this);
		jscrollpane4.getHorizontalScrollBar().addMouseListener(this);
		jscrollpane4.getHorizontalScrollBar().addMouseMotionListener(this);
	
	}
	return jscrollpane4;
}
/**
 * Insert the method's description here.
 * Creation date: (12/14/99 9:22:35 AM)
 * @return javax.swing.JScrollPane
 */
private JScrollPane getScrollPane5() {
	if(jscrollpane5==null){
		jscrollpane5 = new JScrollPane(getCompDiag());
		jscrollpane5.getVerticalScrollBar().addMouseListener(this);	
		jscrollpane5.getVerticalScrollBar().addMouseMotionListener(this);
		jscrollpane5.getHorizontalScrollBar().addMouseListener(this);
		jscrollpane5.getHorizontalScrollBar().addMouseMotionListener(this);
	
	}
	return jscrollpane5;
}
/**
 * Insert the method's description here.
 * Creation date: (12/14/99 9:22:35 AM)
 * @return javax.swing.JScrollPane
 */
private JScrollPane getScrollPane6() {
	if(jscrollpane6==null){
		jscrollpane6 = new JScrollPane(getRolePanel());
		jscrollpane6.getVerticalScrollBar().addMouseListener(this);	
		jscrollpane6.getVerticalScrollBar().addMouseMotionListener(this);
		jscrollpane6.getHorizontalScrollBar().addMouseListener(this);
		jscrollpane6.getHorizontalScrollBar().addMouseMotionListener(this);
	
	}
	return jscrollpane6;
}
/**
 * Insert the method's description here.
 * Creation date: (12/17/99 9:22:35 AM)
 * @return javax.swing.JScrollPane
 */
private JScrollPane getScrollPane7() {
	if(jscrollpane7 == null){
		jscrollpane7 = new JScrollPane(getTaskDiagram());
		jscrollpane7.getVerticalScrollBar().addMouseListener(this);	
		jscrollpane7.getVerticalScrollBar().addMouseMotionListener(this);
		jscrollpane7.getHorizontalScrollBar().addMouseListener(this);
		jscrollpane7.getHorizontalScrollBar().addMouseMotionListener(this);
	
	}
	return jscrollpane7;
}
/**
 * Insert the method's description here.
 * Creation date: (12/14/99 9:22:35 AM)
 * @return javax.swing.JScrollPane
 */
private JScrollPane getScrollPane8() {
	if(jscrollpane8==null){
		jscrollpane8 = new JScrollPane(getGoalPanel());
		jscrollpane8.getVerticalScrollBar().addMouseListener(this);	
		jscrollpane8.getVerticalScrollBar().addMouseMotionListener(this);
		jscrollpane8.getHorizontalScrollBar().addMouseListener(this);
		jscrollpane8.getHorizontalScrollBar().addMouseMotionListener(this);
	
	}
	return jscrollpane8;
}
/**
 * Insert the method's description here.
 * Creation date: (12/14/99 9:22:35 AM)
 * @return javax.swing.JScrollPane
 */
private JScrollPane getScrollPane9() {
	if(jscrollpane9==null){
		jscrollpane9 = new JScrollPane(getUseCasePanel());
		jscrollpane9.getVerticalScrollBar().addMouseListener(this);	
		jscrollpane9.getVerticalScrollBar().addMouseMotionListener(this);
		jscrollpane9.getHorizontalScrollBar().addMouseListener(this);
		jscrollpane9.getHorizontalScrollBar().addMouseMotionListener(this);
	
	}
	return jscrollpane9;
}
/**
 * Insert the method's description here.
 * Creation date: (11/2/99 10:11:30 AM)
 * @return system.ATobject
 */
public ATobject getSelected() {
	//get the selected pane
	JScrollPane pane = (JScrollPane)getATTabbedPane().getSelectedComponent();
	//return the selected object of the panel contained in the selected scrollpane
	if(pane==getScrollPane1()){
		return getAgentDiagramPage().getSelectedObject();
	} else if(pane==getScrollPane2()){
		return getAgentPage().getSelectedObject();
	} else if(pane==getScrollPane3()){
		return getInitiatorPage().getSelectedObject();
	} else if(pane==getScrollPane4()){
		return getResponderPage().getSelectedObject();
	} else if(pane==getScrollPane6()){
		return getRolePanel().getSelectedObject();
	} else if(pane==getScrollPane7()){
		return getTaskDiagram().getSelectedObject();
	} else if(pane==getScrollPane8()){
		return getGoalPanel().getSelectedObject();
	} else if(pane==getScrollPane5()){
		return getCompDiag().getSelectedObject(); 
	}
	return null;
}
/**
 * Return the AgentDiagramPage property value.
 * @return Editor.AgentDiagramPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private SeqDiagPanel getSeqDiagPanel() {
	if (ivjSeqDiagPanel == null) {
		try {
			ivjSeqDiagPanel = new Editor.SeqDiagPanel(version);
			ivjSeqDiagPanel.setName("SeqDiagPanel");
			ivjSeqDiagPanel.setLayout(null);
			ivjSeqDiagPanel.setBackground(java.awt.SystemColor.window);
		//	ivjSeqDiagPanel.initPanel(sys);	
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjSeqDiagPanel;
}
private JMenuItem getStoreArchitecture() {
	if (ivjStoreArchitecture == null) {
		try {
			ivjStoreArchitecture = new JMenuItem();
			ivjStoreArchitecture.setName("StoreArchitecture");
			ivjStoreArchitecture.setMnemonic(KeyEvent.VK_R);
			ivjStoreArchitecture.setText("Store Architecture");
		} catch (java.lang.Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return ivjStoreArchitecture;
}
private JMenuItem getStoreObject() {
	if (ivjStoreObject == null) {
		try {
			ivjStoreObject = new JMenuItem();
			ivjStoreObject.setName("StoreObject");
			ivjStoreObject.setMnemonic(KeyEvent.VK_O);
			ivjStoreObject.setText("Store Object");
		} catch (java.lang.Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return ivjStoreObject;
}
private JMenuItem getStoreSystem() {
	if (ivjStoreSystem == null) {
		try {
			ivjStoreSystem = new JMenuItem();
			ivjStoreSystem.setName("StoreSystem");
			ivjStoreSystem.setMnemonic(KeyEvent.VK_Y);
			ivjStoreSystem.setText("Store System");
		} catch (java.lang.Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return ivjStoreSystem;
}
private java.awt.TextArea getSysMsgArea() {
	if (ivjSysMsgArea == null) {
		try {
			//setup Text Area
			ivjSysMsgArea = new java.awt.TextArea("",100,30,java.awt.TextArea.SCROLLBARS_NONE);			
			ivjSysMsgArea.setName("SysMsgArea");
			ivjSysMsgArea.setBounds(7, 200, 135, 162);
//			ivjSysMsgArea.setBackground(new java.awt.Color(244,255,255));
			ivjSysMsgArea.setBackground(new java.awt.Color(255,255,225));
			ivjSysMsgArea.setEditable(false);
			ivjSysMsgArea.setFont(new java.awt.Font("serif", 0, 10));
			ivjSysMsgArea.append("agentTool v" + this.VERSION_NUMBER +"\n");
		} catch (java.lang.Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return ivjSysMsgArea;
}
/**
 * Return the CommClassPage property value.
 * @return Editor.CommClassesPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private ConversationPanel getTaskDiagram() {
	if (TaskDiagram == null) {
		try {
			TaskDiagram = new Editor.ConversationPanel(version);
			TaskDiagram.setName("CommClassPage");
			TaskDiagram.setLayout(null);
			TaskDiagram.setBackground(java.awt.SystemColor.window);
			getTaskDiagram().addMouseListener(this);
			getTaskDiagram().addMouseMotionListener(this);
	
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return TaskDiagram;
}
/**
 * Insert the method's description here.
 * Creation date: (11/7/00 4:17:38 PM)
 * @return javax.swing.JMenu
 */
private JMenu getTransformMenu() {
	if (ivjTransformation == null) {
		try {
			//Setup File Menu
			ivjTransformation = new JMenu();
			ivjTransformation.setName("Transformation");
			ivjTransformation.setMnemonic(KeyEvent.VK_T);
			ivjTransformation.setFont(new java.awt.Font("dialog", 0, 12));
			ivjTransformation.setText("Transformation");

			ivjTransformation.add(getAgComp());
			ivjTransformation.add(getAnCState());
			ivjTransformation.add(getCrConv());
			ivjTransformation.add(getCreateAgentComponent());
			ivjTransformation.add(getAgentComponentMobility());
			ivjTransformation.add(getComponentMobility());			

		} catch (java.lang.Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return ivjTransformation;
}
/**
 * Return the AgentDiagramPage property value.
 * @return Editor.AgentDiagramPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private UseCasePanel getUseCasePanel() {
	if (ivjUseCasePanel == null) {
		try {
			ivjUseCasePanel = new Editor.UseCasePanel(getSeqDiagPanel(), version);
			ivjUseCasePanel.setSys(sys);
			ivjUseCasePanel.setName("UseCasePanel");
			ivjUseCasePanel.setLayout(null);
			ivjUseCasePanel.setBackground(java.awt.SystemColor.window);
		//	ivjUseCasePanel.initPanel(sys);	
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjUseCasePanel;
}
/**
 * Return the FileLoadItem property value.
 * @return com.sun.java.swing.JMenuItem
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JMenuItem getVerifyAsynch() {
	if (ivjVerifyAsynch == null) {
		try {
			ivjVerifyAsynch = new JMenuItem();
			ivjVerifyAsynch.setName("VerifyAsynch");
			ivjVerifyAsynch.setMnemonic(KeyEvent.VK_H);
			ivjVerifyAsynch.setText("Asynchronous");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjVerifyAsynch;
}
/**
 * Return the JMenu2 property value.
 * @return com.sun.java.swing.JMenu
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JMenu getVerifyMenu() {
	if (ivjVerifyMenu == null) {
		try {
			ivjVerifyMenu = new JMenu();
			ivjVerifyMenu.setName("VerifyMenu");
			ivjVerifyMenu.setMnemonic(KeyEvent.VK_V);
			ivjVerifyMenu.setFont(new java.awt.Font("dialog", 0, 12));
			ivjVerifyMenu.setText("Verify");
			ivjVerifyMenu.add(getVerifySynch());
			ivjVerifyMenu.add(getVerifyAsynch());				
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjVerifyMenu;
}
/**
 * Return the FileLoadItem property value.
 * @return com.sun.java.swing.JMenuItem
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JMenuItem getVerifySynch() {
	if (ivjVerifySynch == null) {
		try {
			ivjVerifySynch = new JMenuItem();
			ivjVerifySynch.setName("VerifySynch");
			ivjVerifySynch.setMnemonic(KeyEvent.VK_Y);
			ivjVerifySynch.setText("Synchronous");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjVerifySynch;
}
/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	//System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	//exception.printStackTrace(System.out);
}
/**
 * Initializes connections
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initConnections() {
	//add MouseListener, MouseMotionListener, ChangeListener, and ActionListener to appropriate objects
	FocusAdapter fa = new FocusListener1();
	this.addFocusListener(fa);
	getAgentDiagramPage().addMouseListener(this);
	getAgentDiagramPage().addMouseMotionListener(this);
	getRolePanel().addMouseListener(this);
	getRolePanel().addMouseMotionListener(this);
	getGoalPanel().addMouseMotionListener(this);
	getGoalPanel().addMouseListener(this);
	getUseCasePanel().addMouseListener(this);
	getSeqDiagPanel().addMouseListener(this);
	getSeqDiagPanel().addMouseMotionListener(this);
	getDeploymentPanel().addMouseListener(this);
	getDeploymentPanel().addMouseMotionListener(this);
	getATTabbedPane().addChangeListener(this);
	Color back = new Color(170,170,196);
	getATTabbedPane().setBackground(back);
	getButtonOne().addActionListener(this);
	getButtonTwo().addActionListener(this);
	getButtonThree().addActionListener(this);	
	getVerifySynch().addActionListener(this);
	getVerifyAsynch().addActionListener(this);
	getagentMomGen().addActionListener(this);
	getCarolinaGen().addActionListener(this);	
	getFileLoadSystem().addActionListener(this);
	getFileSaveSystem().addActionListener(this);
	getDataDictionary().addActionListener(this);
	getLoadSystem().addActionListener(this);
	getStoreSystem().addActionListener(this);
	getLoadArchitecture().addActionListener(this);
	getStoreArchitecture().addActionListener(this);		
	getLoadObject().addActionListener(this);
	getStoreObject().addActionListener(this);
	getClearSystem().addActionListener(this);
	getClearPanel().addActionListener(this);
	getExit().addActionListener(this);
	getPrint().addActionListener(this);
	getPrintpage().addActionListener(this);
	getAgComp().addActionListener(this);
	getAnCState().addActionListener(this);
	getCrConv().addActionListener(this);
	getCreateAgentComponent().addActionListener(this);
	getComponentMobility().addActionListener(this);
	getAgentComponentMobility().addActionListener(this);
	getScrollPane1().getVerticalScrollBar().addMouseListener(this);
	getScrollPane1().getVerticalScrollBar().addMouseMotionListener(this);
	this.addKeyListener(this);
}
/**
 * Initialize the class.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initialize() {
	sys = new system.ATsystem(version);
	setName("ATeditorFrame");
	setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
	setVisible(true);
	
	setJMenuBar(getATeditorFrameJMenuBar());
	setFont(new java.awt.Font("dialog", 0, 12));
	setSize(1000, 725);
	setTitle("agentTool");
	setContentPane(getATeditorPanel());
	getATeditorPanel().setLayout(frameLayout);

	agent_last = new ATagent(version,sys.getNextKey());

	getAgentDiagramPage().setSysMsgArea(getSysMsgArea());
	getInitiatorPage().setSysMsgArea(getSysMsgArea());
	getResponderPage().setSysMsgArea(getSysMsgArea());
	getAgentPage().setSysMsgArea(getSysMsgArea());
	getCompDiag().setSysMsgArea(getSysMsgArea());
	getRolePanel().setSysMsgArea(getSysMsgArea());
	getGoalPanel().setSysMsgArea(getSysMsgArea());
	getUseCasePanel().setSysMsgArea(getSysMsgArea());
	getSeqDiagPanel().setSysMsgArea(getSysMsgArea());
	getTaskDiagram().setSysMsgArea(getSysMsgArea());
	getDeploymentPanel().setSysMsgArea(getSysMsgArea());	
	archVector = new Vector();
	initConnections();
	sysMsg("Ready");
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.KeyEvent
 */
public void keyPressed(KeyEvent e) {
	//if a key is being held down, make boolean shift = true
	if(currentPanel != null){
		currentPanel.shift = true;
	}
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.KeyEvent
 */
public void keyReleased(KeyEvent e) {
	//if the key has been released, make the boolean shift = false
	if(currentPanel != null){
		currentPanel.shift = false;
	}
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.KeyEvent
 */
public void keyTyped(KeyEvent e) {
}
/**
 * This method was created in VisualAge.
 */
protected void loadFile() {

	JFileChooser d = new JFileChooser();
	d.setCurrentDirectory(new File(".\\Workshop"));
	int result = d.showOpenDialog(this);
	if(result == JFileChooser.APPROVE_OPTION) {
		String inFileName = d.getSelectedFile().getPath();
		
		ObjectInputStream o = null;

		try {
			java.io.FileInputStream inFileStream = new java.io.FileInputStream(inFileName);
			o = new java.io.ObjectInputStream(inFileStream);
	
		} catch (java.io.IOException e) {
			System.out.println("*** ERROR - cannot open file:" + inFileName);
			handleException(e);
			return;
		}

		system.ATsystem inSys = null;
	
		try {
			inSys = (system.ATsystem)o.readObject();
		} catch (java.io.IOException e) {
			System.out.println("*** ERROR - cannot read from file:" + inFileName);
			e.printStackTrace(System.out);
			handleException(e);
			return;
		} catch (java.lang.ClassNotFoundException e) {
			System.out.println("*** ERROR - bad data in file:" + inFileName);
			handleException(e);
			return;
		}

		sys = inSys;
		getUseCasePanel().setUseCases(sys.getUseCasesVector());
		this.repaint();
	}

/*	java.awt.FileDialog loadDialog = new java.awt.FileDialog(this, "Load System", java.awt.FileDialog.LOAD);
	loadDialog.show();
	if (loadDialog.getFile() == null) {return;};
	String inFileName = loadDialog.getFile();
	String inDirName = loadDialog.getDirectory();

	java.io.File inFile = new java.io.File(inDirName, inFileName);
	java.io.ObjectInputStream o = null;

	try {
		
	java.io.FileInputStream inFileStream = new java.io.FileInputStream(inFile);
	o = new java.io.ObjectInputStream(inFileStream);
	
	} catch (java.io.IOException e) {
		System.out.println("*** ERROR - cannot open file:" + inDirName + inFileName);
		handleException(e);
		return;
	}

	system.ATsystem inSys = null;
	
	try {
		inSys = (system.ATsystem)o.readObject();
	} catch (java.io.IOException e) {
		System.out.println("*** ERROR - cannot read from file:" + inDirName + inFileName);
		e.printStackTrace(System.out);
		handleException(e);
		return;
	} catch (java.lang.ClassNotFoundException e) {
		System.out.println("*** ERROR - bad data in file:" + inDirName + inFileName);
		handleException(e);
		return;
	}

	sys = inSys;
	getUseCasePanel().setUseCases(sys.getUseCasesVector());
	this.repaint();
*/
}
/**
 * This method was created in VisualAge.
 */
protected void loadMAML() {
	JFileChooser d = new JFileChooser();
	d.setCurrentDirectory(new File(".\\Workshop"));
	int result = d.showOpenDialog(this);

	if(result == JFileChooser.APPROVE_OPTION) {

		String inFileName = d.getSelectedFile().getPath();

		TextWindow display = new TextWindow(this,300,375);
		display.append("Opening - " + d.getSelectedFile().getName() + "\n");
		
		StringTokenizer tokens = new StringTokenizer(inFileName, "-.");

		// read MAML string from file //

		System.out.println("Reading MAML String from file");
		display.append("  * Reading MAML String from file\n");
		String MAML = new String();
		boolean firstLine = true;

		int ct=0;
		try	{
			/*BufferedReader in = new BufferedReader(new FileReader(inFileName));
			String str;
			while ((str = in.readLine()) != null) {
				// strip off anything before the first < character //
				if (firstLine) {
					firstLine = false;
					while (str.charAt(0) != '<') str = str.substring(1);
				}
				MAML = MAML + str;
				
			}*/

			// This algorithm is MUCH faster than the string append function above.
			//  (The above algorithm is O(n^2) where this one is O(n), making it
			//   noticeably faster by 10 - 200+ times depending on file size!)
			BufferedInputStream in = new BufferedInputStream(new DataInputStream(new FileInputStream(inFileName)));
			int len = in.available();
			byte[] maml = new byte[len];
			
			for(int i=0; i<len; i++) {
				in.read(maml,i,1);
			}
			MAML = new String(maml);
			
			in.close();
		} catch (IOException e)	{
			System.out.println("*** ERROR - cannot open file:" + inFileName);
			display.append("\n\n*** ERROR - cannot open file:" + inFileName);
			handleException(e);
			return;
		}

		//System.out.println("MAML is: \n" + MAML);
		System.out.println("Sending MAML to constructor.");
		display.append("  * Sending MAML to constructor.\n");
		sys = new ATsystem(version,MAML,display);
		setSystem(sys);
		getUseCasePanel().setUseCases(sys.getUseCasesVector());
		getUseCasePanel().setList2Empty();
		ivjATTabbedPane.setSelectedIndex(0);
//		getUseCasePanel().getJList2().setSelectedIndex(-1);

		display.dispose();
		this.repaint();
	}
}
/**
 * main entrypoint - starts the part when it is run as an application
 * @param args java.lang.String[]
 */
public static void main(java.lang.String[] args) {
	try {
		//initialize
		ATeditor aATeditor;
		aATeditor = new ATeditor();
		try {
			Class aCloserClass = Class.forName("com.ibm.uvm.abt.edit.WindowCloser");
			Class parmTypes[] = { java.awt.Window.class };
			Object parms[] = { aATeditor };
			java.lang.reflect.Constructor aCtor = aCloserClass.getConstructor(parmTypes);
			aCtor.newInstance(parms);
		} catch (java.lang.Throwable exc) {};
		aATeditor.setVisible(true);
	} catch (Throwable exception) {
		System.err.println("Exception occurred in main() of com.sun.java.swing.JFrame");
		exception.printStackTrace(System.out);
	}
}
public void mouseClicked(java.awt.event.MouseEvent e) {
}
/**
 * This method was created in VisualAge.
 */
public void mouseDragged(java.awt.event.MouseEvent e) {
	//get current x and y position
	x = e.getX();
	y = e.getY();
	//if the source is one of the following,
	if (((e.getSource()) == (getAgentDiagramPage()))
		|| ((e.getSource()) == (getInitiatorPage()))
		|| ((e.getSource()) == (getResponderPage()))
		|| ((e.getSource()) == (getAgentPage()))
		|| ((e.getSource()) == (getCompDiag()))
		|| ((e.getSource()) == (getRolePanel()))
		|| ((e.getSource()) == (getTaskDiagram()))
		|| ((e.getSource()) == (getGoalPanel()))
		|| ((e.getSource()) == (getSeqDiagPanel()))
		|| ((e.getSource()) == (getDeploymentPanel()))
		) 
	{
		connMouseDragged();
	} else { //source = component architecture, so we must find it in the vector
		Enumeration archs = archVector.elements();
		ATcompScrollPane next;
		while (archs.hasMoreElements()){
			next = (ATcompScrollPane)archs.nextElement();
			if(getATTabbedPane().getSelectedComponent() instanceof Editor.ATcompScrollPane){
				if((ATcompScrollPane)(getATTabbedPane().getSelectedComponent())==next){
					currentPanel = next.getarchPanel();
					connMouseDragged();
				}
			}
		}
	}
	repaint();
}
public void mouseEntered(java.awt.event.MouseEvent e) {
}
public void mouseExited(java.awt.event.MouseEvent e) {
}
public void mouseMoved(java.awt.event.MouseEvent e) {
}
/**
 * Method to handle events for the MouseListener interface.
 * @param e java.awt.event.MouseEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public synchronized void mousePressed(java.awt.event.MouseEvent e) {
	// user code begin {1}
	x = e.getX();
	y = e.getY();
	inPanel = false;
	//Set current panel depending on where mouse was pressed
	if (e.getSource() == getAgentDiagramPage()) {
		currentPanel = getAgentDiagramPage();
		inPanel = true;
	} else if ((e.getSource()) == (getInitiatorPage())) {
		currentPanel = getInitiatorPage();
		inPanel = true;
	} else if ((e.getSource()) == (getResponderPage())) {
		currentPanel = getResponderPage();
		inPanel = true;
	} else if ((e.getSource()) == (getAgentPage())) {
		currentPanel = getAgentPage();
		inPanel = true;
	} else if ((e.getSource()) == (getCompDiag())){
		currentPanel = getCompDiag();
		inPanel = true;
	} else if ((e.getSource()) == (getRolePanel())){
		currentPanel = getRolePanel();
		inPanel = true;
	} else if ((e.getSource()) == (getTaskDiagram())){
		currentPanel = getTaskDiagram();
		inPanel = true;
	} else if ((e.getSource()) == (getGoalPanel())){
		currentPanel = getGoalPanel();
		inPanel = true;
	} else if ((e.getSource()) == (getUseCasePanel())){
	} else if ((e.getSource()) == (getSeqDiagPanel())){
		currentPanel = getSeqDiagPanel();
		inPanel = true;
	} else if ((e.getSource()) == (getDeploymentPanel())){
		currentPanel = getDeploymentPanel();
		inPanel = true;
	} else {
		//find selected architecture
		Enumeration archs = archVector.elements();
		ATcompScrollPane next;
		while (archs.hasMoreElements()){
			next = (ATcompScrollPane)archs.nextElement();
			if(getATTabbedPane().getSelectedComponent() instanceof Editor.ATcompScrollPane){
				if((ATcompScrollPane)(getATTabbedPane().getSelectedComponent())==next){
					currentPanel = next.getarchPanel();
					inPanel = true;
				}
			}
		}
	}
	connMouseDown();
	selected();
	
}
/**
 * Method to handle events for the MouseListener interface.
 * @param e java.awt.event.MouseEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public synchronized void mouseReleased(java.awt.event.MouseEvent e) {
	// get current x and y position
	x = e.getX();
	y = e.getY();
	//if source is one of the following
	if (((e.getSource()) == (getAgentDiagramPage())) 
		|| ((e.getSource()) == (getInitiatorPage()))
		|| ((e.getSource()) == (getResponderPage()))
		|| ((e.getSource()) == (getAgentPage()))
		|| ((e.getSource()) == (getCompDiag()))
		|| ((e.getSource()) == (getRolePanel()))
		|| ((e.getSource()) == (getTaskDiagram()))
		|| ((e.getSource()) == (getGoalPanel()))
		|| ((e.getSource()) == (getSeqDiagPanel()))
		|| ((e.getSource()) == (getDeploymentPanel()))
		) 
	{
		connMouseUp();
	} else {
		//check to see if souce is one of the architectures
		Enumeration archs = archVector.elements();
		ATcompScrollPane next;
		while (archs.hasMoreElements()){
			next = (ATcompScrollPane)archs.nextElement();
			if(getATTabbedPane().getSelectedComponent() instanceof Editor.ATcompScrollPane){
				if((ATcompScrollPane)(getATTabbedPane().getSelectedComponent())==next){
					currentPanel = next.getarchPanel();
					connMouseUp();
				}
			}
		}
	}
	this.repaint();
}
public int print(Graphics g, PageFormat pf, int pageIndex)
  throws PrinterException 
  {
	if(!currentPanel.fullsize) {
		if(pageIndex < 1) {
			currentPanel.printPage(g, pageIndex, printImage);
			return Printable.PAGE_EXISTS;
		}
		else { return Printable.NO_SUCH_PAGE; }
	}
	else {
		if(pageIndex<c[2]) {
		//System.out.println("Printing page "+pageIndex+" of "+(c[2]-1));
		currentPanel.printPage(g, pageIndex, printImage);
		return Printable.PAGE_EXISTS;
		}
		else { return Printable.NO_SUCH_PAGE; }
	}
  }  
	protected void processWindowEvent(WindowEvent e) {
		super.processWindowEvent(e);

		if (e.getID() == WindowEvent.WINDOW_CLOSING) {
			System.exit(0);
		}
	}
/**
 * This method was created in VisualAge.
 */
public void receiveObject(ATobject t) {
   if (t instanceof system.ATsystem) {
	sys = (ATsystem)t;
	this.repaint();
   }
   if (t instanceof system.ATconversation) {
	currentlySelectedObject = (ATconversation)t;
	this.repaint();
   }
   
}
/**
 * Insert the method's description here.
 * Creation date: (12/16/99 10:43:25 AM)
 * @param index int
 */
 //removes all architecures from the archVector that are greater than the index
public int removeAllArchs() {
	int x = archVector.size();
	ATcompScrollPane test;
	int ts = getATTabbedPane().getSelectedIndex();
	int ti = 0;
	
	for(int i=x-1;i>=0; i--){
		test = (ATcompScrollPane)archVector.get(i);
		//check to make sure TabbedPane is not currently on test
		if(test != getATTabbedPane().getSelectedComponent()){
			ti = getATTabbedPane().indexOfComponent(test);
			getATTabbedPane().remove(test);
			archVector.removeElementAt(i);
			System.out.println(ti + " / " + ts);	
			if(ti < ts) getATTabbedPane().setSelectedIndex(--ts);
		}
	}

	return ts;
}
/**
 * Insert the method's description here.
 * Creation date: (12/16/99 10:43:25 AM)
 * @param index int
 */
 //removes all architecures from the archVector whom are after the current selected tab
 
public int removeArchs(int tabIndex) {
	if(tabIndex != getATTabbedPane().getTabCount()){
		int index = archVector.indexOf(getATTabbedPane().getComponentAt(tabIndex));
		
		int ti = 0;
		
		int x = archVector.size();
		ATcompScrollPane test;

		for(int i=x-1; i > index; i--){
			test = (ATcompScrollPane)archVector.get(i);
			
			//check to make sure TabbedPane is not currently on test
			if(test != getATTabbedPane().getSelectedComponent()){
				ti = getATTabbedPane().indexOfComponent(test);
				getATTabbedPane().remove(test);
				archVector.removeElementAt(i);
				
				if(ti < tabIndex-1) getATTabbedPane().setSelectedIndex((--tabIndex)-1);
			}
		}
	}
	
	return tabIndex;
}
/**
 * Insert the method's description here.
 * Creation date: (1/6/00 2:08:02 PM)
 * @param index int
 */
private void removeTabsFrom(int index) {
	//removes tabs that have index greater or equal to than "index"
	int size = getATTabbedPane().getTabCount();
	
	for(int j=index; j<size; j++){
		getATTabbedPane().removeTabAt(index);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (6/8/00 11:31:22 AM)
 */
public void reset() {
/*	jscrollpane1 = null;
	jscrollpane2 = null;
	jscrollpane3 = null;
	jscrollpane4 = null;
	jscrollpane5 = null;
	jscrollpane6 = null;
	jscrollpane7 = null;
	jscrollpane8 = null;*/
//	getATTabbedPane() = null;}
}
protected void saveDataDict() {
	JFileChooser d = new JFileChooser();
	d.setCurrentDirectory(new File(".\\Workshop"));
	int result = d.showSaveDialog(this);
	if(result == JFileChooser.APPROVE_OPTION) {
		String outFileName = d.getSelectedFile().getName();
		try {
			FileOutputStream outFileStream = new FileOutputStream(outFileName);
			PrintWriter o = new PrintWriter(outFileStream);
	
			sys.encodeDataDict();
			o.write(sys.getDATA());
			o.close();
		} catch (java.io.IOException e) {
			System.out.println("*** ERROR - cannot save to file:" + outFileName);
			e.printStackTrace(System.out);
			handleException(e);
			return;
		}
	}

/*	java.awt.FileDialog saveDialog = new java.awt.FileDialog(this, "Save System", java.awt.FileDialog.SAVE);
	saveDialog.show();

	String outFileName = saveDialog.getFile();
	String outDirName = saveDialog.getDirectory();

	// strip off old MAML version if there is one
	if (outFileName.lastIndexOf("-v") > 0)
		outFileName = outFileName.substring(0, outFileName.lastIndexOf("-v"));
	// add .txt to end if needed
	if (outFileName.lastIndexOf(".txt") < 0)
		outFileName = outFileName + ".txt";
		
	// create new filename 
	File outFile = new File(outDirName, outFileName);

	try {
		// open the file as a PrintWriter (text file)
		FileOutputStream outFileStream = new FileOutputStream(outFile);
		PrintWriter o = new PrintWriter(outFileStream);
	
	sys.encodeDataDict();
	o.write(sys.getDATA());
	o.close();
	// test line
	} catch (java.io.IOException e) {
		System.out.println("*** ERROR - cannot save to file:" + outDirName + outFileName);
		e.printStackTrace(System.out);		
		handleException(e);
		return;
	}
*/
}
protected void saveFile() {
	JFileChooser d = new JFileChooser();
	d.setCurrentDirectory(new File(".\\Workshop"));
	int result = d.showSaveDialog(this);
	if(result == JFileChooser.APPROVE_OPTION) {
		String outFileName = d.getSelectedFile().getName();
		try {
			// open the file as a PrintWriter (text file)
			// test line
			sys.getMAML();
			
			FileOutputStream outFileStream = new FileOutputStream(outFileName);
			ObjectOutputStream o = new ObjectOutputStream(outFileStream);
			
			o.writeObject(sys);
			o.close();
		} catch (java.io.IOException e) {
			System.out.println("*** ERROR - cannot save to file:" + outFileName);
			e.printStackTrace(System.out);
			handleException(e);
			return;
		} catch (Exception e) {
			System.out.println("*** ERROR - Exception in execution, cannot save file.");
			e.printStackTrace(System.out);
			handleException(e);
			return;
		}
	}

/*	java.awt.FileDialog saveDialog = new java.awt.FileDialog(this, "Save System", java.awt.FileDialog.SAVE);
	saveDialog.show();
	String outFileName = saveDialog.getFile();
	String outDirName = saveDialog.getDirectory();

	java.io.File outFile = new java.io.File(outDirName, outFileName);

	try {
		
	java.io.FileOutputStream outFileStream = new java.io.FileOutputStream(outFile);
	java.io.ObjectOutputStream o = new java.io.ObjectOutputStream(outFileStream);
	o.writeObject(sys);
	// test line
	sys.encodeMAML();
	} catch (java.io.IOException e) {
		System.out.println("*** ERROR - cannot save to file:" + outDirName + outFileName);
		e.printStackTrace(System.out);		
		handleException(e);
		return;
	}
*/
}
/*
* saveMAML()
*
* Author: Mark Raphael	March 2000
*
* Updates: rebuilt for Swing component JFileChooser
*            - added "cancel" functionality to eliminate error
*
*	4 August 2000	SAD
*		Changed output file type to PrinterWriter to allow it to save strings longer than
*		65535.  Also added logic to strip off old version before adding the new MAML version.
*/

protected void saveMAML() {
	JFileChooser d = new JFileChooser();
	d.setCurrentDirectory(new File(".\\Workshop"));
	int result = d.showSaveDialog(this);
	if(result == JFileChooser.APPROVE_OPTION) {
		String outFileName = d.getSelectedFile().getPath();
		
		if (outFileName.lastIndexOf("-v") > 0)
		outFileName = outFileName.substring(0, outFileName.lastIndexOf("-v"));

		// add new MAML version and extension
		outFileName = outFileName + "-v" + Double.toString(sys.getVersion()) + ".maml";
		
		try {
			// open the file as a PrintWriter (text file)
			sysMsg("Saving MAML file...");

			String s = sys.getMAML();

			FileOutputStream outFileStream = new FileOutputStream(outFileName);
			PrintWriter o = new PrintWriter(outFileStream);
			
						// print string and close file
			o.print(s);
			o.close();

			sysMsg("... Save Complete");

		} catch (java.io.IOException e) {
			System.out.println("*** ERROR - cannot save to file:" + outFileName);
			sysMsg("... Error Saving!  IOException");
			e.printStackTrace(System.out);
			handleException(e);
			return;
		} catch (Exception e) {
			System.out.println("*** ERROR - Exception in execution, cannot save file.");
			sysMsg("... Error Saving!");
			e.printStackTrace(System.out);
			return;
		}
	}
	
	
	
/*	java.awt.FileDialog saveDialog = new java.awt.FileDialog(this, "Save System", java.awt.FileDialog.SAVE);
	saveDialog.show();

	//The selected name is modified by adding the version number and MAML extension

	// get the filename from a dialog box
	String outFileName = saveDialog.getFile();

	// strip off old MAML version if there is one
	if (outFileName.lastIndexOf("-v") > 0)
		outFileName = outFileName.substring(0, outFileName.lastIndexOf("-v"));

	// add new MAML version and extension
	outFileName = outFileName + "-v" + Double.toString(sys.getVersion()) + ".maml";

	// get directory name from same box
	String outDirName = saveDialog.getDirectory();

	// create new filename 
	File outFile = new File(outDirName, outFileName);

	try {
		// open the file as a PrintWriter (text file)
		FileOutputStream outFileStream = new FileOutputStream(outFile);
		PrintWriter o = new PrintWriter(outFileStream);

		// create MAML string
		sys.encodeMAML();
		String s = sys.getMAML();

		// print string and close file
		o.print(s);
		o.close();
	} catch (java.io.IOException e) {
		System.out.println("*** ERROR - cannot save to file:" + outDirName + outFileName);
		e.printStackTrace(System.out);
		handleException(e);
		return;
	}
*/
}
/**
 * This method was created in VisualAge.
 */
protected void selected() {
	int index = getATTabbedPane().getSelectedIndex();
	updateSelectedObject();

	//if currently selected object hasn't changed, return
	if (currentlySelectedObject == lastSelectedObject){ 
		return;
	}
	
	if((getATTabbedPane().getSelectedComponent())!=(getScrollPane11())){   // Deplyoment Panel

		// Temporarily remove this tab for insertion/deletion ease
		getATTabbedPane().remove(getScrollPane11());

		if((getATTabbedPane().getSelectedComponent())==(getScrollPane6())){   // Role Panel
			
			if(currentlySelectedObject != null && currentlySelectedObject instanceof system.ATTask){
				getTaskDiagram().setTask((ATTask)currentlySelectedObject);
				getATTabbedPane().insertTab("Task Panel",null, getScrollPane7(),null,4);
				
			} else {
				getATTabbedPane().remove(getScrollPane7());
			}
	
				
		} else if((getATTabbedPane().getSelectedComponent())==(getScrollPane1())){
			//if we're on the agent diagram page
			
			//lastSelectedObject2 = currentlySelectedObject;
			//lastSelectedObject = currentlySelectedObject;
	
			// remove the agent page and architectures and Component State Diagram
			// remove the initiator and responder pages
	
			getATTabbedPane().remove(getScrollPane2());
			getATTabbedPane().remove(getScrollPane3());
			getATTabbedPane().remove(getScrollPane4());
			getATTabbedPane().remove(getScrollPane5());
			index = removeAllArchs();
					
	
			if (currentlySelectedObject != null) {
				
				//if an agent is currently selected
				if (currentlySelectedObject instanceof system.ATagent) {
					//add in the agent page
					lastSelectedAgent = currentlySelectedObject;
			
					getAgentPage().setAgent((system.ATagent)currentlySelectedObject);
					getATTabbedPane().addTab(getAgentDiagramPage().getSelectedObjectName(), getScrollPane2());
					agent_last = (system.ATagent)currentlySelectedObject;
				//	return;
				}
	
				//if a conversation is currently selected
				else if (currentlySelectedObject instanceof system.ATconversation) {
	
					lastSelectedConv = currentlySelectedObject;
					//add the initiator page and responder page
					getATTabbedPane().addTab(getAgentDiagramPage().getSelectedObjectName() + " Initiator",getScrollPane3());//getInitiatorPage());
					getATTabbedPane().addTab(getAgentDiagramPage().getSelectedObjectName() + " Responder",getScrollPane4());//ResponderPage());
					//set their conversations
					getResponderPage().setConversation((ATconversation)lastSelectedConv,2);
					getInitiatorPage().setConversation((ATconversation)lastSelectedConv,1);
				}
	
			}
			
		} else {
			// if nothing recognized above is selected but something was selected before
			
			int ti = getATTabbedPane().indexOfComponent(getScrollPane5());
			if(ti != index){ 
				if(ti>0) {
					getATTabbedPane().remove(getScrollPane5());
					if(ti < index) getATTabbedPane().setSelectedIndex(--index);
				}
				
				//if (lastSelectedObject != null)	{
				index = removeArchs(index);
				//}
			}
			
			if (currentlySelectedObject != null && currentlySelectedObject instanceof system.ATagentComponent) {
	
				lastSelectedComp = currentlySelectedObject;
				Enumeration archs = archVector.elements();
				ATcompScrollPane next = null;
				
				//set the component for the component diagram
				getCompDiag().setComponent((system.ATagentComponent)currentlySelectedObject);//(ATagentComponent)getAgentPage().getSelectedObject());
			
				//if it has a sub architecture
				if(((system.ATagentComponent)currentlySelectedObject).gethasSub()) {
					next = addArch();
					getATTabbedPane().addTab(((system.ATagentComponent)currentlySelectedObject).getName() + " Architecture",next);
				}

				//set the component diagram's component
				getCompDiag().setComponent((system.ATagentComponent)currentlySelectedObject);
				getATTabbedPane().addTab(((system.ATagentComponent)currentlySelectedObject).getName() + " : Component State Diag",getScrollPane5());//getCompDiag());
			}		
		}

		getATTabbedPane().addTab("Deployment", getScrollPane11());
	}

	/*
	//if currently selected object = last selected object 2 (the currently selected object
	//of the agent diagram page) 

	if (lastSelectedObject2 != null && currentlySelectedObject == lastSelectedObject2) {
	
		//if the last selected object 3 is an agent component
		if(lastSelectedObject3 != null &&
			(lastSelectedObject3.getClass().getName().equals("system.ATagentComponent"))) {

			if(getATTabbedPane().indexOfComponent(getScrollPane5()) < index)
				getATTabbedPane().setSelectedIndex(index-1);
			
			// remove all agent associated tabs...
					
			getATTabbedPane().remove(getScrollPane2());
			getATTabbedPane().remove(getScrollPane3());
			getATTabbedPane().remove(getScrollPane4());
			getATTabbedPane().remove(getScrollPane5());
			removeAllArchs();
		
		}
		
		return;
		
	}
*/		
	
			
/*	if((lastSelectedObject!=null) && (lastSelectedObject.getClass().getName().equals("system.ATTask"))){

		if(getATTabbedPane().indexOfComponent(getScrollPane7()) < index)
			getATTabbedPane().setSelectedIndex(index-1);
		getATTabbedPane().remove(getScrollPane7());
		
	}
*/
}
/**
 * This method was created in VisualAge.
 */
private void setSelectedObject(ATobject temp) {
	lastSelectedObject = currentlySelectedObject;
	currentlySelectedObject = temp;
}
/**
 * Insert the method's description here.
 * Creation date: (1/19/01 2:20:52 PM)
 */
public void setSystem(ATsystem sys) {
	this.sys = sys;
	getAgentDiagramPage().setSys(sys);
	getInitiatorPage().setSys(sys);
	getResponderPage().setSys(sys);
	getAgentPage().setSys(sys);
	getCompDiag().setSys(sys);
	getRolePanel().setSys(sys);
	getGoalPanel().setSys(sys);
	getUseCasePanel().setSys(sys);
	getSeqDiagPanel().setSys(sys);
	getTaskDiagram().setSys(sys);
	getDeploymentPanel().setSys(sys);
}
/**
 * Insert the method's description here.
 * Creation date: (11/30/00 5:50:31 PM)
 * @param t system.ATTask
 * @param trans system.ATtransition
 */
public void showComponentTransition(ATagent a, ATagentComponent c, ATstatetable st, ATtransition trans) {
	// deselect all components
	Enumeration e = a.returnComponents();
	while(e.hasMoreElements()){
		ATagentComponent comp = (ATagentComponent)e.nextElement();
		comp.Selected = false;
	}
	setSelectedObject(trans);
	
	lastSelectedAgent = a;
	agent_last = a;
		
	getATTabbedPane().remove(getScrollPane5());
	removeAllArchs();
	getATTabbedPane().remove(getScrollPane2());
	getATTabbedPane().remove(getScrollPane3());
	getATTabbedPane().remove(getScrollPane4());
	
	a.Selected = true;
	c.Selected = true;

	getAgentPage().setAgent(a);
	getAgentDiagramPage().setSelectedObject(a);
	int i = getATTabbedPane().indexOfComponent(getScrollPane1());
	getATTabbedPane().insertTab(getAgentDiagramPage().getSelectedObjectName(), null, getScrollPane2(), null, i+1);
	
	getCompDiag().setComponent(c);
	getATTabbedPane().insertTab(c.getName(), null, getScrollPane5(), null, i+2);

	try{
		Thread.sleep(10);
	}catch(Exception ex){}

	getATTabbedPane().setSelectedComponent(getScrollPane5());
	currentPanel = getCompDiag();

	trans.Selected = true;
		
	repaint();
	//currentPanel.repaint();
}
/**
 * Insert the method's description here.
 * Creation date: (11/30/00 5:50:31 PM)
 * @param t system.ATTask
 * @param trans system.ATtransition
 */
public void showTaskTransition(ATTask t, ATtransition trans) {
	// deselect all tasks
	Enumeration e = sys.returnTasks();
	while(e.hasMoreElements()){
		ATTask task = (ATTask)e.nextElement();
		task.Selected = false;
	}
	
	setSelectedObject(trans);
	
	getTaskDiagram().setTask(t);
	getATTabbedPane().remove(getScrollPane7());

	try{
		Thread.sleep(100);
	}catch(Exception ex){}

	getATTabbedPane().insertTab("Task Panel", null, getScrollPane7(), null, 4);
	
	getATTabbedPane().setSelectedComponent(getScrollPane7());
	currentPanel = getTaskDiagram();
	trans.Selected = true;
	t.Selected = true;
	
	repaint();
	currentPanel.repaint();
	
	try{
		Thread.sleep(100);
	}catch(Exception ex){}

}
/**
 * This method was created in VisualAge.
 * @param e com.sun.java.swing.event.ChangeEvent
 */
public void stateChanged(ChangeEvent e) {
	selected();
	if ((e.getSource() == getATTabbedPane()) ) {
	
		cancelAllOps();
		
		getButtonOne().setEnabled(true);
		getButtonTwo().setEnabled(true);
		if (getATTabbedPane().getSelectedComponent() == getScrollPane1())
		{
			getButtonOne().setText("Add Agent");
			getButtonOne().setMnemonic(KeyEvent.VK_A);
			getButtonTwo().setText("Add Conv");
			getButtonTwo().setMnemonic(KeyEvent.VK_C);
			getButtonOne().setVisible(true);
			getButtonTwo().setVisible(true);
			getButtonThree().setVisible(false);
			
			currentPanel = getAgentDiagramPage();
			currentPanel.initPanel(sys);

		} else if (getATTabbedPane().getSelectedComponent() == getScrollPane3() ||
		           getATTabbedPane().getSelectedComponent() == getScrollPane4() ||
		           getATTabbedPane().getSelectedComponent() == getScrollPane5() ||
		           getATTabbedPane().getSelectedComponent() == getScrollPane7()){
			getButtonOne().setText("Add State");
			getButtonOne().setMnemonic(KeyEvent.VK_S);
			getButtonTwo().setText("Add Trans");
			getButtonTwo().setMnemonic(KeyEvent.VK_A);
			getButtonOne().setVisible(true);
			getButtonTwo().setVisible(true);
			getButtonThree().setVisible(false);

			if (getATTabbedPane().getSelectedComponent() == getScrollPane3()) {
				currentPanel = getInitiatorPage();
			} else if (getATTabbedPane().getSelectedComponent() == getScrollPane4()){
				currentPanel = getResponderPage();
			} else if (getATTabbedPane().getSelectedComponent() == getScrollPane5()){
				currentPanel = getCompDiag();
			} else if (getATTabbedPane().getSelectedComponent() == getScrollPane7()){
				currentPanel = getTaskDiagram();
			}
				
		} else if (getATTabbedPane().getSelectedComponent() == getScrollPane2()){
			getButtonOne().setText("Add Component");
			getButtonOne().setMnemonic(KeyEvent.VK_C);
			getButtonTwo().setText("Add Connection");
			getButtonTwo().setMnemonic(KeyEvent.VK_A);
			getButtonOne().setVisible(true);
			getButtonTwo().setVisible(true);
			getButtonThree().setVisible(false);		
			
			currentPanel = getAgentPage();
			currentPanel.initPanel((ATagent)(getAgentDiagramPage().getSelectedObject()));
		} else if (getATTabbedPane().getSelectedComponent() == getScrollPane6()){
			getButtonOne().setText("Add Role");
			getButtonOne().setMnemonic(KeyEvent.VK_R);
			getButtonTwo().setText("Add Task");
			getButtonTwo().setMnemonic(KeyEvent.VK_A);
			getButtonThree().setText("AddProtocol");
			getButtonThree().setMnemonic(KeyEvent.VK_P);
			getButtonOne().setVisible(true);
			getButtonTwo().setVisible(true);
			getButtonThree().setVisible(true);

			currentPanel = getRolePanel();
			currentPanel.initPanel(sys);
		} else if (getATTabbedPane().getSelectedComponent() == getScrollPane8()){
			getButtonOne().setText("Add Goal");
			getButtonOne().setMnemonic(KeyEvent.VK_G);
			getButtonOne().setVisible(true);
			getButtonTwo().setVisible(false);
			getButtonThree().setVisible(false);
			currentPanel = getGoalPanel();
		} else if (getATTabbedPane().getSelectedComponent() == getScrollPane9()){
			getButtonOne().setText("Add Use Case");
			getButtonOne().setMnemonic(KeyEvent.VK_A);
			getButtonOne().setVisible(true);
			getButtonTwo().setText("Delete Use Case");
			getButtonTwo().setMnemonic(KeyEvent.VK_D);
			getButtonTwo().setVisible(true);
			getButtonThree().setVisible(false);
			currentPanel = getUseCasePanel();
		} else if (getATTabbedPane().getSelectedComponent() == getScrollPane10()){
			getButtonOne().setText("Add Role");
			getButtonOne().setMnemonic(KeyEvent.VK_R);
			getButtonOne().setVisible(true);
			getButtonTwo().setText("Add Message");
			getButtonTwo().setMnemonic(KeyEvent.VK_M);
			getButtonTwo().setVisible(true);
			getButtonThree().setVisible(false);
			currentPanel = getSeqDiagPanel();
			if(getSeqDiagPanel().seqDiag == null){
				getButtonOne().setEnabled(false);
				getButtonTwo().setEnabled(false);
			}
		} else if (getATTabbedPane().getSelectedComponent() == getScrollPane11()){
			getButtonOne().setText("Add Agent");
			getButtonOne().setMnemonic(KeyEvent.VK_A);
			getButtonOne().setVisible(true);
			getButtonTwo().setText("Add Conversation");
			getButtonTwo().setMnemonic(KeyEvent.VK_C);
			getButtonTwo().setVisible(true);
			getButtonThree().setText("Add System");
			getButtonThree().setMnemonic(KeyEvent.VK_S);
			getButtonThree().setVisible(true);
			currentPanel = getDeploymentPanel();
			currentPanel.initPanel(sys);
		} else {
			Enumeration archs = archVector.elements();
			ATcompScrollPane next;
			while (archs.hasMoreElements()){
				next = (ATcompScrollPane)archs.nextElement();
				if(getATTabbedPane().getSelectedComponent() instanceof Editor.ATcompScrollPane){
					if((ATcompScrollPane)(getATTabbedPane().getSelectedComponent())==next){
						currentPanel = next.getarchPanel();	
						getButtonOne().setText("Add Component");
						getButtonOne().setMnemonic(KeyEvent.VK_C);
						getButtonTwo().setText("Add Connection");
						getButtonTwo().setMnemonic(KeyEvent.VK_N);
						getButtonOne().setVisible(true);
						getButtonTwo().setVisible(true);
						getButtonThree().setVisible(false);	
					}
				}
			}
		}
	}
	repaint();
//	update();
//	currentPanel.repaint();
}
public void sysMsg(String msg) {
	
	getSysMsgArea().append(msg + "\n");
}
	//- - - - - - - - - - - - - - -
	// Draw objects on panel
	//- - - - - - - - - - - - - - -
	public synchronized void update(Graphics g) {
		/*JScrollPane current = (JScrollPane)getATTabbedPane().getSelectedComponent();
	//find which panel is currently being displayed by the tabbed pane, and update that panel
		if(current==(getScrollPane1())){//AgentDiagramPage
			getAgentDiagramPage().update(sys,g);
		} else
		if(current==(getScrollPane4())){//ResponderPage
			getResponderPage().setInitOrResp(2);
			getResponderPage().update(g);
		} else
		if(current==(getScrollPane3())){//InitiatorPage
			getInitiatorPage().setInitOrResp(1);
			getInitiatorPage().update(g);
		} else
		if(current==(getScrollPane5())){//CompDiag
			getCompDiag().setInitOrResp(0);
			getCompDiag().update(g);
		} else
		if(current==(getScrollPane2())){//AgentPage
			getAgentPage().update(g);
		} else
		if(current==(getScrollPane6())){//RolePanel
			getRolePanel().update(sys,g);
		} else
		if(current==(getScrollPane7())){
			getTaskDiagram().setInitOrResp(0);
			getTaskDiagram().update(g);
		} else
		if(current==(getScrollPane8())){
			getGoalPanel().update(sys,g);
		} else
		if(current==(getScrollPane9())){
	//		getScrollPane9().update(g);
		} else
		if(current==(getScrollPane10())){
			getSeqDiagPanel().update(g);
		} else
		if(current==(getScrollPane11())){
			getDeploymentPanel().update(sys,g);
		} else
		if (archVector != null){
			Enumeration archs = archVector.elements();
			ATcompScrollPane next;
			while (archs.hasMoreElements()){
				next = (ATcompScrollPane)archs.nextElement();
				if(getATTabbedPane().getSelectedComponent() instanceof Editor.ATcompScrollPane){
					if((ATcompScrollPane)(getATTabbedPane().getSelectedComponent())==next){
						next.getarchPanel().update(g);
						return;
					}
				}
			}
		}
		*/
		super.update(g);
	}
/**
 * This method was created in VisualAge.
 */
private void updateSelectedObject() {
	lastSelectedObject = currentlySelectedObject;
	currentlySelectedObject = null;
			

	if((JScrollPane)(getATTabbedPane().getSelectedComponent())==(getScrollPane1())){//(getAgentDiagramPage
		if (getAgentDiagramPage().selected != null){
			currentlySelectedObject = getAgentDiagramPage().getSelectedObject();
			getCurrentObjectField().setText(getAgentDiagramPage().getSelectedObjectName());
		}
	}
	
	else if((JScrollPane)(getATTabbedPane().getSelectedComponent())==(getScrollPane2())){
		if(getAgentPage().selected != null && (getAgentPage().selected).equals("component")){
			currentlySelectedObject = getAgentPage().getSelectedObject();
		}
	}
	
	else if((JScrollPane)(getATTabbedPane().getSelectedComponent())==(getScrollPane6())){
		if(getRolePanel().selected != null && (getRolePanel().selected).equals("task")){
			currentlySelectedObject = getRolePanel().selectedTask;
		}
	}
	
/*	else if((JScrollPane)(getATTabbedPane().getSelectedComponent())==(getScrollPane8())){
		if((getGoalPanel().selected).equals("goal")){
			currentlySelectedObject = getGoalPanel().selectedGoal;
		} else {
			currentlySelectedObject = null;
		}
	}
*/
	else {	
		Enumeration archs = archVector.elements();
		ATcompScrollPane next;
		while (archs.hasMoreElements()){
			next = (ATcompScrollPane)archs.nextElement();
			if(getATTabbedPane().getSelectedComponent() instanceof Editor.ATcompScrollPane){
				if((ATcompScrollPane)(getATTabbedPane().getSelectedComponent())==next){
					if((next.getarchPanel()).selected != null) {
						currentPanel = next.getarchPanel();
						if((currentPanel.selected).equals("component")){
							currentlySelectedObject = currentPanel.getSelectedObject();
						}
						break;
					}
				}
			}
		}
	}
}
/**
 * This method was created in VisualAge.
 */
public void verifyConversationsSynch()
{
	sysMsg("Verifying...");
	ErrorVector = Verify.VCRun.verify(sys.getVerifyVector(),0);

	// the rest sets up the graphical error display
	java.util.Enumeration Enum = ErrorVector.elements();
	system.ATerror e = null;
	system.ATconversation c;
	system.ATstatetable t = null;
	java.util.Enumeration Convs = sys.returnConvs();
	java.util.Enumeration states;
	java.util.Enumeration transitions;
	system.ATtableElement s;
	system.ATtransition trans;	
	while(Convs.hasMoreElements()){
		c = (system.ATconversation) Convs.nextElement();
		t = c.getStateTable(system.ATsystem.INITIATOR);
		states = t.returnStates();
		while(states.hasMoreElements()){
			s = (system.ATtableElement) states.nextElement();
			s.errorSelected = false;
		}
		transitions = t.returnTrans();
		while(transitions.hasMoreElements()){
			trans = (ATtransition) transitions.nextElement();
			trans.errorSelected = false;
		}
		t = c.getStateTable(system.ATsystem.RESPONDER);
		states = t.returnStates();
		while(states.hasMoreElements()){
			s = (system.ATtableElement) states.nextElement();
			s.errorSelected = false;
		}
		transitions = t.returnTrans();
		while(transitions.hasMoreElements()){
			trans = (ATtransition) transitions.nextElement();
			trans.errorSelected = false;
		}
	}
	
	while (Enum.hasMoreElements())
	{
		Convs = sys.returnConvs();
		e = (system.ATerror) Enum.nextElement();
		if (e.getType() == system.ATerror.DEADLOCK)
		{
			while (Convs.hasMoreElements())
			{
				c = (system.ATconversation) Convs.nextElement();
				if (c.getName().equals(e.getConvName()))
				{
					if (e.getParticipantName().equals("Initiator"))
					{
						t = c.getStateTable(system.ATsystem.INITIATOR);
					}
					else
					{
						t = c.getStateTable(system.ATsystem.RESPONDER);
					}
					transitions = t.returnTrans();
					while (transitions.hasMoreElements())
					{
						trans = (system.ATtransition) transitions.nextElement();
						
						if (trans.getRecMessage().equals(e.getStateTransition()) &&
							trans.getCurrentState().getName().equals(e.getCurrentState()))
						{
							trans.errorSelected = true;
						}
					}
				}
			}
			
		}
		if (e.getType() == system.ATerror.PROGRESS)
		{
			while (Convs.hasMoreElements())
			{
				c = (system.ATconversation) Convs.nextElement();
				if (c.getName().equals(e.getConvName()))
				{
					if (e.getParticipantName().equals("Initiator"))
					{
						t = c.getStateTable(system.ATsystem.INITIATOR);
					}
					else
					{
						t = c.getStateTable(system.ATsystem.RESPONDER);
					}
					states = t.returnStates();
					while (states.hasMoreElements())
					{
						s = (system.ATtableElement) states.nextElement();
						if (s.getName().equals(e.getCurrentState()))
						{
							s.errorSelected = true;
						}
					}
				}
			}
		}
	}
	repaint();
	sysMsg("  Errors highlighted");
	sysMsg("Complete");
}
}
