package Editor;

import system.*;
/**
 * This type was created in VisualAge.
 * The panel that all others extend.
 * @author: Jennifer Mifflin
  *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
public abstract class ATpanel extends JPanel implements ActionListener{

	ATsystem sys = null;
	double version;
	//position of mouse
	int x_pos, y_pos;
	
	//popup menu
	PopupMenu popup;

	//name of object that is currently selected
	String selected = null;
	public static final String NOTHING = "<none>";

	//true if key is being held down
	boolean shift = false;

	//message area
	java.awt.TextArea sysMsgArea = null;

	//if line is not being added linestatus == normal
	protected final int NORMAL = 0;

	//if line is beginning to be added linestatus = wait first point
	protected final int WAIT_FIRST_POINT = 1;

	//if line's second object is being added, linestatus = wait second point
	protected final int WAIT_SECOND_POINT = 2;

	//linestatus = normal, b/c line is not being added until user specifies	
	protected int linestatus = NORMAL;

	protected int change = 0,
				yes = 1,
				no = 0;

	protected int initOrResp = 0,
		   		init = 1,
				resp = 2;

	//Dimension offDimension;
	//Image offImage;
	//Graphics offGraphics;

	//keeps track of whether a new point has been added
	//if so, that point is just dragged
	//newPt is set to 0 every time the mouse is released
	protected int newPt = 0;
	
	protected int psx = 2000, psy = 2000;

	public boolean fullsize = true;
	int PAGEWIDTH = 468;
	int PAGEHEIGHT = 648;
	int user_x, user_y;
	int c[] = {1, 1, 1, 1, 1};

	//helps keep track of what is currently in popup menu
//	protected String previous;  

/**
 * AgentDiagramPanel constructor comment.
 */
public ATpanel(double v) {
	super(true);
//	setMaximumSize(new java.awt.Dimension(700, 700));
	setPreferredSize(new java.awt.Dimension(psx, psy));
	setBounds(0, 0, psx, psy);
	setMinimumSize(new java.awt.Dimension(psx, psy));
	setBackground(Color.white);
	version = v;
}
/**
 * AgentDiagramPanel constructor comment.
 * @param layout java.awt.LayoutManager
 */
public ATpanel(java.awt.LayoutManager layout, double v){
	super(layout,true);
	version = v;
}
/**
 * AgentDiagramPanel constructor comment.
 * @param layout java.awt.LayoutManager
 */
public ATpanel(java.awt.LayoutManager layout, boolean isDoubleBuffered, double v) {
	super(layout,isDoubleBuffered);
	version = v;
}
/**
 * AgentDiagramPanel constructor comment.
 */
public ATpanel(boolean isDoubleBuffered, double v) {
	super(isDoubleBuffered);
	version = v;
}
public void actionPerformed(java.awt.event.ActionEvent event) {
}
/**
 * Insert the method's description here.
 * Creation date: (11/21/00 1:14:08 PM)
 */
public void autoSize(Dimension bounds) {
	int xs = bounds.width;
	int ys = bounds.height;
	if(xs < 2000) xs = 2000;
	if(ys < 2000) ys = 2000;
	
	psx = getSize().width;
	psy = getSize().height;
	
	setPreferredSize(new Dimension(xs,ys));
	setSize(new Dimension(xs,ys));
}
/**
 * Insert the method's description here.
 * Creation date: (2/1/00 9:34:52 AM)
 */
public abstract void clear();
/**
 * Insert the method's description here.
 * Creation date: (2/2/01 5:38:46 PM)
 * @return java.awt.Image
 */
public abstract Image formPrintImage();
/**
 * Insert the method's description here.
 * Creation date: (1/19/01 3:00:35 PM)
 * @return int[]
 */
public abstract int[] getPages();
//returns the currently selected object
public abstract ATobject getSelectedObject();
//returns currently selected object's name
public abstract String getSelectedObjectName();
/**
 * Insert the method's description here.
 * Creation date: (1/26/01 12:29:46 PM)
 * @return java.awt.Dimension
 */
public Dimension getVisibleArea() {
	return new Dimension(2000,2000);
}
/**
 * This method was created in VisualAge.
 */
public abstract void initPanel(system.ATobject object);
//method for handeling mouseDown action 
public abstract boolean mouseDown(int x, int y, system.ATsystem sys);
//method for handling mouseDrag action
public abstract boolean mouseDrag(int x, int y, system.ATsystem sys);
//method for handling mouseDrag action
public abstract boolean mouseUp(int x, int y, system.ATsystem sys);
	/**
	 * Rewrites the paint method.  Used to eliminate flashing
	 * of graphics
	 */
	public void paint(Graphics g) {
		super.paint(g);
	}
/**
 * Insert the method's description here.
 * Creation date: (1/24/01 1:55:01 PM)
 * @param g java.awt.Graphics
 * @param pageIndex int
 * @param c int[]
 */
public abstract void printPage(Graphics g, int pageIndex, Image i);
/**
 * Insert the method's description here.
 * Creation date: (1/8/01 1:45:31 PM)
 * @param sys system.ATsystem
 */
public void setSys(ATsystem sys) {
	this.sys = sys;	
}
/**
 * Sets the system message area to communicate with the user
 */
public void setSysMsgArea(java.awt.TextArea ta) {
	//sets the system Message area
	sysMsgArea = ta;
}
/**
 * Insert the method's description here.
 * Creation date: (2/16/01 1:40:43 PM)
 * @param x int
 */
public void setUserX(int x) {
	user_x = x;
	}
/**
 * Insert the method's description here.
 * Creation date: (2/16/01 1:41:11 PM)
 * @param y int
 */
public void setUserY(int y) {
	user_y = y;
	}
public void sysMsg(String s) {
	//writes s in the system message area
	if (sysMsgArea != null)
		sysMsgArea.append(s + "\n");
}
}
