package Editor;

import javax.swing.*;
/**
 * This type was created in VisualAge.
 * Displays sequence diagrams
 * @author: Jennifer Mifflin
  *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
import system.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
public class SeqDiagPanel extends ATpanel
{
	//MenuItems for popup menus
	private MenuItem roleName;
	private MenuItem roleType;
	private MenuItem messName;
	private MenuItem delete;
	
	ATseqDiag seqDiag;
	ATRole2 selectedRole = null;
	
	final int AddMessage1 = 4;
	final int AddMessage2 = 5;
	
	ATmessage selectedMessage = null;
	ATmessage message;
	
	int LineMaxLength = 1900;
	int lineLength = 350;
	
	boolean lineMove = false;
/**
 * This method was created in VisualAge.
 */
public SeqDiagPanel(double v)
{
	super(v);
	this.enableEvents(AWTEvent.MOUSE_EVENT_MASK);
	this.enableEvents(AWTEvent.MOUSE_MOTION_EVENT_MASK);
	popup = new PopupMenu();
	this.add(popup);
}
/**
 * This method was created in VisualAge.
 */
public void actionPerformed(java.awt.event.ActionEvent event) {
	String command = event.getActionCommand();
	
	//all these commands come from the popup menu.
	//they are pretty self-explanitory
	if(command.equals("roleName")){
		ObjName objN = new ObjName(selectedRole);
		objN.show();

		String cname = selectedRole.getName();
		String cnameL = cname;
		int i=2;
		while(seqDiag.repeatName(cnameL)) {//if not unique
			cnameL = cname + "(" + Integer.toString(i) + ")";
			i++;
		}
		selectedRole.setName(cnameL);
		
		int h;
		int count = 0;
		java.util.Enumeration messages = seqDiag.returnMessages();
		while(messages.hasMoreElements()){
			message = (system.ATmessage)messages.nextElement();
			if(message.getFirstRole()==selectedRole || message.getSecondRole()==selectedRole) {
				//update(this.getGraphics());
				h = message.getHeight();
				message.refresh(count);
				message.setHeight(h);
				message.move(0);
				count++;
			}
		}
		
	} else if(command.equals("roleType")) {
		SelectRole selectRole = new SelectRole(selectedRole, sys);
		selectRole.requestFocus();
		selectRole.show();
		
	} else if(command.equals("spaceLines")) {
		autospace();
	
	} else if(command.equals("RoleLineLength")) {
		int len = selectedRole.getLength();
		len += 200;
		if(len > LineMaxLength) len = LineMaxLength;
		
		java.util.Enumeration roles = seqDiag.returnRoles();
		ATRole2 role;
		while(roles.hasMoreElements()){
			role = (ATRole2)roles.nextElement();
			role.setLength(len);
		}
	
	} else if(command.equals("messName")){
		ObjName objN = new ObjName(selectedMessage);
		objN.show();
	} else if(command.equals("delete")){
		if(selected == "role" || selected == "roleLine"){
			if(selectedRole.hasNoMessages()){
				seqDiag.deleteRole(selectedRole);
			} else {
				sysMsg("remove Messages first");
			}
		} else if(selected == "message") {
			seqDiag.deleteMessage(selectedMessage);
		}
	}

	cancelAddMessage();
	repaint();
	//paint(this.getGraphics());
}
/**
 * Insert the method's description here.
 * Creation date: (6/19/00 10:15:00 AM)
 * @param Num int
 */
public void addMessage() {
	sysMsg("select Role");
	message = new ATmessage(version,sys.getNextKey());
	message.setName("Message " + (seqDiag.messageCount()+1));
	linestatus = AddMessage1;
	adjustLineLength();
}
/**
 * Insert the method's description here.
 * Creation date: (6/16/00 8:40:39 AM)
 */
public void addRole(ATRole2 role) {
	if(seqDiag == null){
		sysMsg("select Sequence Diagram from Use Cases Panel\n");
	} else {
		java.util.Enumeration roles = seqDiag.returnRoles();
		if(roles.hasMoreElements()) {
			selectedRole = (ATRole2)roles.nextElement();
			role.setLength(selectedRole.getLength());
		}
		
		/*String cname = role.getName();
		String cnameL = cname;
		int i=2;
		while(seqDiag.repeatName(cnameL)) {//if not unique
			cnameL = cname + "(" + Integer.toString(i) + ")";
			i++;
		}
		role.setName(cnameL);
		*/
		
		seqDiag.addRole(role);
	}
	//paint(this.getGraphics());
	repaint();
}
/**
 * Insert the method's description here.
 * Creation date: (7/11/00 3:10:29 PM)
 */
public void adjustLineLength() {
	int maxlength = 0;
	int maxmess = 0;
	
	java.util.Enumeration roles = seqDiag.returnRoles();
	ATRole2 role;
	int i = 0;
	while(roles.hasMoreElements()){
		i++;
		role = (ATRole2)roles.nextElement();
		int len = role.getLength();
		int mess = role.returnMessageCount();

		if(len > maxlength) maxlength = len;
		if(mess > maxmess) maxmess = mess;
	}

	if((maxlength / maxmess) < 20*i) maxlength += 200;
	if(maxlength < LineMaxLength) maxlength = LineMaxLength;

	roles = seqDiag.returnRoles();
	while(roles.hasMoreElements()){
		role = (ATRole2)roles.nextElement();
		role.setLength(maxlength);
	}
	
	
	/*//method to adjust the length of the lines according
	//to how many messages are connected to one role
	java.util.Enumeration roles = seqDiag.returnRoles();
	ATRole2 role;
	//set minimun count at 5
	int count = 5;
	//go through the roles and check to see if any has
	//more messages than 5.  If so, set count to that
	//amount and continue
	while(roles.hasMoreElements()){
		role = (ATRole2)roles.nextElement();
		int hold = role.returnMessageCount();
		if(hold >5){
			count = hold;
		}
	}
	//make length appropriate so each message has 60 pts
	int length = 60*count;
	//if the new length is greater than the current length
	if(length>lineLength){
		//go through the roles and adjust the line length
		roles = seqDiag.returnRoles();
		while(roles.hasMoreElements()){
			role = (ATRole2)roles.nextElement();
			role.setLength(length);
		}
		//set the max to 2*length
		LineMaxLength = length*2;
		lineLength = length;
	}*/
}
/**
 * Insert the method's description here.
 * Creation date: (1/12/01 5:32:08 PM)
 */
public void autospace() {

	java.util.Vector roles = seqDiag.returnRoleVector();
	java.util.Vector checkedMessages = new Vector(20);
	ATRole2 role;
	
	int maxmess = 0;
	java.util.Enumeration rolestemp = roles.elements();
	while(rolestemp.hasMoreElements()){
		role = (ATRole2)rolestemp.nextElement();
		int mess = role.returnMessageCount();
		if(mess > maxmess) maxmess = mess;
	}

	int delta = 20;
	int spacing = delta * roles.size();
	if(spacing > (LineMaxLength / maxmess+1)) {
		spacing = LineMaxLength / maxmess+1;
		delta = spacing / roles.size();
	}
	
	for(int i=0; i<roles.size(); i++) {
		role = (ATRole2)roles.elementAt(i);
		int base = role.base();
		java.util.Enumeration messages = role.getMessages();
		ATmessageGRFX mess;
		int j = 0;
		while(messages.hasMoreElements()) {
			mess = (ATmessageGRFX)messages.nextElement();
			if(!checkedMessages.contains(mess)) {
				int h =  base + (delta * i) + (spacing * j);
				mess.setHeight(h);
				checkedMessages.add(mess);
				j++;
			}
		}
	}
	
}
/**
 * Insert the method's description here.
 * Creation date: (11/2/00 2:22:16 PM)
 */
public void cancelAddMessage() {
	if(linestatus != NORMAL) {
		linestatus = NORMAL;
		sysMsg(" <cancel operation>");
	}
}
/**
 * Insert the method's description here.
 * Creation date: (2/1/00 9:35:31 AM)
 */
public void clear() {
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public boolean findSelectedObject(int x, int y) {
	if(selectedRole!=null){
		selectedRole.Selected = false;
	}
	if(selectedMessage != null){
		selectedMessage.Selected = false;
	}
	
	java.util.Enumeration roles = seqDiag.returnRoles();
	java.util.Enumeration messages = seqDiag.returnMessages();
	ATRole2 role1;
	ATmessage message1;
	selected = null;
	
	while (roles.hasMoreElements()) {
		role1 = (system.ATRole2)roles.nextElement();
		if (role1.checkSelected(x, y)) {
			role1.Selected = true;
			selectedRole = role1;
			selected = "role";
			return true;
		} else if(role1.checkLineSelected(x,y)){
			selectedRole = role1;
			selected = "roleLine";
			return true;
		}
	}
	
	while(messages.hasMoreElements()) {
		message1 = (ATmessage)messages.nextElement();
		if(message1.checkSelected(x,y)) {
			message1.Selected = true;
			selectedMessage = message1;
			selected = "message";
			return true;
		}
	}
	
	return false;
}
/**
 * Insert the method's description here.
 * Creation date: (2/2/01 4:09:02 PM)
 * @return java.awt.Image
 * @param i java.awt.Image
 * @param g java.awt.Graphics
 */
public Image formPrintImage() {
		java.util.Enumeration roles = seqDiag.returnRoles();
		java.util.Enumeration messages = seqDiag.returnMessages();

		Image i = createImage(c[3]+5, c[4]+5);//creates an image with the panel's width and height
		Graphics g = i.getGraphics();		

		g.setColor(Color.white);
		g.fillRect(0,0,c[3]+5, c[4]+5);
		g.setColor(Color.black);
		g.drawString(seqDiag.getName(), 10, 10);
		
		roles = seqDiag.returnRoles();
		//draws all the roles/messages onto the graphics object g
		while(roles.hasMoreElements()) {
			system.ATRole2 role = (ATRole2) roles.nextElement();				
			role.draw(g);
	 	}

		messages = seqDiag.returnMessages();
		while(messages.hasMoreElements()) {
			system.ATmessage mess = (ATmessage) messages.nextElement();
			mess.draw(g);
		}
		return i;
}
/**
 * Insert the method's description here.
 * Creation date: (1/18/01 12:57:49 PM)
 * @return int[]
 */
public int[] getPages() {
																	//c[0]-total pages in x-direction
																	//c[1]-total pages in y-direction
																	//c[2]-total number of pages
	int a=0, b=0;
	java.util.Enumeration roles = seqDiag.returnRoles();
	java.util.Enumeration messages = seqDiag.returnMessages();
	//pages across equals greatest x coordinate of any of the ATObject/648   visibile area of a standard 8.5"
	//pages down equals greatest y coordinate of any of the ATObject/468     by 11" paper respectively w/ this method
	//																	  printed in landscape mode
	while(roles.hasMoreElements()) {
		//this while loop will get the extreme boundaries of the panel
		ATRole2 role = (ATRole2) roles.nextElement();
		if(role.getGrfx().x2() > a) a = role.getGrfx().x2();
	}
	while(messages.hasMoreElements()) {
		ATmessage mess = (ATmessage) messages.nextElement();
		if(mess.getHeight() > b) b = mess.getHeight();
	}
	c[0] = a/PAGEWIDTH + 1;
	c[1] = b/PAGEHEIGHT + 1;
	
	c[2] = c[0] * c[1]; //# of pages total
	
	c[3] = a + 10;
	c[4] = b + 10;
	
	return c;
}
/**
 * Insert the method's description here.
 * Creation date: (1/19/01 1:33:37 PM)
 * @return int
 */
public int getRole2Count() {
	return seqDiag.getRole2Count();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public ATobject getSelectedObject()
{	//returns the currently selected object
		
	return null;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getSelectedObjectName() {
	//returns selected object's name
	return selected;
}
public void initPanel(system.ATobject object) {
	if (object instanceof system.ATsystem) {
		sys = null;
		sys = (system.ATsystem)object;
	}		
}
	//- - - - - - - - - - - - - - - - - - - - - - - - 
	// Start to move a box, draw a line or arrow
	//- - - - - - - - - - - - - - - - - - - - - - - -
	public synchronized boolean mouseDown(int x, int y, system.ATsystem sys) {
		x_pos = x;
		y_pos = y;
		java.util.Enumeration roles = seqDiag.returnRoles();
		java.util.Enumeration messages = seqDiag.returnMessages();
		ATRole2 role1;
		ATmessage message1;
		selected = null;
		if(selectedRole!=null){
			selectedRole.Selected = false;
		}
		if(selectedMessage != null){
			selectedMessage.Selected = false;
		}
		//check to see what has been selected if anything
		if(linestatus == NORMAL){
			selected = "";
			//check roles
			while(roles.hasMoreElements()){
				role1 = (system.ATRole2)roles.nextElement();
				if(role1.checkSelected(x,y)){
					if(selectedRole!=null && selectedRole!=role1){
						selectedRole.Selected = false;
					}
					role1.Selected = true;
					selectedRole = role1;
					selected = "role";
				} else if(role1.checkLineSelected(x,y)){
					lineMove = true;
					selectedRole = role1;
					selected = "roleLine";
				} else {
					role1.Selected = false;
				}
			}
			if(selected == "role"){
				return true;
			}
			//check messages
			while(messages.hasMoreElements()){
				message1 = (ATmessage)messages.nextElement();
				if(message1.checkSelected(x,y)){
					if(selectedMessage!=null && selectedMessage!=message1){
						selectedMessage.Selected = false;
					}
					message1.Selected = true;
					selectedMessage = message1;
					selected = "message";
				} else {
					message1.Selected = false;
				}
			}
			if(selected == "message"){
				return true;
			}

		//if we're going to add a message
		} else if (linestatus == AddMessage1){
			//go through roles and find which one was selected
			system.ATRole2 choosen = null;
			while(roles.hasMoreElements()){
				role1 = (system.ATRole2)roles.nextElement();
				if(role1.checkSelected(x,y)){
					//store it in choosen
					choosen = role1;
					if(selectedRole!=null){
						selectedRole.Selected = false;
					}
				}
			}
			if(choosen != null){
					message.setFirst(choosen);
					linestatus = AddMessage2;
			} else {
				sysMsg("select Role");
			}
		//picking second role for a message
		} else if (linestatus == AddMessage2){
			system.ATRole2 choosen = null;
			//find which role is selected
			while(roles.hasMoreElements()){
				role1 = (system.ATRole2)roles.nextElement();
				if(role1.checkSelected(x,y)){
					choosen = role1;
					if(selectedRole!=null){
						selectedRole.Selected = false;
					}
				}
			}
			if(choosen != null){
				//check to make sure the initiator and responder aren't the same
				if(message.setSecond(choosen)){
					//add the message to the seqDiag
					/**********message.refresh(seqDiag.messageCount());<----change this***/
					seqDiag.addMessage(message);
					linestatus = NORMAL;
					//arange line lengths accordingly
					seqDiag.arrangeMessages(LineMaxLength);
				} 
				else {
					sysMsg("select diff role");
				}
			} else {
				sysMsg("select Role");
			}
		}
		return true;
	}
public synchronized boolean mouseDrag(int x, int y, system.ATsystem sys) {
	ATRole2 role = null;
	if((x>0)&&(y>0)){
		//reset x_pos and y_pos
		x_pos = x;
		y_pos = y;
		
		java.util.Enumeration roles = seqDiag.returnRoles();
		java.util.Enumeration messages = seqDiag.returnMessages();

		ATRole2 selRole = null;
		ATmessage selMessage = null;
		
		//if a role is selected, move it
		while(roles.hasMoreElements()){
			selRole = (ATRole2)roles.nextElement();
			if(selRole.Selected){
				selRole.move(x,y);
			}
		}

		//if a message is selected, move it
		while(messages.hasMoreElements()){
			selMessage = (ATmessage)messages.nextElement();
			if(selMessage.Selected){
				selMessage.move(y);
			}
		}

		/*//for making the lines longer
		if(lineMove){
			if(role!=null){
				lineLength = role.getLength();
				int end = role.lineEnd();
				messages = seqDiag.returnMessages();
				int l = lineLength + dy;
				while(messages.hasMoreElements()){
					selMessage = (ATmessage)messages.nextElement();
					if(selMessage.getHeight() > end+dy){
						lineMove = false;
						return true;
					}
				}
				if(l>0){
					lineLength = l;
					LineMaxLength = 2*l;
			 	 	roles = seqDiag.returnRoles();
			
					while(roles.hasMoreElements()){
						selRole = (ATRole2)roles.nextElement();
						selRole.setLength(l);
					}
				}
			}
		}*/
	}
	return true;
}
	public synchronized boolean mouseUp(int x, int y, system.ATsystem sys) {
		if(selected == "message"){
			//keep messages in order in the array from top to bottom
			seqDiag.arrangeMessages(LineMaxLength);
		}
		lineMove = false;
		return true;
	}
/**
 * Insert the method's description here.
 * Creation date: (1/8/01 11:31:23 AM)
 * @param g java.awt.Graphics
 */
public void paint(Graphics g) {
	
	Dimension d = getSize();
	g.setColor(Color.white);
	g.fillRect(0, 0, d.width, d.height);
	g.setColor(Color.black);

	if(seqDiag == null){
		sysMsg("select Sequence Diagram from Use Cases Panel\n");
	} else {
		seqDiag.draw(g);
	}
	
}
/**
 * Insert the method's description here.
 * Creation date: (2/10/00 10:05:01 AM)
 */
public void printPage(Graphics g, int pageIndex, Image i) {
	try {
		int xpage = pageIndex % c[0];
		int ypage = (pageIndex/c[0]) % c[1];
		
		if(fullsize) {
			g.drawImage(i, 72, 72, 540, 720,//<--destination rectangle
				    xpage*PAGEWIDTH, ypage*PAGEHEIGHT, xpage*PAGEWIDTH+PAGEWIDTH, ypage*PAGEHEIGHT+PAGEHEIGHT, null);
		}
		else {
			g.drawImage(i, 72, 72, 540, 72 + (c[4] * 468 / c[3]),//<--destination rectangle
					        0,  0, c[3], c[4], null);
//			g.drawImage(i, 72, 72, 540, 720,//<--destination rectangle
//	        0,  0, c[0]*PAGEWIDTH, c[1]*PAGEHEIGHT, null);
		}
	}
	 catch (Exception e) {
		System.out.println(e);
	 }
}
/**
 * This method was created in VisualAge.
 * @param e MouseEvent
 */
public synchronized void processMouseEvent(java.awt.event.MouseEvent e) {
	//if right mouse button is pushed
	if(e.isPopupTrigger()) {
		//get x,y position
		x_pos = e.getX();
		y_pos = e.getY();
		
		findSelectedObject(x_pos,y_pos);
		if(selected!=null) {
			popup.removeAll();
			//set popup menu according to what has been selected
		
			if(selected == "role"){
				setRolePopup();
			} else if (selected == "roleLine"){
				setRoleLinePopup();
			} else if (selected == "message"){
				setMessPopup();
			}
			//show popup
			popup.show(this, e.getX(), e.getY());

		// !!! If you don't add something to popup after doing a removeAll(),
		//  and then call show(), it will lock up the popup and you won't be
		//  able to use it again.  To fix this, I added the if(selected != null)
		//  ensure that we will always have an active popup.  -JAG 1-5-01
		}		
	}
	//if not popup, pass on event
	else {
		super.processMouseEvent(e);
	}
}
/**
 * This method was created in VisualAge.
 */
public void setMessPopup() {
	messName = new MenuItem("Name");
	messName.setActionCommand("messName");
	messName.addActionListener(this);
	popup.add(messName);

	delete = new MenuItem("Delete");
	delete.setActionCommand("delete");
	delete.addActionListener(this);
	popup.add(delete);
}
/**
 * This method was created in VisualAge.
 */
public void setRoleLinePopup() {
	roleName = new MenuItem("Increase Length");
	roleName.setActionCommand("RoleLineLength");
	roleName.addActionListener(this);
	popup.add(roleName);

	roleType = new MenuItem("Auto-Space Lines");
	roleType.setActionCommand("spaceLines");
	roleType.addActionListener(this);
	popup.add(roleType);

	delete = new MenuItem("Delete");
	delete.setActionCommand("delete");
	delete.addActionListener(this);
	popup.add(delete);
}
/**
 * This method was created in VisualAge.
 */
public void setRolePopup() {
	roleName = new MenuItem("Name");
	roleName.setActionCommand("roleName");
	roleName.addActionListener(this);
	popup.add(roleName);

	roleType = new MenuItem("Role Type");
	roleType.setActionCommand("roleType");
	roleType.addActionListener(this);
	popup.add(roleType);

	delete = new MenuItem("Delete");
	delete.setActionCommand("delete");
	delete.addActionListener(this);
	popup.add(delete);
}
/**
 * Insert the method's description here.
 * Creation date: (6/20/00 2:34:16 PM)
 * @param sD system.ATseqDiag
 */
public void setSeqDiag(ATseqDiag sD) {
	seqDiag = sD;
	}
//- - - - - - - - - - - - - - -
// Draw objects on panel
//- - - - - - - - - - - - - - -
public void update() {

	/*try {
		
		//get graphics position for this panel
		g = this.getGraphics();
		Dimension d = getSize();
		if ((offGraphics == null)
		 || (d.width != offDimension.width)
		 || (d.height != offDimension.height)) {
			    offDimension = d;
			    offImage = createImage(d.width, d.height);
			    offGraphics = offImage.getGraphics();
		}
		offGraphics.setColor(Color.white);
		offGraphics.fillRect(0, 0, d.width, d.height);
		offGraphics.setColor(Color.black);

		if(seqDiag == null){
			sysMsg("select Sequence Diagram from Use Cases Panel\n");
		} else {
			seqDiag.draw(offGraphics);
			g.drawImage(offImage,0,0,null);
		}
		
	} catch (java.lang.NullPointerException e) {
	}
	*/
}
}
