package Editor;

/**
 * Insert the type's description here.
 * Creation date: (6/13/00 9:29:50 AM)
 * @author: 
 * 
 * This example demonstrates how to simplify tracking the selection
 * in a JList whose selection model is in SINGLE_SELECTION mode.
 * 
 * Tested against swing-1.1, JDK1.1.7.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;

import java.lang.reflect.Method;


/**
 * Create a SINGLE_SELECTION ListSelectionModel that calls a new 
 * method, updateSingleSelection(), each time the selection
 * changes.  This can be a little bit more convienent than using the 
 * ListModels ListSelectionListener, since ListSelectionListeners
 * are only given the range of indices that the change spans.
 */
class SingleSelectionModel extends DefaultListSelectionModel 
{
/**
 * Try4 constructor comment.
 */
public SingleSelectionModel() {
	super();
}
	public void setSelectionInterval(int index0, int index1) {
	int oldIndex = getMinSelectionIndex();
	super.setSelectionInterval(index0, index1);
	int newIndex = getMinSelectionIndex();
	if (oldIndex != newIndex) {
	    updateSingleSelection(oldIndex, newIndex);
	}
	}
	public void updateSingleSelection(int oldIndex, int newIndex) {
		System.out.println("new Index = " + newIndex);
	}
}
