package KBFile;

/*
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 */

import java.io.*;

public class RecordWriter {

  String key;
  DbByteArrayOutputStream out;
  ObjectOutputStream objOut;

  public RecordWriter(String key) {
	this.key = key;
	out = new DbByteArrayOutputStream();
  }  
  /**
   * Returns the number of bytes in the data.
   */
  public int getDataLength() {
	return out.size();
  }  
  public String getKey() {
	return key;
  }  
  public ObjectOutputStream getObjectOutputStream() throws IOException {
	if (objOut == null) {
	  objOut = new ObjectOutputStream(out);
	}
	return objOut;
  }  
  public OutputStream getOutputStream() {
	return out;
  }  
  public void writeObject(Object o) throws IOException {
	getObjectOutputStream().writeObject(o);
	getObjectOutputStream().flush();
  }  
  /**
   *  Writes the data out to the stream without re-allocating the buffer.
   */
  public void writeTo(DataOutput str) throws IOException {
	out.writeTo(str);
  }  
}
