package Transforms;

/**
 * This class is used to represent an agent in the system
 *
 * Creation date: (11/3/00 10:50:21 AM)
 * @author: Clint Sparkman
 *
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */

import java.util.Vector;
import system.ATagent;
 
public class Agent {
	private ATagent	atAgent = null;
	private String	name = null;				// agent name
	private Vector	roles = null;				// SET of roles
	private Vector	components = null;			// SET of components
	private Vector	conversations = null;		// SET of conversations
/**
 * Insert the method's description here.
 * Creation date: (11/6/00 12:50:42 PM)
 */
public Agent(ATagent ag) {
	name = ag.getName();
	atAgent = ag;
}
/**
 * Insert the method's description here.
 * Creation date: (11/6/00 12:51:03 PM)
 */
public Agent(ATagent ag, Vector r) {
	name = ag.getName();
	roles = r;
	atAgent = ag;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 7:57:57 PM)
 * @return system.ATagent
 */
public system.ATagent getAtAgent() {
	return atAgent;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 7:57:57 PM)
 * @return java.util.Vector
 */
public java.util.Vector getComponents() {
	return components;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 7:57:57 PM)
 * @return java.util.Vector
 */
public java.util.Vector getConversations() {
	return conversations;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 7:57:57 PM)
 * @return java.lang.String
 */
public java.lang.String getName() {
	return name;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 7:57:57 PM)
 * @return java.util.Vector
 */
public java.util.Vector getRoles() {
	return roles;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 7:57:57 PM)
 * @param newAtAgent system.ATagent
 */
public void setAtAgent(system.ATagent newAtAgent) {
	atAgent = newAtAgent;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 7:57:57 PM)
 * @param newComponents java.util.Vector
 */
public void setComponents(java.util.Vector newComponents) {
	components = newComponents;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 7:57:57 PM)
 * @param newConversations java.util.Vector
 */
public void setConversations(java.util.Vector newConversations) {
	conversations = newConversations;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 7:57:57 PM)
 * @param newName java.lang.String
 */
public void setName(java.lang.String newName) {
	name = newName;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 7:57:57 PM)
 * @param newRoles java.util.Vector
 */
public void setRoles(java.util.Vector newRoles) {
	roles = newRoles;
}
/**
 * Show method used for debugging
 *
 * Creation date: (11/6/00 1:38:54 PM)
 */
public void show() {
	System.out.println("Agent: " + name);
	System.out.print("Roles: ");
	if(roles != null){
		for(int i = 0; i < roles.size(); i++){
			Role r = (Role)roles.elementAt(i);
			System.out.print(r.getName());
			if(i+1 < roles.size())
				System.out.print(", ");
		}
	}
	System.out.println();
	System.out.println("Components:");
	if(components != null){
		for(int i = 0; i < components.size(); i++){
			Component c = (Component)components.elementAt(i);
			System.out.println();
			c.show();
		}
	}
}
}
