package Transforms;

/**
 * This class is used to represent an agent component
 *
 * Creation date: (11/3/00 10:50:21 AM)
 * @author: Clint Sparkman
 *
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */

import java.util.Vector;
import system.ATagentComponent;
 
public class Component {
	private ATagentComponent atComponent = null;
	private Agent		parent = null;
	private String		name = null;				// component name
	private StateTable	stateTable = null;			// component state table
	private Vector		convs = null;				// SET of ConversationHalfs that belong to the component
/**
 * Insert the method's description here.
 * Creation date: (11/10/00 12:13:39 PM)
 */
public Component(String n, StateTable st, Agent a) {
	name = n;
	stateTable = st;
	parent = a;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 8:17:27 PM)
 * @return system.ATagentComponent
 */
public system.ATagentComponent getAtComponent() {
	return atComponent;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 8:17:27 PM)
 * @return java.util.Vector
 */
public java.util.Vector getConvs() {
	return convs;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 8:17:27 PM)
 * @return java.lang.String
 */
public java.lang.String getName() {
	return name;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 8:17:27 PM)
 * @return Transforms.Agent
 */
public Agent getParent() {
	return parent;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 8:17:27 PM)
 * @return Transforms.StateTable
 */
public StateTable getStateTable() {
	return stateTable;
}
/**
 * This method is used to determine if the component has
 * a ConversationHalf that has the given name
 *
 * Creation date: (12/2/00 7:14:16 PM)
 */
public boolean hasConv(String cid) {
	if(convs != null)
	for(int i = 0; i < convs.size(); i++){
		ConversationHalf ch = (ConversationHalf)convs.elementAt(i);
		if(ch.getConvID().equals(cid))
		return true;
	}
	return false;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 8:17:27 PM)
 * @param newAtComponent system.ATagentComponent
 */
public void setAtComponent(system.ATagentComponent newAtComponent) {
	atComponent = newAtComponent;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 8:17:27 PM)
 * @param newConvs java.util.Vector
 */
public void setConvs(java.util.Vector newConvs) {
	convs = newConvs;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 8:17:27 PM)
 * @param newName java.lang.String
 */
public void setName(java.lang.String newName) {
	name = newName;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 8:17:27 PM)
 * @param newParent Transforms.Agent
 */
public void setParent(Agent newParent) {
	parent = newParent;
}
/**
 * Insert the method's description here.
 * Creation date: (12/5/00 8:17:27 PM)
 * @param newStateTable Transforms.StateTable
 */
public void setStateTable(StateTable newStateTable) {
	stateTable = newStateTable;
}
/**
 * Show method used for debugging
 *
 * Creation date: (11/10/00 12:32:32 PM)
 */
public void show() {
	System.out.println("Component: " + name);
	if(convs != null){
		System.out.print("\tConversationHalfs: ");
		for(int i = 0; i < convs.size(); i++){
			ConversationHalf ch = (ConversationHalf)convs.elementAt(i);
			System.out.print(ch.getConvID());
			if(i+1 < convs.size())
				System.out.print(", ");
		}
		System.out.println();
	}
	
	if(stateTable != null)
		stateTable.show();
	
}
}
