package Transforms;

/**
 * Insert the type's description here.
 * Creation date: (11/24/00)
 * Window to allow Protocols to be added to external events
 *
 * Creation date: (11/3/00 10:50:21 AM)
 * @author: Clint Sparkman
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
 import java.util.Vector;
 import javax.swing.JLabel;
 import javax.swing.JOptionPane;
 
public class ProtocolWindow extends javax.swing.JDialog {
	
	private javax.swing.JButton 	ivjAddProtocolButton = null;
	private javax.swing.JButton 	ivjDeleteProtocolButton = null;
	private javax.swing.JButton 	ivjFinishButton = null;
	
	private javax.swing.JList 		ivjEventsProtocols = null;
	
	private javax.swing.JPanel 		ivjJFrameContentPane = null;
	
	private javax.swing.JLabel 		ivjJLabel1 = null;
	private javax.swing.JLabel 		ivjJLabel2 = null;
	private javax.swing.JLabel		ivjJLabel3 = null;
	private javax.swing.JLabel		ivjJLabel4 = null;
		
	private javax.swing.JScrollPane ivjJScrollPane1 = null;
	private javax.swing.JScrollPane ivjJScrollPane2 = null;
	
	private javax.swing.JList 		ivjProtocols = null;
	
	private java.util.Vector 		list1 = null;
	private java.util.Vector 		list2 = null;
	
	IvjEventHandler 				ivjEventHandler = new IvjEventHandler();
	
	// myStuff
	SendEvent						se = null;
	ReceiveEvent					re = null;
	Protocol						p = null;

	private boolean done = false;
	

	class IvjEventHandler implements java.awt.event.ActionListener {
		public void actionPerformed(java.awt.event.ActionEvent e) {
			if (e.getSource() == ProtocolWindow.this.getAddProtocolButton()) 
				connEtoC1();
			if (e.getSource() == ProtocolWindow.this.getDeleteProtocolButton()) 
				connEtoC2();
			if (e.getSource() == ProtocolWindow.this.getFinishButton()) 
				connEtoC3();
		};
	};
/**
 * Insert the method's description here.
 * Creation date: (6/6/00 12:07:58 PM)
 */
public ProtocolWindow(Vector protocols, ReceiveEvent receiveEvent) {
	super((java.awt.Frame)null,false);
	//super((java.awt.Frame)null, true);
	re = receiveEvent;
	list1 = new Vector();
	list2 = new Vector();
	setlist1(protocols);
	setlist2(re.getProtocols());

	initialize();
}
/**
 * Insert the method's description here.
 * Creation date: (6/6/00 12:07:58 PM)
 */
public ProtocolWindow(Vector protocols, SendEvent sendEvent) {
	super((java.awt.Frame)null,false);
	//super((java.awt.Frame)null, true);
	se = sendEvent;
	list1 = new Vector();
	list2 = new Vector();
	setlist1(protocols);
	setlist2(se.getProtocols());

	initialize();
}
/**
 * Comment
 */
public void addProtocolButton_ActionEvents() {
	int index = ivjProtocols.getSelectedIndex();
	if(index < 0)
		return;
		
	if(se!=null){
		if(se.getProtocols() == null)
		se.setProtocols(new Vector());
		se.getProtocols().add(list1.elementAt(index));
	}
	if(re!=null){
		if(re.getProtocols() == null)
		re.setProtocols(new Vector());
		re.getProtocols().add(list1.elementAt(index));
	}
	
	list2.add(list1.elementAt(index));
	list1.removeElementAt(index);
	updateLists();
}
/**
 * connEtoC1:  (AddRoleButton.action. --> RoleWindow.addRoleButton_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC1() {
	try {
		// user code begin {1}
		// user code end
		this.addProtocolButton_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC2:  (DeleteRoleButton.action. --> RoleWindow.deleteRoleButton_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC2() {
	try {
		// user code begin {1}
		// user code end
		this.deleteProtocolButton_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC3:  (FinishButton.action. --> RoleWindow.finishButton_ActionEvents()V)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC3() {
	try {
		// user code begin {1}
		// user code end
		this.finishButton_ActionEvents();
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * Comment
 */
public void deleteProtocolButton_ActionEvents() {
	int index = getEventsProtocols().getSelectedIndex();
	if(index < 0)
		return;
	
	if(re!=null){
		Protocol p = (Protocol)list2.elementAt(index);
		re.getProtocols().remove(p);
	}
	if(se!=null){
		Protocol p = (Protocol)list2.elementAt(index);
		se.getProtocols().remove(p);
	}
	list1.add(list2.elementAt(index));
	list2.removeElementAt(index);
	updateLists();
}
/**
 * Comment
 */
public void finishButton_ActionEvents() {
	if((list2!=null) && (list2.size() > 0)){
		if(re!=null){
			re.setProtocols((Vector)list2.clone());
		}
		if(se!=null){
			se.setProtocols((Vector)list2.clone());
		}

		done = true;
		this.dispose();
	}
	else{
		String msg = "Every external event must \nbelong to at least one protocol!";
		Object[] options = { "OK"};
		JOptionPane.showOptionDialog(null, msg, "Warning", 
			JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE,
			null, options, options[0]);
	}
}
/**
 * Return the AddRoleButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getAddProtocolButton() {
	if (ivjAddProtocolButton == null) {
		try {
			ivjAddProtocolButton = new javax.swing.JButton();
			ivjAddProtocolButton.setName("AddProtocolButton");
			ivjAddProtocolButton.setText("=> Add  =>");
			ivjAddProtocolButton.setBounds(210, 153, 97, 27);
			ivjAddProtocolButton.setActionCommand("AddProtocol");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjAddProtocolButton;
}
/**
 * Return the DeleteRoleButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getDeleteProtocolButton() {
	if (ivjDeleteProtocolButton == null) {
		try {
			ivjDeleteProtocolButton = new javax.swing.JButton();
			ivjDeleteProtocolButton.setName("DeleteProtocolButton");
			ivjDeleteProtocolButton.setText("<= Delete <=");
			ivjDeleteProtocolButton.setBounds(210, 205, 97, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjDeleteProtocolButton;
}
/**
 * Return the AgentsRoles property value.
 * @return javax.swing.JList
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JList getEventsProtocols() {
	if (ivjEventsProtocols == null) {
		try {
			ivjEventsProtocols = new javax.swing.JList();
			ivjEventsProtocols.setName("Events Protocols");
			ivjEventsProtocols.setBounds(0, 0, 160, 120);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjEventsProtocols;
}
/**
 * Return the FinishButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getFinishButton() {
	if (ivjFinishButton == null) {
		try {
			ivjFinishButton = new javax.swing.JButton();
			ivjFinishButton.setName("FinishButton");
			ivjFinishButton.setText("Finish");
			ivjFinishButton.setBounds(210, 353, 97, 27);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjFinishButton;
}
/**
 * Return the JFrameContentPane property value.
 * @return javax.swing.JPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JPanel getJFrameContentPane() {
	if (ivjJFrameContentPane == null) {
		try {
			ivjJFrameContentPane = new javax.swing.JPanel();
			ivjJFrameContentPane.setName("JFrameContentPane");
			ivjJFrameContentPane.setLayout(null);
			getJFrameContentPane().add(getJScrollPane1(), getJScrollPane1().getName());
			getJFrameContentPane().add(getJScrollPane2(), getJScrollPane2().getName());
			getJFrameContentPane().add(getAddProtocolButton(), getAddProtocolButton().getName());
			getJFrameContentPane().add(getJLabel1(), getJLabel1().getName());
			getJFrameContentPane().add(getJLabel2(), getJLabel2().getName());
			getJFrameContentPane().add(getJLabel3(), getJLabel3().getName());
			getJFrameContentPane().add(getJLabel4(), getJLabel4().getName());
			getJFrameContentPane().add(getDeleteProtocolButton(), getDeleteProtocolButton().getName());
			getJFrameContentPane().add(getFinishButton(), getFinishButton().getName());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJFrameContentPane;
}
/**
 * Return the JLabel1 property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JLabel getJLabel1() {
	if (ivjJLabel1 == null) {
		try {
			ivjJLabel1 = new javax.swing.JLabel();
			ivjJLabel1.setName("JLabel1");
			ivjJLabel1.setText("Protocols");
			ivjJLabel1.setBounds(34, 80, 146, 17);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJLabel1;
}
/**
 * Return the JLabel2 property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JLabel getJLabel2() {
	if (ivjJLabel2 == null) {
		try {
			ivjJLabel2 = new javax.swing.JLabel();
			ivjJLabel2.setName("JLabel2");
			ivjJLabel2.setText("Event\'s Protocols");
			ivjJLabel2.setBounds(327, 80, 104, 17);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJLabel2;
}
/**
 * Return the JLabel1 property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JLabel getJLabel3() {
	String text = "";
	if (ivjJLabel3 == null) {
		try {
			ivjJLabel3 = new javax.swing.JLabel();
			ivjJLabel3.setName("JLabel3");
			if(re != null){
				// set the text for the re
				text = "Choose the protocols the Receive Event:  ";
				text += re.toString() + "  belongs to."; 
			}
			if(se != null){
				// set the text for the se
				text = "Choose the protocols the Send Event:  ";
				text += se.toString() + "  belongs to.";
			}
			ivjJLabel3.setText(text);
			ivjJLabel3.setBounds(25, 10, 475, 20);
			ivjJLabel3.setHorizontalAlignment(JLabel.CENTER);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJLabel3;
}
/**
 * Return the JLabel1 property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JLabel getJLabel4() {
	String text = "";
	if (ivjJLabel4 == null) {
		try {
			ivjJLabel4 = new javax.swing.JLabel();
			ivjJLabel4.setName("JLabel3");
			if(re != null){
				// set the text for the re
				text = "The transition is highlighted in the task diagram.";
			}
			if(se != null){
				// set the text for the se
				text = "The transition is highlighted in the task diagram.";
			}
			ivjJLabel4.setText(text);
			ivjJLabel4.setBounds(25, 30, 475, 20);
			ivjJLabel4.setHorizontalAlignment(JLabel.CENTER);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJLabel4;
}
/**
 * Return the JScrollPane1 property value.
 * @return javax.swing.JScrollPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JScrollPane getJScrollPane1() {
	if (ivjJScrollPane1 == null) {
		try {
			ivjJScrollPane1 = new javax.swing.JScrollPane();
			ivjJScrollPane1.setName("JScrollPane1");
			ivjJScrollPane1.setBounds(33, 105, 160, 275);
			ivjJScrollPane1.setViewportView(getProtocols());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJScrollPane1;
}
/**
 * Return the JScrollPane2 property value.
 * @return javax.swing.JScrollPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JScrollPane getJScrollPane2() {
	if (ivjJScrollPane2 == null) {
		try {
			ivjJScrollPane2 = new javax.swing.JScrollPane();
			ivjJScrollPane2.setName("JScrollPane2");
			ivjJScrollPane2.setBounds(325, 105, 160, 275);
			ivjJScrollPane2.setViewportView(getEventsProtocols());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJScrollPane2;
}
/**
 * Return the Roles property value.
 * @return javax.swing.JList
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JList getProtocols() {
	if (ivjProtocols == null) {
		try {
			ivjProtocols = new javax.swing.JList();
			ivjProtocols.setName("Protocols");
			ivjProtocols.setBounds(0, 0, 157, 272);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjProtocols;
}
/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(java.lang.Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	// System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	// exception.printStackTrace(System.out);
}
/**
 * Initializes connections
 * @exception java.lang.Exception The exception description.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initConnections() throws java.lang.Exception {
	// user code begin {1}
	// user code end
	getAddProtocolButton().addActionListener(ivjEventHandler);
	getDeleteProtocolButton().addActionListener(ivjEventHandler);
	getFinishButton().addActionListener(ivjEventHandler);
}
/**
 * Initialize the class.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initialize() {
	try {
		// user code begin {1}
		// user code end
		setName("ProtocolWindow");
		setTitle("Event\'s Protocols");
		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		setSize(525, 435);
		setContentPane(getJFrameContentPane());
		initConnections();
		
	} catch (java.lang.Throwable ivjExc) {
		handleException(ivjExc);
	}
	// user code begin {2}
	// user code end
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 12:18:08 PM)
 * @return boolean
 */
public boolean isDone() {
	return done;
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 12:18:08 PM)
 * @param newDone boolean
 */
public void setDone(boolean newDone) {
	done = newDone;
}
/**
 * Insert the method's description here.
 * Creation date: (5/18/00 12:03:57 PM)
 * @param agent system.ATagent
 */
public void setEvent(ReceiveEvent rec) {
	re = rec;

	if(rec.getProtocols() != null)
	setlist2(rec.getProtocols());
}
/**
 * Insert the method's description here.
 * Creation date: (5/18/00 12:03:57 PM)
 * @param agent system.ATagent
 */
public void setEvent(SendEvent send) {
	se = send;

	if(send.getProtocols() != null)
	setlist2(send.getProtocols());
}
/**
 * Set the list to a new value.
 * @param newValue java.util.Vector
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public void setlist1(java.util.Vector newValue) {
	try {
	//	list1 = newValue;
		java.util.Enumeration temp = newValue.elements();
		Vector list = new Vector();
		while(temp.hasMoreElements()){
			String s;
			Protocol p = (Protocol)temp.nextElement();
			list1.add(p);
			list.add(p.getName());
		}
		getProtocols().setListData(list);
		// user code begin {1}
			// user code end
	} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
		handleException(ivjExc);
	}
	// user code begin {3}
	// user code end
}
/**
 * Set the list to a new value.
 * @param newValue java.util.Vector
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public void setlist2(java.util.Vector newValue) {
	try {
		list2 = (Vector)newValue.clone();
		java.util.Enumeration temp = list2.elements();
		Vector list = new Vector();
		while(temp.hasMoreElements()){
			Protocol p = (Protocol)temp.nextElement();
			list.add(p.getName());
		}
	//	java.util.Vector oldValue = getlist();
		getEventsProtocols().setListData(list);
		// user code begin {1}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {2}
		// user code end
		handleException(ivjExc);
	}
	// user code begin {3}
	// user code end
}
/**
 * Insert the method's description here.
 * Creation date: (11/7/00 12:35:41 PM)
 */
public void updateLists() {
	java.util.Enumeration temp = list1.elements();
	Vector list = new Vector();
	while(temp.hasMoreElements()){
		Protocol p = (Protocol)temp.nextElement();
		list.add(p.getName());
	}
	getProtocols().setListData(list);
	
	temp = list2.elements();
	list = new Vector();
	while(temp.hasMoreElements()){
		Protocol p = (Protocol)temp.nextElement();
		list.add(p.getName());
	}
	getEventsProtocols().setListData(list);
}
}
