package Transforms;

/**
 * This class is used to represent a role in the analysis phase.
 * Agents in the design phase play some set of roles.
 *
 * Creation date: (11/3/00 10:50:21 AM)
 * @author: Clint Sparkman
 *
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */

import java.util.Vector;
import system.ATRole;
 
public class Role {
	private ATRole	atRole = null;
	private String 	name = null;			// role's name
	private Vector 	tasks = null;			// SET of Tasks
/**
 * Insert the method's description here.
 * Creation date: (11/7/00 2:09:40 PM)
 */
public Role(ATRole r) {
	name = r.getName();
	atRole = r;
}
/**
 * Insert the method's description here.
 * Creation date: (11/7/00 2:05:42 PM)
 */
public Role(ATRole r, Vector t) {
	name = r.getName();
	tasks = t;
	atRole = r;
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 8:19:14 AM)
 * @return system.ATRole
 */
public system.ATRole getAtRole() {
	return atRole;
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 8:19:14 AM)
 * @return java.lang.String
 */
public java.lang.String getName() {
	return name;
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 8:19:14 AM)
 * @return java.util.Vector
 */
public java.util.Vector getTasks() {
	return tasks;
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 8:19:14 AM)
 * @param newAtRole system.ATRole
 */
public void setAtRole(system.ATRole newAtRole) {
	atRole = newAtRole;
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 8:19:14 AM)
 * @param newName java.lang.String
 */
public void setName(java.lang.String newName) {
	name = newName;
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 8:19:14 AM)
 * @param newTasks java.util.Vector
 */
public void setTasks(java.util.Vector newTasks) {
	tasks = newTasks;
}
/**
 * Show method used for debugging
 *
 * Creation date: (11/6/00 1:01:26 PM)
 */
public void show() {
	System.out.println();
	System.out.println("Showing Role: " + name);
	System.out.println("Tasks:");
	if(tasks != null){
		for(int i = 0; i < tasks.size(); i++){
			Task t = (Task)tasks.elementAt(i);
			System.out.println();
			t.show();
		}
	}
}
}
