package Verify;

/**
 * A Class for getting spin generated messages from a file, <tt>newpan.txt</tt>,
 * <tt>newpan2.txt</tt>, or <tt>newpan3.txt</tt>
 * created when Spin analyzes the Promela Code
 * @version 1.0 6 Oct 1999
 * @author Capt Tim Lacey
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
import java.util.*;
class PanTable
{
	String spinMessage = null;
/**
 * Constructor that reads a line of the newpan files, <tt>newpan.txt</tt>,
 * <tt>newpan2.txt</tt>, or <tt>newpan3.txt<tt>
 * @param line the message line of the file
 * @return nothing
 * @throws nothing
 */
public PanTable(String line)
{
	// Read an entire line of text at a time
	StringTokenizer t = new StringTokenizer(line, "\n");
	while (t.hasMoreTokens())
	{
		spinMessage = t.nextToken();
	}
}
/**
 * Get the line of the message file saved here
 * @param nothing
 * @return the line of the message
 * @throws nothing
 */
public String getSpinMessage()
{
	return spinMessage;
}
}
