package Verify;

/**
 * A Class for getting the trace of an error sequence
 * @version 1.0 6 Oct 1999
 * @author Capt Tim Lacey
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
import java.util.*;
class TraceTable
{
	String traceMessage = null;
/**
 * Constructor that reads a line of the trace file, <tt>trace.txt</tt>,
 * @param line one line of the message trace
 * @return nothing
 * @throws nothing
 */
public TraceTable(String line)
{
	// Read an entire line at a time
	StringTokenizer t = new StringTokenizer(line, "\n");
	while (t.hasMoreTokens())
	{
		traceMessage = t.nextToken();
	}
}
/**
 * Get the line of the trace file saved here
 * @param nothing
 * @return the line of the trace
 * @throws nothing
 */
public String getTraceMessage()
{
	return traceMessage;
}
}
