package agentBase;

import java.util.*;
import java.io.*;
import KBFile.*;
import system.*;
import afit.mom.*;

public class KBAdministrator extends Agent  {
	ATObjectFile cLibrary  =null;
	ATObjectFile sLibrary  =null;
	ATObjectFile aLibrary  =null;
	ATObjectFile rLibrary  =null;
	ATObjectFile fLibrary  =null;
	ATObjectFile archLibrary  =null;
	ATObjectFile cmptLibrary  =null;	
/**
 * Constructor
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public KBAdministrator(String s, int i) { //throws Exception {
	super(s, i);
	MessageHandler handler = new MessageHandler(this.port, this);
	handler.start();
	
	try {
	 cLibrary  = new ATObjectFile("ATConversations.library","rw");
	 sLibrary  = new ATObjectFile("ATSystems.library","rw");
	 aLibrary  = new ATObjectFile("ATAgents.library", "rw");
	 rLibrary  = new ATObjectFile("ATRoles.library",  "rw");
	 fLibrary  = new ATObjectFile("ATFrameworks.library","rw");
	 cmptLibrary  = new ATObjectFile("ATComponents.library", "rw");
	 archLibrary  = new ATObjectFile("ATArchitectures.library", "rw");	
	}
	catch (java.io.IOException ioe) {
		System.out.println("*** ERROR - kbserver ioexception");
	}
	catch (RecordsFileException rfe) {
		System.out.println("*** ERROR - kbserver recordsexception");
	}
	catch (Exception e) {System.out.println("*** ERROR - KBServer");}
}
/**
 * Insert the method's description here.
 * Creation date: (10/13/99 2:58:52 PM)
 * @return boolean
 */
public boolean keyTest(String c, String key) {
	System.out.println(" ** cLibrary is now: " + this.cLibrary);
	System.out.println(" ** THIS is : " + this);
	if (c.equals("system.ATconversation")) 
		return (cLibrary.recordExists(key));
	else if (c.equals("system.ATagent")) 
		return (aLibrary.recordExists(key));	
	else if (c.equals("system.ATsystem")) 
		return (sLibrary.recordExists(key));
	else if (c.equals("system.ATarchitecture")) 
		return (archLibrary.recordExists(key));
	else if (c.equals("system.ATrole")) 
		return (rLibrary.recordExists(key));		
	else if (c.equals("system.ATframework")) 
		return (fLibrary.recordExists(key));
	else if (c.equals("system.ATagentComponent")) 
		return (cmptLibrary.recordExists(key));	
	else return true;
}
/**
 * Insert the method's description here.
 * Creation date: (10/11/99 10:22:26 PM)
 */
public Collection list(String type) {
 
	Collection c = cLibrary.listKeys();
	System.out.println("*** Type requested is: " + type + " specifically.");
	
	if	(type.equals("system.ATconversation")) {
	//Set string array to have conversation keys
	   	c = new HashSet(cLibrary.listKeys());	
	}
	else if	(type.equals("system.ATagent")) {
	//Set string array to have agent keys
		c = new HashSet(aLibrary.listKeys());	
	}
	else if	(type.equals("system.ATsystem")) {
	//Set string array to have system keys
		c = new HashSet(sLibrary.listKeys());	
	}
	else if	(type.equals("system.ATrole")) {
	//Set string array to have system keys
		c = new HashSet(rLibrary.listKeys());
	}
	else if	(type.equals("system.ATframework")) {
	//Set string array to have agent keys
		c = new HashSet(fLibrary.listKeys());	
	}
	else if	(type.equals("system.ATarchitecture")) {
	//Set string array to have system keys
		c = new HashSet(archLibrary.listKeys());	
	}
	else if	(type.equals("system.ATagentComponent")) {
	//Set string array to have system keys
		c = new HashSet(cmptLibrary.listKeys());
	}	

	Object[] a = c.toArray();
	System.out.println("*** One key is: "+ (String) a[0]);
	return c;
}
/**
 * This method was created in VisualAge.
 */
public ATKB_Object load(ATKB_Object req) {

	String   key    = req.getkey();
	String   type   = req.getotype();
	RecordReader rr = null;
	String   maml    = null;	
	try { //The typecasting may be unnecessary below
		if (type.equals("system.ATconversation")) {
			rr = cLibrary.readRecord(key);
		}
		else if (type.equals("system.ATagent")) {
			rr = aLibrary.readRecord(key);
		}
		else if (type.equals("system.ATsystem")) {
			rr = sLibrary.readRecord(key);
		}
		else if (type.equals("system.ATrole")) {
			rr = rLibrary.readRecord(key);
		}	
		else if (type.equals("system.ATarchitecture")) {
			rr = archLibrary.readRecord(key);
		}
		else if (type.equals("system.ATframework")) {
			rr = fLibrary.readRecord(key);
		}
		else if (type.equals("system.ATagentComponent")) {
			rr = cmptLibrary.readRecord(key);
		}		
		else {
			System.out.println("*** ERROR - Unknown AT object type encountered in store routine");
		}
		//I now cast it to the ATobject, though it really is more specific than this
		maml = (String)rr.readObject();
	}
	catch (java.io.IOException ioe) {
		System.out.println("*** ERROR - IO exception in preparing RecordReader:");
	}
	catch (RecordsFileException rfe) {
		System.out.println("*** ERROR - RecordFile Error in writing RecordWriter to persistent storage");
	}
	catch (ClassNotFoundException cnf) {
		System.out.println("*** ERROR - RecordFile Error in writing RecordWriter to persistent storage");
	}
	return(new ATKB_Object(key,type, maml));
}
  public static void main (String[] args)  {

	KBAdministrator KBS = new KBAdministrator("KBAdministrator", 5000);
	KBS.run();
  }  
/**
 * This method was created in VisualAge.
 */
public void receiveMessage(java.net.Socket server, ObjectInputStream input, ObjectOutputStream output) {
	int i;
	Message m;
	KBStoreObject sc;
	Thread t;
	try {
		
	  m = (Message) input.readObject();
	//  String c = (String) (m.getContent().getClass().getName()); 
	//  	
	  if (m.performative.equals("store")) {  
  		t = new Thread(new KBStoreObject(server, input, output, this, m));
  		t.start();
	  }
	  else if (m.performative.equals("load")) { 
		t = new Thread(new KBLoadObject(server, input, output, this, m));
  		t.start();   
	  }
	  else if (m.performative.equals("list")) { 
		t = new Thread(new KBList(server, input, output, this, m));
  		t.start();   
	  }
	  else System.out.println("Unknown performative type");
	}
	catch (ClassNotFoundException cnfex) {}
	catch (IOException ioe) {}
		
}
/**
 * Insert the method's description here.
 * Creation date: (10/13/99 12:53:14 PM)
 */
public void run() {
}
/**
 * This method was created in VisualAge.
 */
public void store(ATKB_Object kbobj) {

	ATObjectFile workLibrary=null;
	String key = kbobj.getkey();
	String o   = kbobj.getotype();
	String maml = kbobj.getMAML();
	
//	if (obj.getVersion()>0) key = key+".v" + Integer.toString(obj.getVersion());
//	else key = "#" + key;

	RecordWriter rw = new RecordWriter(key);	
	try { //The typecasting may be unnecessary below
		if (o.equals("system.ATconversation")) {
			workLibrary=cLibrary;
			rw.writeObject(maml);
		}
		else if (o.equals("system.ATagent")) {
			workLibrary=aLibrary;
			rw.writeObject(maml);
		}
		else if (o.equals("system.ATsystem")) {
			workLibrary=sLibrary;
			rw.writeObject(maml);
		}
		else if (o.equals("system.ATagentComponent")) {
			workLibrary=cmptLibrary;
			rw.writeObject(maml);
		}
		else if (o.equals("system.ATrole")) {
			workLibrary=rLibrary;
			rw.writeObject(maml);
		}
		else if (o.equals("system.ATarchitecture")) {
			workLibrary=archLibrary;
			rw.writeObject(maml);
		}
		else if (o.equals("system.ATframework")) {
			workLibrary=fLibrary;
			rw.writeObject(maml);
		}
		else System.out.println("*** ERROR - Unknown AT object type encountered in store routine");
	
	  	workLibrary.insertRecord(rw);
	}
	catch (java.io.IOException ioe) {
		System.out.println("*** ERROR - IO exception in preparing RecordWriter:");
	}
	catch (RecordsFileException rfe) {
		System.out.println("*** ERROR - RecordFile Error in writing RecordWriter to persistent storage");
	}
}
}
