package system;

/**
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
import java.util.*;
public class ATGoal extends ATobject {

	//name of the agent
	private String Num = "0";
	private ATGoal goal;
	private Vector children = new Vector();
	private Vector secondaryParents = new Vector();
	private Vector spGrfx = new Vector();
	
	private ATRole role;
	///--graphics objects stuff.

	//actual graphics object
	private ATgoalGRFX grfxObj;
	private ATGoalConnectorGRFX grfxCObj;
	//keeps track of whether agent is selected or not 
	public boolean Selected = false;
	private boolean Partitioned = false;
	private boolean keybased = false;
	private static final String ukh = "goal@";
/**
 * ATagent constructor comment.
 */
public ATGoal(double ver, String[] tokens,ATsystem sys) {
	this(ver,0); //*** Version 1 of ATagent ***
	
	int loc = ATtokenOps.findnextinstanceof("version",tokens,0);
	double v=Double.parseDouble(tokens[loc+3]);
	//setVersion(v);
	
  //Code for constructing object model from MAML tokens
	if (v>=1) constructFromV1(tokens,sys);
	else {
		System.out.println("Loading a version other than 1.");	
	}
 	//	System.out.println("Loaded a goal");
}
	//keeps track of whether an agent's corner is selected
	
/**
 * ATagent constructor comment.
 */
public ATGoal(double v, int keynum) {
	super(v);
	setKey(ukh + keynum);
	MAMLheader+="<!DOCTYPE agent SYSTEM \"atagent"+Double.toString(getVersion())+".dtd\">\n";
	grfxObj = new ATgoalGRFX(v);
	grfxCObj = new ATGoalConnectorGRFX(true);
	role = null;
	setCoordinates(50,50,50,50);
}
/**
 * ATagent constructor comment.
 */
public ATGoal(double ver, String x,ATsystem sys) {
	this(ver,ATtokenOps.parseLine(x),sys);
}
	//keeps track of whether an agent's corner is selected
	
/**
 * ATagent constructor comment.
 */
public ATGoal(ATGoal cp) {
	super(cp);
}
/**
 * Insert the method's description here.
 * Creation date: (11/16/00 5:03:45 PM)
 * @param child system.ATGoal
 */
public void addChild(ATGoal child) {
	children.add(child);
}
/**
 * Insert the method's description here.
 * Creation date: (1/26/01 4:37:42 PM)
 * @param sp system.ATGoal
 */
public void addSecondaryParent(ATGoal sp) {
	secondaryParents.add(sp);
	
	ATGoalConnectorGRFX spgrfx = new ATGoalConnectorGRFX(false);
	spgrfx.place(sp.getGrfx(),this.getGrfx());

	spGrfx.add(spgrfx);
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public boolean checkSelected(int x, int y) {
	//check to see if object has been selected
	if(grfxObj.dist(x,y)) {
		return true;
	} else {
		return false;
	}
}
/**
 * Insert the method's description here.
 * Creation date: (10/25/99 11:28:36 PM)
 */
public void constructFromV1(String[] tokens,ATsystem sys) {
	
	//	name = tokens[loc];
	//	description = (String)tokens[loc+3];
	//	setName(name);
	
		int end=0;
		
		int loc  = ATtokenOps.findnextinstanceof("key", tokens, 0);
		if(loc != -1) {
			setKey(tokens[loc+3]);
			keybased = true;
		} else {
			setKey(ukh + sys.getNextKey());
		}
		
		loc = ATtokenOps.findnextinstanceof("num",tokens,0);
		String num = tokens[loc+3];
		loc = ATtokenOps.findnextinstanceof("desc",tokens,loc+2);
		int start=ATtokenOps.findnextinstanceof("description", tokens, loc+3);
	    loc  = ATtokenOps.findnextinstanceof("/description", tokens, start+2);
		description=ATtokenOps.extract(tokens,(start+2), (loc-2));
		
		//Get agent coordinates for graphics display
		
		loc = ATtokenOps.findnextinstanceof("gName",tokens,loc+2);
		String gNum = (String)tokens[loc+3];

		
		Enumeration goals = sys.returnGoals();
		ATGoal goal2;
		while(goals.hasMoreElements()){
			goal2 = (ATGoal)goals.nextElement();
			if(keybased) {
				if(goal2.getKey().equals(gNum)){
					setGoal(goal2);
					break;
				}
			} else {
				if(goal2.getNum().equals(gNum)){
					setGoal(goal2);
					break;
				}
			}
		}
		
		Num = num;
		grfxObj.setName(Num + " " + description);
			// don't really want to use setNum() because it is now a recursive
			// operation used for assigning the numbers of it and all its children
		
		setDescription(description);
		
		// partitioning
		loc = ATtokenOps.findnextinstanceof("gprt",tokens,loc+2);
	    if(loc != -1) {
		    String part = (String)tokens[loc+3];
			Partitioned = (part.equalsIgnoreCase("T"));
	    } else Partitioned = false;


	    // secondary parents

	    loc = ATtokenOps.findnextinstanceof("sps",tokens,loc+2);
		if(loc != -1) {
			loc = ATtokenOps.findnextinstanceof("sp",tokens,loc+1);
			while(loc != -1) {
				gNum = (String)tokens[loc+3];
				secondaryParents.add(gNum);
				loc = ATtokenOps.findnextinstanceof("sp",tokens,loc+1);

			//  Because we cannot guarantee that all the secondary parents are loaded
			//  before this goal is loaded, we save the gNum string and will run the
			//  link process after all the goals are loaded.
				
				/*goals = sys.returnGoals();
				while(goals.hasMoreElements()){
					goal2 = (ATGoal)goals.nextElement();
					if(goal2.getNum().equals(gNum)){
						secondaryParents.add(goal2);
						ATGoalConnectorGRFX spgrfx = new ATGoalConnectorGRFX(false);
						spgrfx.place(goal2.getGrfx(), this.getGrfx());
						spGrfx.add(spgrfx);
						break;
					}
				}
				*/
				
			}
		}
	    

		loc  = ATtokenOps.findnextinstanceof("view", tokens, loc+2);
		if (loc>0){ //KB-stored agents do not have view information
					//because they appear at a location the operator selects
			int x = Integer.parseInt(tokens[loc+5]);
			int y = Integer.parseInt(tokens[loc+11]);
			int h = Integer.parseInt(tokens[loc+17]);
			int w = Integer.parseInt(tokens[loc+23]);
	//		loc+=25;
			setCoordinates(x,y,h,w);
		}
		
		
		loc = ATtokenOps.findnextinstanceof("n_pts",tokens,loc+2);
		int j = 0;
		if(loc>0){
			j = Integer.parseInt(tokens[loc+3]);
			loc= loc +3;
		}
//		setCoordinates(component1,component2);
/*		for(int i=0; i<j; i++){
			int k = Integer.parseInt(tokens[loc+6]);
			//loc+=6;
			int l = Integer.parseInt(tokens[loc+12]);
			loc+=12;
			grfxCObj.Xs[i]=k;
			grfxCObj.Ys[i]=l;
		}
*/
		int[] xpos = new int[j];
		int[] ypos = new int[j];
		
		for(int i=0; i<j; i++){
			xpos[i] = Integer.parseInt(tokens[loc+6]);
			loc+=6;
			ypos[i] = Integer.parseInt(tokens[loc+6]);
			loc+=6;
		}
		grfxCObj.initializePoints(xpos,ypos);
		grfxCObj.Arrow();
	
//		setGoal(this.goal);
}
public int conversationCount() {
	//return the number of conversations connected to this agent
	return grfxObj.lineCount();
}
/**
 * Insert the method's description here.
 * Creation date: (2/5/01 12:53:26 PM)
 * @param child system.ATGoal
 */
public void decGoal() {
	int i = goal.children.indexOf(this);
	if(i>0) {
		goal.children.removeElementAt(i);
		goal.children.insertElementAt(this,i-1);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (6/8/00 3:43:20 PM)
 */
public void deleteMe() {
	if(goal!=null){
		goal.removechild(this);
		grfxCObj.deleteMe();
	}
}
/**
 * This method was created in VisualAge.
 */
public void draw(java.awt.Graphics g) {
	//draw the object
	grfxCObj.drawLine(g);
	grfxObj.drawObject(g,Partitioned);
	
	for(int i=0; i<spGrfx.size(); i++) {
		ATGoalConnectorGRFX spgrfx = (ATGoalConnectorGRFX)spGrfx.elementAt(i);
		spgrfx.drawLine(g);
	}	

	if(role==null && !Partitioned){
		grfxObj.drawHighlighted(g);
	}
	//if the object is selected, draw the selection box
	if(Selected==true){
		grfxObj.drawSelected(g);
	}

}
/**
 * Insert the method's description here.
 * Creation date: (2/9/01 3:44:16 PM)
 * @return java.util.Enumeration
 */
public Enumeration getChildren() {
	return children.elements();
}
/**
 * Insert the method's description here.
 * Creation date: (5/31/00 8:38:49 AM)
 * @return system.ATRole
 */
public ATGoal getGoal() {
	return goal;
}
/**
 * This method was created in VisualAge.
 * @return system.ATagentGRFX
 */
public ATgoalGRFX getGrfx() {
	return grfxObj;
}
/**
 * This method was created in VisualAge.
 */
public String getMAML() throws NullPointerException {
	//Opening line for an Component element
	MAML="";
	MAML+="\t<goal";
	MAML+=" version=\"" + Double.toString(version) + "\"";
	
	MAML += " key=\"" + getKey() + "\"";
	
	MAML+=" num=\"" + Num + "\"";
/*	if(description!="\""){
		MAML+=" desc=\"" + name + "\"";
	} else {
		MAML+=" desc=\" \"";
	}*/
	//New Line for Description element
	MAML+="\t\t<description>\n\t\t";
	MAML+=getDescription();
	MAML+="\n\t\t</description>\n";

	if(goal!=null){
		MAML+="\t\t<gName=\"" + goal.getKey() +"\"\n";
		//MAML+="\t\t<gName=\"" + goal.getNum() +"\"\n";
	} else {
		MAML+="\t\t<gName=\"" + "null" + "\"\n";
	}
	
	// partitioned status
	MAML+="\t\t<gprt=\"" + ((Partitioned) ? "T":"F") +"\"\n";

	// secondary parents
	MAML+="\t\t<sps=";
	for(int k=0; k<secondaryParents.size(); k++) {
		ATGoal sp = (ATGoal)secondaryParents.elementAt(k);
		MAML+="	sp=\"" + sp.getKey() + "\"";
		//MAML+="	sp=\"" + sp.getNum() + "\"";
	}
	MAML+="\n";
	
	
	int[] c = grfxObj.getCoords();
	MAML+="\t\t<view";
	MAML+=" x=\""+ c[0] + "\"";
	MAML+=" y=\""+ c[1] + "\"";
	MAML+=" w=\""+ c[2] + "\"";
	MAML+=" h=\""+ c[3] + "\"/>\n";

	MAML+=" n_pts=\""+grfxCObj.n()+"\"";//>\n";
	for(int j = 0; j<grfxCObj.n(); j++){
		MAML+=" x" +j+ "=\"" +grfxCObj.x(j) +"\"";
		MAML+=" y" +j+ "=\"" +grfxCObj.y(j) +"\"";
	}
	//End of encode sequence	
	MAML+="\t\t\t</goal>\n";

	return MAML;
}
/**
 * Insert the method's description here.
 * Creation date: (6/6/00 10:34:39 AM)
 * @return java.lang.String
 */
public String getNum() {
	return Num;
}
/**
 * Insert the method's description here.
 * Creation date: (10/24/00 4:49:00 PM)
 * @return boolean
 */
public boolean getPartition() {
	return Partitioned;
}
/**
 * Insert the method's description here.
 * Creation date: (1/26/01 4:37:09 PM)
 * @return java.util.Enumeration
 */
public Enumeration getSecondaryParents() {
	return secondaryParents.elements();
}
/**
 * Insert the method's description here.
 * Creation date: (6/7/00 2:58:27 PM)
 * @return boolean
 */
public boolean hasRole() {
	if(role == null){
		return false;
	} else {
		return true;
	}
}
/**
 * Insert the method's description here.
 * Creation date: (1/26/01 4:56:40 PM)
 * @return boolean
 * @param sp system.ATGoal
 */
public boolean hasSP(ATGoal sp) {
	return secondaryParents.contains(sp);
}
/**
 * Insert the method's description here.
 * Creation date: (2/5/01 12:53:26 PM)
 * @param child system.ATGoal
 */
public void incGoal() {
	int i = goal.children.indexOf(this);
	if(i+1 < goal.children.size()) {
		goal.children.removeElementAt(i);
		goal.children.insertElementAt(this,i+1);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (1/26/01 4:59:51 PM)
 * @return boolean
 * @param d system.ATGoal
 */
public boolean isDescendant(ATGoal d) {
	ATGoal child;
	for(int i=0; i<children.size(); i++) {
		child = (ATGoal)children.elementAt(i);
		if(child == d || child.isDescendant(d)) return true;
	}	
	return false;
}
/**
 * Insert the method's description here.
 * Creation date: (1/29/01 1:07:09 PM)
 * @return boolean
 * @param g system.ATGoal
 * @param sys system.ATsystem
 */
public boolean isSP(ATsystem sys) {
	java.util.Enumeration goals = sys.returnGoals();
	while(goals.hasMoreElements()) {
		ATGoal gtemp = (ATGoal)goals.nextElement();
		if(gtemp.hasSP(this)) return true;
	}
	return false;
}
/**
 * Insert the method's description here.
 * Creation date: (11/16/00 5:08:08 PM)
 */
public void leaveParent() {
	if(goal != null) {
		goal.removechild(this);	
		//grfxCObj;
	}
}
/**
 * Insert the method's description here.
 * Creation date: (1/29/01 12:39:11 PM)
 */
public void linkSecondaryParents(ATsystem sys) {
	Enumeration enum = secondaryParents.elements();
	Enumeration goals;
	ATGoal goal2;
	Vector sptemp = new Vector();
	String gNum;
	
	while (enum.hasMoreElements()) {
		gNum = (String)enum.nextElement();
		goals = sys.returnGoals();
		while (goals.hasMoreElements()) {
			goal2 = (ATGoal) goals.nextElement();
			if(keybased) {
				if (goal2.getKey().equals(gNum)) {
					sptemp.add(goal2);
					ATGoalConnectorGRFX spgrfx = new ATGoalConnectorGRFX(false);
					spgrfx.place(goal2.getGrfx(), this.getGrfx());
					spGrfx.add(spgrfx);
					break;
				}
			} else {
				if (goal2.getNum().equals(gNum)) {
					sptemp.add(goal2);
					ATGoalConnectorGRFX spgrfx = new ATGoalConnectorGRFX(false);
					spgrfx.place(goal2.getGrfx(), this.getGrfx());
					spGrfx.add(spgrfx);
					break;
				}
			}
		}
	}

	secondaryParents.removeAllElements();
	secondaryParents = sptemp;
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public void move(int x, int y, boolean snap) {
	//move the graphics object
	if(snap) 
		grfxObj.move(x,y,grfxObj.HORIZONTAL);
	else 
		grfxObj.move(x,y,grfxObj.FREE_MOVE);
		
	//grfxCObj.Arrow();
}
/**
 * Insert the method's description here.
 * Creation date: (11/17/00 3:24:10 PM)
 * @param tokens java.lang.String[]
 * @param sys system.ATsystem
 */
public void reconstruct(String[] tokens, ATsystem sys) {
	double v=Double.parseDouble(tokens[6]);
	setVersion(v);
	
	if (v>=1) constructFromV1(tokens,sys);
}
/**
 * Insert the method's description here.
 * Creation date: (11/16/00 5:04:54 PM)
 * @param child system.ATGoal
 */
public void removechild(ATGoal child) {
	children.remove(child);
}
/**
 * Insert the method's description here.
 * Creation date: (6/6/00 11:51:34 AM)
 * @param role system.ATRole
 */
public void removeRole() {
	role = null;
}
/**
 * Insert the method's description here.
 * Creation date: (1/26/01 4:38:20 PM)
 * @param sp system.ATGoal
 */
public void removeSecondaryParent(ATGoal sp) {
	int index = secondaryParents.indexOf(sp);
	
	secondaryParents.removeElementAt(index);	
	ATGoalConnectorGRFX spgrfx = (ATGoalConnectorGRFX)spGrfx.elementAt(index);
	spgrfx.deleteMe();
	spGrfx.removeElementAt(index);
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public void resize(int x, int y) {
	//resize the graphics object
	grfxObj.resize(x,y);
}
/**
 * Insert the method's description here.
 * Creation date: (1/26/01 3:02:35 PM)
 * @return system.ATGoal
 */
public ATGoal root() {
	if(goal == null) return this;
	else return goal.root();
}
/**
 * This method was created in VisualAge.
 */
public void setCoordinates(int x, int y, int width, int height) {
	grfxObj.place(x,y,width,height);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setDescription(String s) {
	description = s;
	//setNum();
	if((description!=null)&&(description.equals("null"))){
		description = null;
	}
	if(description!=null){
		grfxObj.setName(Num + " " + s);
		//grfxCObj.paint();
	} else {
		grfxObj.setName(Num);
	}
	grfxObj.resetMax();
}
/**
 * Insert the method's description here.
 * Creation date: (5/2/00 12:22:46 PM)
 * @param r system.ATRole
 */
public void setGoal(ATGoal g) {
	leaveParent();
	goal = g;

	if(g!=null) {
		
		setVPos(g.getGrfx().y2() + 50);
		setHPos(g.getGrfx().center_x - (this.grfxObj.width / 2));
		grfxCObj.place(g.getGrfx(),this.grfxObj);

		goal.addChild(this);

		this.Num = goal.Num + "." + (goal.subGoals());
		grfxObj.setName(Num + " " + description);
	}
	
	//setDescription(description);

//	setNum();
//	grfxCObj.Arrow();
}
/**
 * Insert the method's description here.
 * Creation date: (2/9/01 3:55:09 PM)
 * @param y int
 */
public void setHPos(int x) {
	grfxObj.place(x + (grfxObj.width/2),grfxObj.y1()+(grfxObj.height/2),grfxObj.width,grfxObj.height);
}
/**
 * Insert the method's description here.
 * Creation date: (7/17/00 10:53:13 AM)
 * @param n java.lang.String
 */
public void setName(String n) {}
/**
 * Insert the method's description here.
 * Creation date: (11/17/00 1:45:16 PM)
 * @param n int
 */
public void setNum(String n) {
	Num = n;
	grfxObj.setName(Num + " " + description);

	for(int i=0; i<children.size(); i++) {
		ATGoal child = (ATGoal)children.elementAt(i);
		child.setNum(Num + "." + (i+1));
	}
}
/**
 * Insert the method's description here.
 * Creation date: (10/24/00 4:32:12 PM)
 */
public void setPartition(boolean p) {
	Partitioned = p;
}
/**
 * Insert the method's description here.
 * Creation date: (6/6/00 1:01:02 PM)
 * @param r system.ATRole
 */
public void setRole(ATRole r) {
	role = r;
	}
/**
 * Insert the method's description here.
 * Creation date: (11/16/00 2:30:53 PM)
 * @param v double
 */
public void setVersion(double v) {
	this.version = v;
	grfxObj.setVersion(v);	
}
/**
 * Insert the method's description here.
 * Creation date: (2/9/01 3:55:09 PM)
 * @param y int
 */
public void setVPos(int y) {
	grfxObj.place(grfxObj.x1() + (grfxObj.width/2),y+(grfxObj.height/2),grfxObj.width,grfxObj.height);
}
/**
 * Insert the method's description here.
 * Creation date: (11/16/00 4:01:54 PM)
 * @return int
 * @param minposx int
 * @param minposy int
 * @param dy int
 */
public java.awt.Point snap(int minposx) {
	int maxposx = minposx;
	
	Enumeration childEnum = children.elements();

	java.awt.Point bound = new java.awt.Point(0,0);
	
	while(childEnum.hasMoreElements()) {
		ATGoal child = (ATGoal)childEnum.nextElement();
		bound = child.snap(maxposx);
		if(bound.x > maxposx) maxposx = bound.x;
	}

	
	if((maxposx - minposx) < grfxObj.width) {
		setHPos(minposx);
		maxposx = minposx + grfxObj.width + 10;
	} else {
		setHPos((minposx + maxposx - 10 - grfxObj.width)/2);
	}

	boolean buffered = false;
	if(bound.y == 1) {
		buffered = true;
	}
	if(!buffered && !children.isEmpty()) {
		maxposx += 20;
		buffered = true;
	}
	
	return new java.awt.Point(maxposx, (buffered) ? 1 : 0);
}
/**
 * Insert the method's description here.
 * Creation date: (1/26/01 5:25:55 PM)
 * @return int
 */
public int spCount() {
	return secondaryParents.size();
}
/**
 * Insert the method's description here.
 * Creation date: (6/6/00 10:31:09 AM)
 * @return int
 */
public int subGoals() {
	return children.size();
}
}
