package system;

/**
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
import java.util.*;
public class ATRole extends ATobject{

	private Vector tasks;
	private Vector agents = null;
	//private Vector goals = null;
	private Vector roles = null;
	///--graphics objects stuff.

	//actual graphics object
	private ATroleGRFX grfxObj;
//	private ATroleGRFX2 grfxObj2;
	//keeps track of whether agent is selected or not 
	public boolean Selected = false;
	private static final String ukh = "role@";
/**
 * ATagent constructor comment.
 */
public ATRole(double ver, String[] tokens, ATsystem sys) {
	this(ver,0); //*** Version 1 of ATagent ***
	
	int loc = ATtokenOps.findnextinstanceof("version",tokens,0);
	double v=Double.parseDouble(tokens[loc+3]);
	//setVersion(v);
  //Code for constructing object model from MAML tokens
	if (v>=1) constructFromV1(tokens, sys);
	else {
		System.out.println("Loading a version other than 1.");	
	}
 	//	System.out.println("Loaded an agent");
}
	//keeps track of whether an agent's corner is selected
	
/**
 * ATagent constructor comment.
 */
public ATRole(double v, int keynum) {
	super(v);
	setKey(ukh + keynum);
	MAMLheader+="<!DOCTYPE agent SYSTEM \"atagent"+Double.toString(getVersion())+".dtd\">\n";
	grfxObj = new ATroleGRFX();
//	grfxObj2 = new ATroleGRFX2();
	agents = new Vector();
	//goals = new Vector();
	roles = new Vector();
	tasks = new Vector();
}
/**
 * ATagent constructor comment.
 */
public ATRole(double ver, String x, ATsystem sys) {
	this(ver,ATtokenOps.parseLine(x),sys);
}
	//keeps track of whether an agent's corner is selected
	
/**
 * ATagent constructor comment.
 */
public ATRole(ATRole cp) {
	super(cp);
}
/**
 * Insert the method's description here.
 * Creation date: (5/19/00 10:29:50 AM)
 * @param a afit.system.ATagent
 */
public void addAgent(ATagent a) {
	agents.add(a);
	}
/**
 * Insert the method's description here.
 * Creation date: (5/2/00 12:36:45 PM)
 * @param t afit.system.ATTask
 */
public void addRole(ATRole2 r) {
	roles.add(r);
	}
/**
 * Insert the method's description here.
 * Creation date: (5/2/00 12:36:45 PM)
 * @param t afit.system.ATTask
 */
public void addTask(ATTask t) {
	tasks.add(t);
//	t.setRole(this);
	}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public boolean checkSelected(int x, int y) {
	//check to see if object has been selected
	if(grfxObj.dist(x,y)) {
	//	Selected = true;
		return true;
	} else {
	//	Selected = false;
		return false;
	}
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public boolean checkSelected2(int x, int y) {
	//check to see if object has been selected
/*	if(grfxObj2.dist(x,y)) {
	//	Selected = true;
		return true;
	} else {
	//	Selected = false;
		return false;
	}*/
	return true;
}
/**
 * Insert the method's description here.
 * Creation date: (12/21/00 3:53:08 PM)
 */
public void clearGoals() {
		grfxObj.goals.removeAllElements();
	}
/**
 * Insert the method's description here.
 * Creation date: (10/25/99 11:28:36 PM)
 */
public void constructFromV1(String[] tokens, ATsystem sys) {
	
	   	int end=0;
		int loc = ATtokenOps.findnextinstanceof("name",tokens,0);
		setName(tokens[loc+3]);

		boolean keybased = false;
		
		loc  = ATtokenOps.findnextinstanceof("key", tokens, loc);
		if(loc != -1) {
			setKey(tokens[loc+3]);
			keybased = true;
		} else {
			setKey(ukh + sys.getNextKey());
		}
	
		int start=ATtokenOps.findnextinstanceof("description", tokens, loc+3);
	    loc  = ATtokenOps.findnextinstanceof("/description", tokens, start+2);
		description=ATtokenOps.extract(tokens,(start+2), (loc-2));
		
		int hold = ATtokenOps.findnextinstanceof("goals:",tokens,loc);
		if(hold>=0){
			loc = hold;
			int j = Integer.parseInt(tokens[loc+12]);
			loc = loc+12;
			Enumeration Goals;
			for(int i=0; i<j; i++){
				Goals = sys.returnGoals();
				loc = ATtokenOps.findnextinstanceof("Num",tokens,loc);
				String num = tokens[loc+3];
				loc = loc+3;
				while(Goals.hasMoreElements()){
					ATGoal goal = (ATGoal)Goals.nextElement();
					if(keybased) {
						if((goal.getKey()).equals(num)){
							grfxObj.goals.addElement(goal);
							goal.setRole(this);
							if(goal.getPartition()) {
								goal.setPartition(false);
								System.out.println("\nGoal "+goal.getNum()+" was an invalidly partitioned goal!  The partition status has been removed.\n");
							}
						}
					} else {
						if((goal.getNum()).equals(num)){
							grfxObj.goals.addElement(goal);
							goal.setRole(this);
							if(goal.getPartition()) {
								goal.setPartition(false);
								System.out.println("\nGoal "+goal.getNum()+" was an invalidly partitioned goal!  The partition status has been removed.\n");
							}
						}
					}
				}
			}
			//setGoals(goals);
		}
		//Get agent coordinates for graphics display
		loc  = ATtokenOps.findnextinstanceof("view", tokens, loc+2);
		if (loc>0){ //KB-stored agents do not have view information
					//because they appear at a location the operator selects
			int x = Integer.parseInt(tokens[loc+5]);
			int y = Integer.parseInt(tokens[loc+11]);
			int h = Integer.parseInt(tokens[loc+17]);
			int w = Integer.parseInt(tokens[loc+23]);
			setCoordinates(x,y,h,w);
		}
//		start   = findnextinstanceof("architecture", tokens, end);
		//Need to locate "match" for this architecture, not for possible sub-architectures.
//		end     = findnextinstanceof("/agent", tokens, start);
//		end     = findlastinstanceof("/architecture", tokens, start, end);
//		submaml = extract(tokens, (start-1), (end+1));
}
public int conversationCount() {
	//return the number of conversations connected to this agent
	return grfxObj.lineCount();
}
/**
 * Insert the method's description here.
 * Creation date: (6/12/00 8:04:30 AM)
 */
public void deleteMe() {
	Enumeration g = grfxObj.goals.elements();
	ATGoal goal;
	while(g.hasMoreElements()){
		goal = (ATGoal)g.nextElement();
		goal.setRole(null);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (7/5/00 9:38:04 AM)
 * @param agent afit.system.ATagent2
 */
public void deleteTask(ATTask task) {
	tasks.remove(task);
	}
/**
 * This method was created in VisualAge.
 */
public void draw(java.awt.Graphics g) {
	
	//draw the object
	grfxObj.drawObject(g);
	if(agents.isEmpty()){
		grfxObj.drawHighlighted(g);
	}
	//if the object is selected, draw the selection box
	if(Selected==true){
		grfxObj.drawSelected(g);
	}
	
}
/**
 * Insert the method's description here.
 * Creation date: (5/18/00 2:05:13 PM)
 * @return java.util.Enumeration
 */
public Vector getGoals() {
	return grfxObj.goals;
}
/**
 * This method was created in VisualAge.
 * @return system.ATagentGRFX
 */
public ATroleGRFX getGrfx() {
	return grfxObj;
}
/**
 * Insert the method's description here.
 * Creation date: (4/25/00 2:38:12 PM)
 */
public String getMAML() throws NullPointerException {
	
	//Opening line for a Role element
	MAML = "";
	MAML += "\t<role";
	MAML += " version=\"" + Double.toString(version) + "\"";
	MAML += " name=\"" + name + "\">\n";
	//New Line for Description element
	
	MAML += " key=\"" + getKey() + "\"";
	
	MAML += "\t\t<description>\n\t\t";
	MAML += getDescription();
	MAML += "\n\t\t</description>\n";
	MAML += "\t\t<goals: \n";
	Enumeration goalz = grfxObj.goals.elements();
	ATGoal goal;
	MAML += "\t\t\t num of goals = \"" + grfxObj.goals.size() + "\"\n";
	while(goalz.hasMoreElements()){
		goal = (ATGoal)goalz.nextElement();
		MAML+= "\t\t\tNum=\"" + goal.getKey() + "\"\n";
		//MAML+= "\t\t\tNum=\"" + goal.getNum() + "\"\n";
	}
	int[] c = grfxObj.getCoords();
	MAML += "\t\t<view";
	MAML += " x=\"" + c[0] + "\"";
	MAML += " y=\"" + c[1] + "\"";
	MAML += " w=\"" + c[2] + "\"";
	MAML += " h=\"" + c[3] + "\"/>\n";
	//Closing line for an Agent element		
	MAML += "\t</role>\n";

	return MAML;
	
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getName() {
	return name;
}
/**
 * Insert the method's description here.
 * Creation date: (11/7/00 4:10:36 PM)
 * @return java.util.Vector
 */
public Vector getTasks() {
	return getTasks(false);
}
/**
 * Insert the method's description here.
 * Creation date: (11/7/00 4:12:48 PM)
 * @return java.util.Vector
 * @param reference boolean
 */
public Vector getTasks(boolean reference) {
	if(reference) {
		return tasks;
	} else {
		return (Vector)tasks.clone();
	}
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public void move(int x, int y) {
	//move the graphics object
	grfxObj.move(x,y);
}
/**
 * Insert the method's description here.
 * Creation date: (1/17/01 12:52:43 PM)
 * @return boolean
 */
public boolean noSeqDiagRoles() {
	if(roles.size() > 0) return false;
	return true;
}
/**
 * Insert the method's description here.
 * Creation date: (6/8/00 3:17:14 PM)
 * @return boolean
 */
public boolean nothingAttached() {
	if(grfxObj.lineCount()!=0){
		return false;
	}

	return true;
}
/**
 * This method was created in VisualAge.
 */
public void print(java.awt.Graphics g) {
	grfxObj.paint(g);
}
/**
 * Insert the method's description here.
 * Creation date: (5/19/00 10:30:31 AM)
 * @param a system.ATagent
 */
public void removeAgent(ATagent a) {
	agents.removeElement(a);
	}
/**
 * Insert the method's description here.
 * Creation date: (1/26/01 12:55:55 PM)
 * @param role system.ATRole2
 */
public void removeRole(ATRole2 r) {
	roles.remove(r);	
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public void resize(int x, int y) {
	//resize the graphics object
	grfxObj.resize(x,y);
}
/**
 * This method was created in VisualAge.
 */
public void setCoordinates(int x, int y, int width, int height) {
	grfxObj.place(x,y,width,height);
}
/**
 * Insert the method's description here.
 * Creation date: (5/18/00 2:05:13 PM)
 * @return java.util.Enumeration
 */
public void setGoals(Vector r) {
	
	grfxObj.goals = r;
	
	// Because the graphics object now holds the actual vector of goals, there is no
	// longer a need for this function.
	/*Vector hold = new Vector();
	java.util.Enumeration enum = goals.elements();
	ATGoal goal;
	while(enum.hasMoreElements()){
		goal = (ATGoal)enum.nextElement();
		hold.add((String)goal.getNum());
	}
	grfxObj.setGoals(hold);
	*/
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setName(String s) {
	name = ATtokenOps.validName(s);
	//set the name of the graphics object
	grfxObj.setName(name);
//	grfxObj2.setName(name);
	//resize the graphics object accordingly
	grfxObj.resetMax();
	Enumeration r = roles.elements();
	ATRole2 role2;
	while(r.hasMoreElements()){
		role2 = (ATRole2)r.nextElement();
		role2.updateRoleName();
	}
	Enumeration a = agents.elements();
	ATagent agent;
	while(a.hasMoreElements()){
		agent = (ATagent)a.nextElement();
		agent.resetRoleNames();
	}
}
/**
 * Insert the method's description here.
 * Creation date: (7/17/00 2:17:09 PM)
 */
public void writeDATA() {
	super.writeDATA();
	MAML+= "\n\tTasks:\n";
	Enumeration tasks = this.tasks.elements();
	ATTask task;
	while(tasks.hasMoreElements()){
		task = (ATTask)tasks.nextElement();
		MAML+= "\t" + task.getName() + "\n";
	}
	MAML+="\n\tGoals:\n";
	Enumeration goals = getGoals().elements();
	ATGoal goal;
	while(goals.hasMoreElements()){
		goal = (ATGoal)goals.nextElement();
		MAML+= "\t" + goal.getNum() + "\n";
	}
	MAML+="\n\tAgents:\n";
	Enumeration agents = this.agents.elements();
	ATagent agent;
	while(agents.hasMoreElements()){
		agent = (ATagent)agents.nextElement();
		MAML+= "\t" + agent.getName() + "\n";
	}
	
}
}
