package system;

/**
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
public class ATagentComponentAttribute extends ATobject {
	private String  type = " ";
	private String  attrView;
	private String  initialValue;
	private boolean userDefined;
	private boolean runTimeDefined;
	private boolean set;
	private boolean sequence;
	private boolean bag;
	private static final String ukh = "compatt@";
/**
 * ATagentComponentAttribute constructor comment.
 */
public ATagentComponentAttribute(String[] tokens, ATsystem sys) {
	this(0);
		int loc = ATtokenOps.findnextinstanceof("name",tokens,0);
  		setName(tokens[loc+3]);
		setType(tokens[loc+9]);
		setIsRunTimeDefined(tokens[loc+15].equals("true"));
		setIsUserDefined(tokens[loc+21].equals("true"));
		setIsSet(tokens[loc+27].equals("set"));
		setIsBag(tokens[loc+27].equals("bag"));
		setIsSequence(tokens[loc+27].equals("seq"));

		loc = ATtokenOps.findnextinstanceof("key", tokens, 30);
		if(loc != -1) {
			setKey(tokens[loc+3]);
		} else {
			setKey(ukh + sys.getNextKey());
		}
		
		loc = ATtokenOps.findnextinstanceof("initialvalue", tokens, 30) + 3;
	    initialValue = (tokens[loc].equals("\"") ? "" : tokens[loc]);

	   setAttrView();	
}
/**
 * ATagentComponentAttribute constructor comment.
 */
public ATagentComponentAttribute(int keynum) {
  super(1);
  setKey(ukh + keynum);
}
/**
 * ATagentComponentAttribute constructor comment.
 */
public ATagentComponentAttribute(String maml, ATsystem sys) {
	this(ATtokenOps.parseLine(maml),sys);
}
/**
 * ATagentComponentAttribute constructor comment.
 */
public ATagentComponentAttribute(ATagentComponentAttribute cp) {
	super(cp);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getAttrView() {
	return attrView;
}
/**
 * Insert the method's description here.
 * Creation date: (11/1/99 11:57:35 AM)
 * @return java.lang.String
 */
public String getCType() {

if (sequence) return "sequence";
if (bag) return "bag";
if (set) return "set";
return "none";
}
/**
 * Insert the method's description here.
 * Creation date: (11/3/00 11:42:19 AM)
 */
public String getInitialValue() {

	return initialValue;	

}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public boolean getIsBag() {
	return bag;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public boolean getIsRunTimeDefined() {
	return runTimeDefined;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public boolean getIsSequence() {
	return sequence;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public boolean getIsSet() {
	return set;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public boolean getIsUserDefined() {
	return userDefined;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getMAML() throws Exception {
	//Opening line for an Method element
	MAML="";
	MAML+="\t\t\t\t<attribute";
	MAML+=" name=\"" + name + "\"";
	MAML+=" type=\""+type+"\"";
	MAML+=" runtimedefined=\""+runTimeDefined+"\"";
	MAML+=" userdefined=\""+userDefined+"\"";
	MAML+=" collectiontype=\""+getCType()+"\"";
	
	MAML+=" key=\"" + getKey() + "\"";
	
	MAML+=" initialvalue=\""+initialValue+"\"/>\n";
	
	return MAML;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getName() {
	return name;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getType() {
	return type;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setAttrView()
{
	boolean setBagSeq = set || sequence || bag;

	//format overall attribute view
	if (setBagSeq == false)
		attrView = name + ":" + type;
	else
		if (set == true)
			attrView = name + ":Set(" + type + ")";
		else
			if (sequence == true)
				attrView = name + ":Sequence(" + type + ")";
			else
				if (bag == true)
					attrView = name + ":Bag(" + type + ")";

	//add special identifiers to attribute
	if (runTimeDefined == true && userDefined == false)
		attrView = "-" + attrView;
	else
		if (runTimeDefined == false && userDefined == true)
			attrView = "+" + attrView;
		else
			if (runTimeDefined == true && userDefined == true)
				attrView = "" + attrView;
			else
				if (runTimeDefined == false && userDefined == false)
					attrView = "  " + attrView;
}
/**
 * Insert the method's description here.
 * Creation date: (11/3/00 11:43:12 AM)
 * @param ival java.lang.String
 */
public void setInitialValue(String ival) {
	
	initialValue = ival;
	
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setIsBag(boolean b) {
	bag = b;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setIsRunTimeDefined(boolean r)
{
	runTimeDefined = r;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setIsSequence(boolean s) {
	sequence = s;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setIsSet(boolean s) {
	set = s;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setIsUserDefined(boolean u)
{
	userDefined = u;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setName(String s) {
	name = ATtokenOps.validName(s);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setType(String s) {
	if(s.equals("") || s.equals("\"")) {
		type = " ";
	} else {
		type = s;
	}
	//type = s;
}
}
