package system;

/**
 * message between two roles in a sequence diagram
 * Insert the type's description here.
 * Creation date: (6/16/00 8:30:15 AM)
 * @author: 
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
 import java.awt.*;
 import java.util.*;
public class ATmessage extends ATobject {
	private ATRole2 first, second;
	private ATmessageGRFX grfxObj;
	public boolean Selected = false;
	private static final String ukh = "mess@";
/**
 * ATagent constructor comment.
 */
public ATmessage(double ver, String[] tokens,ATseqDiag seqD, ATsystem sys) {
	this(ver,0); //*** Version 1 of ATagent ***
	
	int loc = ATtokenOps.findnextinstanceof("version",tokens,0);
	double v=Double.parseDouble(tokens[loc+3]);
	//setVersion(v);
  //Code for constructing object model from MAML tokens
	if (v>=1) constructFromV1(tokens,seqD, sys);
	else {
		System.out.println("Loading a version other than 1.");	
	}
 	//	System.out.println("Loaded an agent");
}
/**
 * Insert the method's description here.
 * Creation date: (6/19/00 10:21:45 AM)
 */
public ATmessage(double v, int keynum) {
	super(v);
	setKey(ukh+keynum);
	grfxObj = new ATmessageGRFX();
	}
/**
 * ATagent constructor comment.
 */
public ATmessage(double ver, String x,ATseqDiag seqD, ATsystem sys) {
	this(ver,ATtokenOps.parseLine(x),seqD,sys);
}
/**
 * Insert the method's description here.
 * Creation date: (6/19/00 10:21:45 AM)
 */
public ATmessage(ATmessage cp) {
	super(cp);
}
/**
 * Insert the method's description here.
 * Creation date: (6/19/00 1:47:46 PM)
 * @return boolean
 * @param x int
 * @param y int
 */
public boolean checkSelected(int x, int y) {
	return grfxObj.checkSelected(x,y);
}
/**
 * Insert the method's description here.
 * Creation date: (10/25/99 11:33:58 PM)
 * @param tokens java.lang.String[]
 */
public void constructFromV1(String[] tokens, ATseqDiag seqD, ATsystem sys) {
	
	String submaml=null;
//	int start=0;
//	int end=0;
	String fName = null,sName = null;	
	int loc = ATtokenOps.findnextinstanceof("name",tokens,0);
	setName(tokens[loc+3]);

//	description=tokens[18];
/*	start = findnextinstanceof("description", tokens, 15);
	end   = findnextinstanceof("/description", tokens, start+2);
	description=extract(tokens,(start+2), (end-2));
*/

	boolean keybased = false;
	loc  = ATtokenOps.findnextinstanceof("key", tokens, 0);
	if(loc != -1) {
		setKey(tokens[loc+3]);
		keybased = true;
	} else {
		setKey(ukh + sys.getNextKey());
	}
	
	int hold = ATtokenOps.findnextinstanceof("first", tokens, 12);
	fName = tokens[hold+3];
	hold = ATtokenOps.findnextinstanceof("second", tokens, hold);
	sName = tokens[hold+3];
	ATRole2 temp;


	if(seqD!=null){
		Enumeration roles = seqD.returnRoles();
		while(roles.hasMoreElements()){
			temp = (ATRole2)roles.nextElement();
			if(keybased) {
				if ((temp.getKey().equals(fName)))   first=temp;
				if ((temp.getKey().equals(sName)))   second=temp;
			} else {
				if ((temp.getFullName()!=null)&&((temp.getFullName()).equals(fName)))   first=temp;
				if ((temp.getFullName()!=null)&&((temp.getFullName()).equals(sName)))   second=temp;
			}
		}
		if(first == null) {
			System.out.println("Error!!!  Role " + fName + " not found.");
		} else if(second == null) {
			System.out.println("Error!!!  Role " + sName + " not found.");
		} else {
			setFirst(first);
			setSecond(second);
			grfxObj.refresh(first.getGrfx(), second.getGrfx());
		}
	}
	hold = ATtokenOps.findnextinstanceof("view", tokens, hold);
	grfxObj.y = Integer.parseInt(tokens[hold+6]);
	grfxObj.arrow();
	}
/**
 * Insert the method's description here.
 * Creation date: (6/20/00 11:30:57 AM)
 */
public void deleteMe() {
	grfxObj.deleteMe();
}
/**
 * Insert the method's description here.
 * Creation date: (6/16/00 8:35:48 AM)
 * @param g java.awt.Graphics
 */
public void draw(Graphics g) {
	grfxObj.draw(g);
	if(Selected){
		grfxObj.drawSelected(g);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 12:54:34 PM)
 * @return system.ATRole2
 */
public ATRole2 getFirstRole() {
	return first;
}
/**
 * Insert the method's description here.
 * Creation date: (6/19/00 2:20:39 PM)
 * @return int
 */
public int getHeight() {
	return grfxObj.y;
}
/**
 * encodeMAML method comment.
 */
public String getMAML() throws NullPointerException {
	MAML="";
//	String hold=null;
	//Opening line for an Transisiton element
	MAML+="\t\t\t<message";
//	if (nextState==null) hold="none";
//	else hold=nextState.getName();
	MAML+=" version=\"" + Double.toString(version) + "\"";
	MAML+=" name=\"" + name +"\"";
	
	MAML += " key=\"" + getKey() + "\"";
	
	MAML+=" first=\"" + first.getKey() + "\"";	
	MAML+=" second=\"" + second.getKey() + "\"";
	//MAML+=" first=\"" + first.getFullName() + "\"";	
	//MAML+=" second=\"" + second.getFullName() + "\"";
	
	
	MAML+="\n\t\t\t<view";
		MAML+=" y =\"" +grfxObj.y +"\"";
	MAML+="</message>";

	return MAML;
}
/**
 * Insert the method's description here.
 * Creation date: (6/19/00 2:30:50 PM)
 * @return java.lang.String
 */
public String getName() {
	return name;
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 12:54:57 PM)
 * @return system.ATRole2
 */
public ATRole2 getSecondRole() {
	return second;
}
/**
 * Insert the method's description here.
 * Creation date: (6/19/00 1:57:02 PM)
 * @param dy int
 */
public void move(int dy) {
	grfxObj.move(dy);
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 12:55:38 PM)
 */
public void refresh(int n) {
	grfxObj.refresh(getFirstRole().getGrfx(), getSecondRole().getGrfx(), n);
}
/**
 * Insert the method's description here.
 * Creation date: (6/19/00 11:52:07 AM)
 * @param f system.ATRole2
 */
public void setFirst(ATRole2 f) {
	if(f!=null && f!= second){
		if(first!=null) (first.getGrfx()).deleteMessage(grfxObj);
		this.first = f;
		(first.getGrfx()).addMessage(grfxObj);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (12/6/00 1:00:01 PM)
 * @param h int
 */
public void setHeight(int h) {
	grfxObj.setHeight(h);
	}
/**
 * Insert the method's description here.
 * Creation date: (6/19/00 12:01:07 PM)
 * @param n java.lang.String
 */
public void setName(String n) {
	name = ATtokenOps.validName(n);
	grfxObj.setName(name);
	}
/**
 * Insert the method's description here.
 * Creation date: (6/19/00 11:52:07 AM)
 * @param f system.ATRole2
 */
public boolean setSecond(ATRole2 r) {
	if(r!= null && r!= first){
		if(second != null) (second.getGrfx()).deleteMessage(grfxObj);
		
		this.second = r;
		(second.getGrfx()).addMessage(grfxObj);
		grfxObj.refresh(first.getGrfx(), second.getGrfx());
		return true;
	}
	return false;
}
}
