package system;

/**
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
//___________________________________________________
// Class to represent a line
//___________________________________________________
import java.io.*;
import java.util.*;
import java.awt.*;

public class ATrole2GRFX {

	// Current position of square
	int x1, x2, y2;
	static int y1 = 50;
	int length = 300;
	//position of square - center point
	int center_x, center_y;
	
	//height and width of square	
	int width;
	int height;
	
	String name = "";
//	String action = "";
	private int Max=60;
	Vector messages = null;

public ATrole2GRFX() {
	super();
	x1 = 50;
	width = 50;
	center_x = x1 + width/2;
	messages = new Vector();
}
public ATrole2GRFX(int n) {
	super();
	x1 = 20 + (n-1) * 50;
	width = 50;
	center_x = x1 + width/2;
	messages = new Vector();
}
public ATrole2GRFX(ATrole2GRFX cp) {
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (6/19/00 1:15:19 PM)
 * @param message afit.system.ATmessage
 */
public void addMessage(ATmessageGRFX message) {
	messages.add(message);
}
/**
 * Method returns a value for the minumum position a message should be placed at.
 * Creation date: (1/19/01 11:06:24 AM)
 * @return int
 */
public int base() {
	return y2 + 20;
}
/**
 * Insert the method's description here.
 * Creation date: (7/11/00 4:11:32 PM)
 * @return boolean
 * @param x int
 * @param y int
 */
public boolean checkLineSelected(int x, int y) {
	int dx , dy;
	if(x>center_x){
		dx = x-center_x;
	} else {
		dx = center_x-x;
	}
	if(dx<5 && y>y2 && y<y2+length){
		return true;
	}
	return false;
}
/**
 * Insert the method's description here.
 * Creation date: (2/5/01 2:43:25 PM)
 */
public void deleteMe() {
	messages.removeAllElements();
	messages = null;
}
/**
 * Insert the method's description here.
 * Creation date: (6/20/00 11:32:07 AM)
 * @param m afit.system.ATmessageGRFX
 */
public void deleteMessage(ATmessageGRFX m) {
//	int i = messages.indexOf(m);
	messages.remove(m);
//	messages.remove(i);
	}
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	// Calculate distance from center of line to a point in space
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	public boolean dist(int x, int y) {
		
		if(((x1<x)&&(y1<y))&&((x<x2)&&(y<y2))){
			return true;
		}  else {
			return false;
		}
		
	}
	//- - - - - - - - -
	// Draw a blue line
	//- - - - - - - - -
public void drawObject(java.awt.Graphics g){
	Font f = g.getFont();
	FontMetrics fm = g.getFontMetrics(); // SAD Change - deprecated fix???
	int textHeight = fm.getHeight();
	int textWidth = fm.stringWidth(name);
	
	Max = 60;
	width = Max;
	x2 = x1 + Max;
		
	height = textHeight  + 9;
	y2 = y1 + height;
	if ((textWidth) > (Max))
	{
		Max = textWidth + 6;
		width = Max;
		x2 = x1 + Max;
	}

	int oldcenter = center_x;
	center_x = x1 + width/2;

	if(oldcenter != center_x) moveConnections();
	
	int center = x1 + (width - textWidth) / 2;
	
	g.setColor(new java.awt.Color(255,255,225)); 
	g.fillRoundRect(x1,y1,width,height,15,15);
	
	g.setColor(new java.awt.Color(0,0,155));
	g.drawRoundRect(x1,y1,width,height,15,15);
	
	g.setColor(Color.black);	
	g.drawString(name,center,y1+18);
		
	g.drawLine(center_x, y2, center_x, y2+length);
}
	//- - - - - - - - -
	// Draw a blue line
	//- - - - - - - - -
public void drawSelected(java.awt.Graphics g) {
	//draw and orange rectangle just inside the perimeter of the
	//component and one just outside the perimeter
	g.setColor(new java.awt.Color(255,170,71));
	g.drawLine(x1-1, y1-1, x2+1, y1-1);   
	g.drawLine(x2+1, y1-1, x2+1, y2+1);
	g.drawLine(x2+1, y2+1, x1-1, y2+1);
	g.drawLine(x1-1, y2+1, x1-1, y1-1);
	g.drawLine(x1+1, y1+1, x2-1, y1+1);   
	g.drawLine(x2-1, y1+1, x2-1, y2-1);
	g.drawLine(x2-1, y2-1, x1+1, y2-1);
	g.drawLine(x1+1, y2-1, x1+1, y1+1);
}
/**
 * Insert the method's description here.
 * Creation date: (10/25/99 1:09:26 PM)
 */
public int[] getCoords() {
	
	int[] c= new int[4];
		c[0]=center_x;
		c[1]=center_y;
		c[2]=width;
		c[3]=height;
	return c;
	}
/**
 * Insert the method's description here.
 * Creation date: (7/11/00 4:17:39 PM)
 * @return int
 */
public int getLength() {
	return length;
}
/**
 * Insert the method's description here.
 * Creation date: (1/19/01 10:58:40 AM)
 * @return java.util.Vector
 */
public Enumeration getMessages() {
	return messages.elements();
}
/**
 * Insert the method's description here.
 * Creation date: (6/20/00 11:27:47 AM)
 * @return boolean
 */
public boolean hasNoMessages() {
	return messages.isEmpty();
}
/**
 * Insert the method's description here.
 * Creation date: (7/11/00 4:23:18 PM)
 * @return int
 */
public int lineEnd() {
	return y2+length;
}
/**
 * Insert the method's description here.
 * Creation date: (7/11/00 3:12:35 PM)
 * @return int
 */
public int messageCount() {
	return messages.size();
}
	//- - - - - - - - - - - - - -
	// Move line to new position
	//- - - - - - - - - - - - - -
	public void move(int dx, int dy) {

		// Calculate new center

		center_x = dx;
		x1 = center_x - (width/2);
		x2 = x1 + width;
		
		moveConnections();
	}
/**
 * Insert the method's description here.
 * Creation date: (1/26/01 1:14:26 PM)
 */
public void moveConnections() {
	
	Enumeration m = messages.elements();
	ATmessageGRFX message;
	while(m.hasMoreElements()){
		message = (ATmessageGRFX)m.nextElement();
		if(message.start == this){
			message.x1=center_x;
			message.arrow();
		} else {
			message.x2=center_x;
			message.arrow();
		}
	}
	
}
	//- - - - - - - - - - - - - - - - - - - -
	// Place a new line in its first position
	//- - - - - - - - - - - - - - - - - - - -
	public void place(int fx1, int fy1, int fx2, int fy2) {
		x2 = fx1+fx2/2;
		y2 = fy1+fy2/2;
		x1 = fx1-fx2/2;
		y1 = fy1-fy2/2;
		
		center_x = fx1;
		center_y = fy1;
		width = fx2;;
		height = fy2;
	}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void resetMax() {
	Max=60;
}
/**
 * Insert the method's description here.
 * Creation date: (7/11/00 3:18:38 PM)
 * @param l int
 */
public void setLength(int l) {
	length = l;}
/**
 * Insert the method's description here.
 * Creation date: (6/15/00 3:03:35 PM)
 * @param s java.lang.String
 */
public void setName(String s) {
	this.name = s;
}
/**
 * Insert the method's description here.
 * Creation date: (1/19/01 11:13:05 AM)
 * @return int
 */
public int tip() {
	return y2 + length - 20;
}
/**
 * Insert the method's description here.
 * Creation date: (1/19/01 3:16:52 PM)
 * @return int
 */
public int x2() {
	return x2;
}
}
