package system;

/**
 * system in the deployment diagram
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
import java.util.*;
public class ATsys extends ATobject {

	//name of the agent
	private Vector agents = null;
	///--graphics objects stuff.

	//actual graphics object
	private ATsysGRFX grfxObj;
	//keeps track of whether agent is selected or not 
	public boolean Selected = false;
	public boolean cornerSelected = false;
	public boolean edgeSelected = false;
	private int selCorner = -1;
	private int selEdge = -1;
	private static final String ukh = "sys@";
/**
 * ATagent constructor comment.
 */
public ATsys(double ver, String[] tokens, ATsystem sys) {
	this(ver,0); //*** Version 1 of ATagent ***
	
	int loc = ATtokenOps.findnextinstanceof("version",tokens,0);
	double v=Double.parseDouble(tokens[loc+3]);
	//setVersion(v);
//	roles = new Vector();
  //Code for constructing object model from MAML tokens
	if (v>=1) constructFromV1(tokens, sys, v);
	else {
		System.out.println("Loading a version other than 1.");	
	}
 	//	System.out.println("Loaded an agent");
}
	//keeps track of whether an agent's corner is selected
	
/**
 * ATagent constructor comment.
 */
public ATsys(double v, int keynum) {
	super(v);
	setKey(ukh + keynum);
	MAMLheader+="<!DOCTYPE agent SYSTEM \"atagent"+Double.toString(getVersion())+".dtd\">\n";
	grfxObj = new ATsysGRFX();
	setCoordinates(50,50,50,50);
	agents = new Vector();
}
/**
 * ATagent constructor comment.
 */
public ATsys(double ver, String x, ATsystem sys) {
	this(ver,ATtokenOps.parseLine(x),sys);
}
	//keeps track of whether an agent's corner is selected
	
/**
 * ATagent constructor comment.
 */
public ATsys(ATsys cp) {
	super(cp);
}
/**
 * Insert the method's description here.
 * Creation date: (5/19/00 10:29:50 AM)
 * @param a afit.system.ATagent
 */
public void addAgent(ATagent2 a) {
	agents.add(a);
	}
/**
 * Insert the method's description here.
 * Creation date: (2/12/01 1:31:19 PM)
 * @return boolean
 * @param container system.ATsys
 */
public boolean checkContained(ATsys container) {
	if(this != container) {
		Square box = container.getGrfx();

		return (box.x1() <= grfxObj.x1() && box.x2() >= grfxObj.x2() &&
			box.y1() <= grfxObj.y1() && box.y2() >= grfxObj.y2());
		
	} else return false;
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public boolean checkSelected(int x, int y) {
	//check to see if object has been selected
	selCorner = grfxObj.checkCorners(x,y);
	selEdge = grfxObj.checkEdges(x,y);
		
	if(selCorner != -1) {
		Selected = false;
		cornerSelected = true;
		edgeSelected = false;
		return false;
	} else if(selEdge != -1) {
		Selected = false;
		cornerSelected = false;
		edgeSelected = true;
		return false;
	} else if(grfxObj.dist(x,y)) {
		Selected = true;
		cornerSelected = false;
		edgeSelected = false;
		return true;
	} else {
		Selected = false;
		cornerSelected = false;
		edgeSelected = false;
		return false;
	}
	
}
/**
 * Insert the method's description here.
 * Creation date: (10/25/99 11:28:36 PM)
 */
public void constructFromV1(String[] tokens, ATsystem sys, double v) {
	
	int end=0;
	int loc = ATtokenOps.findnextinstanceof("name",tokens,0);
	setName(tokens[loc+3]);

	boolean keybased = false;
	
	loc  = ATtokenOps.findnextinstanceof("key", tokens, loc);
	if(loc != -1) {
		setKey(tokens[loc+3]);
		keybased = true;
	} else {
		setKey(ukh + sys.getNextKey());
	}
		
	int start=ATtokenOps.findnextinstanceof("description", tokens, loc+3);
	loc  = ATtokenOps.findnextinstanceof("/description", tokens, start+2);
	description=ATtokenOps.extract(tokens,(start+2), (loc-2));
	loc = ATtokenOps.findnextinstanceof("size",tokens,loc);
	int agentNum = Integer.parseInt(tokens[loc+4]);
	loc = loc+4;
	Enumeration agents;
	ATagent2 a;
	for(int i=0; i<agentNum; i++){
		String agentName = tokens[loc+2];
		loc = loc+2;
		agents = sys.returnAgentInstances();
		while(agents.hasMoreElements()){
			a = (ATagent2)agents.nextElement();
			if(keybased) {
				if(a.getKey().equals(agentName)){
					addAgent(a);
				}
			} else {
				if(a.getFname().equals(agentName)){
					addAgent(a);
				}
			}
		}
	}
	//Get agent coordinates for graphics display
	loc  = ATtokenOps.findnextinstanceof("view", tokens, loc+2);
	if (loc>0){ //KB-stored agents do not have view information
				//because they appear at a location the operator selects
		int x = Integer.parseInt(tokens[loc+5]);
		int y = Integer.parseInt(tokens[loc+11]);
		int h = Integer.parseInt(tokens[loc+17]);
		int w = Integer.parseInt(tokens[loc+23]);
		loc+=25;
		setCoordinates(x,y,h,w);
	}
}
public int conversationCount() {
	//return the number of conversations connected to this agent
	return grfxObj.lineCount();
}
/**
 * This method was created in VisualAge.
 */
public void draw(java.awt.Graphics g) {
	//draw the object
	grfxObj.drawObject(g);
	//if the object is selected, draw the selection box
	if(Selected || cornerSelected || edgeSelected){
		grfxObj.drawSelected(g);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (7/14/00 10:04:23 AM)
 * @param agents java.util.Vector
 */
public void findAgents(Enumeration agents) {
	ATagent2 agent;
	this.agents = new Vector();
	while(agents.hasMoreElements()){
		agent = (ATagent2)agents.nextElement();
		if(checkSelected(agent.getCenterX(),agent.getCenterY())){
			addAgent(agent);
		}
	}
	Selected = true;
}
/**
 * Insert the method's description here.
 * Creation date: (5/18/00 2:05:13 PM)
 * @return java.util.Enumeration
 */
public Vector getAgents() {
	return agents;
}
/**
 * This method was created in VisualAge.
 * @return system.ATagentGRFX
 */
public ATsysGRFX getGrfx() {
	return grfxObj;
}
/**
 * Insert the method's description here.
 * Creation date: (10/20/99 1:16:45 PM)
 */
public String getMAML() throws NullPointerException {

	//Opening line for a system element
	MAML = "";
	MAML += "\t<sys";
	MAML += " version=\"" + Double.toString(version) + "\"";
	MAML += " name=\"" + name + "\">\n";
	
	MAML += " key=\"" + getKey() + "\"";
	
	//MAML += " name=\"" + name + "\">\n";
	//New Line for Description element
	MAML += "\t\t<description>\n\t\t";
	MAML += getDescription();
	MAML += "\n\t\t</description>\n";
	MAML += "agents : size = " + agents.size() + "\n";
	Enumeration a = agents.elements();
	ATagent2 agent;
	while(a.hasMoreElements()){
		agent = (ATagent2)a.nextElement();
		MAML += " " + agent.getKey();
		//MAML += " " + agent.getFname();
	}
	int[] c = grfxObj.getCoords();
	MAML += "\t\t<view";
	MAML += " x=\"" + c[4] + "\"";
	MAML += " y=\"" + c[5] + "\"";
	MAML += " w=\"" + c[2] + "\"";
	MAML += " h=\"" + c[3] + "\"/>\n";
//	architecture.encodeMAML();
//	MAML += architecture.getMAML();
/*	Enumeration Roles = roles.elements();
	ATRole role;
	MAML += "\t\t\t<Roles>\n\t\t\t";
	MAML += "\"Num Roles\" = " + roles.size();
	while(Roles.hasMoreElements()){
		role = (ATRole)Roles.nextElement();
		MAML+= "\"" + role.getName() + "\"";
	}
		*/
	//Closing line for an Agent element		
	MAML += "\t</sys>\n";

	return MAML;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getName() {
	return name;
}
/**
 * Insert the method's description here.
 * Creation date: (10/28/99 10:31:27 AM)
 */
public void integrateKBInfo(String maml, ATsystem sys) {
  String[] tokens = ATtokenOps.parseLine(maml);
  int v=Integer.parseInt(tokens[6]);
	
  //Code for constructing object model from MAML tokens
  if (v==version) {
	constructFromV1(tokens, sys, v);
  }
  else {
	System.out.println("Loading from KB a version other than 1");	
  }	
}
/**
 * Insert the method's description here.
 * Creation date: (6/29/00 3:32:45 PM)
 * @return boolean
 * @param agent system.ATagent2
 */
public boolean isConnectedTo(ATagent2 agent) {
	Line l = null;
	if(grfxObj.connectedTo(agent.getGrfx(),l)){
		return true;
	} 
	return false;
}
/**
 * This method was created in VisualAge.
 * @param x int
 * @param y int
 */
public void move(int x, int y, int mode) {
	//move the graphics object
		grfxObj.move(x,y,mode);
	
}
/**
 * Insert the method's description here.
 * Creation date: (7/14/00 9:35:02 AM)
 * @param x int
 * @param y int
 */
public void moveCorner(int x, int y) {
	grfxObj.moveCorner(selCorner,x,y);
}
/**
 * Insert the method's description here.
 * Creation date: (7/14/00 9:35:02 AM)
 * @param x int
 * @param y int
 */
public void moveEdge(int x, int y) {
	grfxObj.moveEdge(selEdge,x,y);
}
/**
 * This method was created in VisualAge.
 */
public void print(java.awt.Graphics g) {
	grfxObj.paint(g);
}
/**
 * Insert the method's description here.
 * Creation date: (5/18/00 2:05:13 PM)
 * @return java.util.Enumeration
 */
public void setAgents(Vector r) {
	agents = r;
//	Vector hold = new Vector();
//	java.util.Enumeration enum = goals.elements();
/*	while(enum.hasMoreElements()){
		agent = (ATagent2)enum.nextElement();
		hold.add((String)agent.getName());
	}
	grfxObj.setGoals(hold);*/
}
/**
 * This method was created in VisualAge.
 */
public void setCoordinates(int x, int y, int width, int height) {
	if(width<0){
		width = 0 - width;
	}
	if(height<0){
		height = 0 - height;
	}
	grfxObj.place(x,y,width,height);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public void setName(String s) {
	name = ATtokenOps.validName(s);
	//set the name of the graphics object
	grfxObj.setName(name);
	//resize the graphics object accordingly
//	grfxObj.resetMax();
}
/**
 * Insert the method's description here.
 * Creation date: (7/17/00 2:17:09 PM)
 */
public void writeDATA() {
	super.writeDATA();
	MAML+= "\n\tAgents:\n";
	Enumeration agents = getAgents().elements();
	ATagent2 agent;
	while(agents.hasMoreElements()){
		agent = (ATagent2)agents.nextElement();
		MAML+= "\t" + agent.getFname() + "\n";
	}
}
}
