package system;

/**
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
 import java.io.*;
 import java.awt.*;
 import java.util.Vector;
abstract class Circle extends Square {
/**
 * Circle constructor comment.
 */
public Circle() {
	super();
}
/**
 * Circle constructor comment.
 */
public Circle(Circle cp) {
	super();
}
//------------------------------
//attach a line to the circle
//------------------------------
//ForS is whether the circle is the First point of the line or the Second
public void add(Line n, int quad, int ForS) {
	// The value of quad is ignored for this class.  This function overrides
	// the default Square function.
	
	setEndPoint(n,ForS);
	LinesX1.addElement(n);
}
/**
 * This method was created in VisualAge.
 */
public void deleteLine(Line line, int quad) {
	// The value of quad is ignored for this class.  This function overrides
	// the default Square function.
	
	LinesX1.removeElement(line);
}
	// Calculate distance from center of circle to a point in space
	
	public boolean dist(int x, int y) {

		double dist = (center_x - x) * (center_x - x) +
			(center_y - y) * (center_y - y);
			
		if (dist < width*width){
			return true;
		} else {
			return false;
		}
	}
/**
 * must override Square method, so return 50 b/c it will not
 * be recognized as selected if the distance is that large.
 * This method was created in VisualAge.
 * @param XorY char
 * @param Num int
 */
public double dist(int quad, int a, int b) {
	// The value of quad is ignored for this class.  This function overrides
	// the default Square function.

	return 50;
}
/**
 * This method was created in VisualAge.
 */
public double dist(int x, int y, int i, int j) {
		
		double dist = Math.sqrt((center_x - x) * (center_x - x) +
			(center_y - y) * (center_y - y));
			
		return(dist);
	}
//-----------------------------------
// Move circle to new position
//-----------------------------------
	public void move(int dx, int dy) {
		move(dx,dy,FREE_MOVE);
	}
public void move(int dx, int dy, int mode) {

	// make sure that mode is a valid value
	boolean delta = false;
	if(mode == DELTA_MODE) delta = true;
	
	if (mode < FREE_MOVE || mode > VERTICAL) mode = FREE_MOVE;

	// Calculate new center
	if(mode == FREE_MOVE || mode == HORIZONTAL) {
		if(delta) {
			x1 = x1 + dx;
			x2 = x1 + width;
			center_x = x1 + (width/2);
		} else {
			center_x = dx;
			x1 = center_x - (width/2);
			x2 = x1 + width;
		}
	}
	if(mode == FREE_MOVE || mode == VERTICAL) {
		if(delta) {
			y1 = y1 + dy;
			y2 = y1 + height;
			center_y = y1 + (height/2);
		} else {
			center_y = dy;
			y1 = center_y - (height/2);
			y2 = y1 + height;		
		}
	}

	refresh();
}
//-------------------------------------------
// Place a new circle in its first position
//-------------------------------------------
	public void place(int fx1, int fy1, int width, int height) {
		//find the corner point for the circle
		x1 = fx1-width/2;		
		y1 = fy1-height/2;
		
		//find the center point for the circle
		center_x = fx1;
		center_y = fy1;

		//set the width and height
		this.width = width;
		this.height = height;
	}
/**
 * This method was created in VisualAge.
 */
public void rearrangeLines(int quad) {
	// The value of quad is ignored for this class.  This function overrides
	// the default Square function.

	java.util.Enumeration X1 = LinesX1.elements();
	while (X1.hasMoreElements()){
		Line selected = (system.Line)X1.nextElement();
		if(selected.type() != "loop") {
			if(selected.first == this){
				setEndPoint(selected,1);
				selected.Arrow();
			} else if(selected.second == this){
				setEndPoint(selected,2);
				selected.Arrow();
			}
		} else{
			resizeLoop(quad);
		}
	}
}
/**
 * Insert the method's description here.
 * Creation date: (1/19/01 1:16:48 PM)
 */
public void refresh() {
	rearrangeLines(0);

	java.util.Vector OtherSquares = new Vector();
	java.util.Enumeration X1 = LinesX1.elements();
	while (X1.hasMoreElements()) {
		Line selected = (system.Line)X1.nextElement();
		if(selected.type() != "loop") {
			if(selected.first == this){
				selected.newSide(2);
				if(!OtherSquares.contains(selected.second)) OtherSquares.add(selected.second);
			} else if(selected.second == this){
				selected.newSide(1);
				if(!OtherSquares.contains(selected.first)) OtherSquares.add(selected.first);
			}
		}
	}
	
	java.util.Enumeration sqrs = OtherSquares.elements();
	Square temp;
	while(sqrs.hasMoreElements()) {
		temp = (Square)sqrs.nextElement();
		temp.rearrangeLines(0);
		if(!(temp instanceof Circle)) {
			temp.rearrangeLines(1);
			temp.rearrangeLines(2);
			temp.rearrangeLines(3);
		}
	}
}
/**
 * This method was created in VisualAge.
 */
public void resize(int newx, int newy) {
	}
/**
 * This method was created in VisualAge.
 */
public void set(int x, int y) {
	this.center_x = x;		//the x coordinate of the center of the circle
	this.center_y = y;		//the y coordinate of the center of the circle
	this.height   = 20;			//the height of the circle
	this.width	 = 20;			//the width of the circle
	this.x1		 = center_x - width/2;				//the x coordinate of the left-upper corner of the box around the circle
	this.y1		 = center_y - height/2;
}
/**
 * Insert the method's description here.
 * Creation date: (11/28/00 4:05:41 PM)
 * @return java.awt.Point
 * @param n system.Line
 */
public void setEndPoint(Line ln, int type) {
	int n = 0;
	int n2 = 1;
	
	if (type==2){
		n = ln.n() - 1;
		n2 = ln.n() - 2;
	}

	double a = width/2;
	double b = height/2;
	double dx = ln.x(n2) - center_x;
	double dy = ln.y(n2) - center_y;

	double d = (Math.sqrt(dx * dx * b * b + dy * dy * a * a));
		
	ln.setPoint(n,(int)(center_x + (a * b * dx / d)),(int)(center_y + (a * b * dy / d)));
}
}
