package system;

/**
 * This type was created in VisualAge.
 *
 * THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS RELEASED "AS IS."
 * THE U.S. GOVERNMENT MAKES NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * CONCERNING THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION, INCLUDING,
 * WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE.  IN NO EVENT WILL THE U.S. GOVERNMENT BE LIABLE
 * FOR ANY DAMAGES, INCLUDING ANY LOST PROFITS, LOST SAVINGS OR OTHER
 * INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE, OR 
 * INABILITY TO USE, THIS SOFTWARE OR ANY ACCOMPANYING DOCUMENTATION,
 * EVEN IF INFORMED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.
 *
 */
//___________________________________________________
// Class to represent a line
//___________________________________________________
import java.io.*;
import java.util.Vector;
import java.awt.*;

public abstract class Square {

	public static final int FREE_MOVE = 0;
	public static final int HORIZONTAL = 1;
	public static final int VERTICAL = 2;
	public static final int DELTA_MODE = 3;

	// Current position of square
	int x1, y1, x2, y2;

	int x,y;  //---the corner of the box that is selected

	//position of square - center point
	int center_x, center_y;
	
	//height and width of square	
	int width;
	int height;

	
	Vector LinesX1 = new Vector();
	Vector LinesX2 = new Vector();
	Vector LinesY1 = new Vector();
	Vector LinesY2 = new Vector();
public Square() {
	super();
}
public Square(Square cp) {
	super();
}
/**
 * This method was created in VisualAge.
 */
public void add(Line n, int quad, int ForS){// int k) {
	//pos is if it's connected to an 'x' or 'y' on the square-
	//the x's being verticle sides and y's being horizontal.
	//j is the side (1 or 2)  one is the left or top and two
	//is the right or bottom.
	//ForS(First or Second) is the square number that this is-
	//relative to the line (needed b/c the line has points x1,y1
	//and x2,y2- we need to know which ones to change).

	// quad is my representation of the connection quadrent.
	// These will correspond to the legacy types pos,num.  
	//
	//						       quad1
	// quad 0 = 'x',1		      \_____/
	// quad 1 = 'y',1		quad0  |   | quad2
	// quad 2 = 'x',2		       |___|
	// quad 3 = 'y',2		      /     \
	//						       quad3

	int pt1 = 0, pt2 = 0;
	if(ForS == 1){
		pt1 = 0;
		pt2 = 1;
		n.first = this;
	} else {
		pt1 = n.n()-1;
		pt2 = n.n()-2;
		n.second = this;
	}
	
	Vector lines = null;
	
	switch(quad){
		case 0: lines = LinesX1;
				n.setPoint(pt1,x1,center_y);
				break;
		case 1: lines = LinesY1;
				n.setPoint(pt1,center_x,y1);
				break;
		case 2: lines = LinesX2;
				n.setPoint(pt1,x2,center_y);
				break;
		case 3: lines = LinesY2;
				n.setPoint(pt1,center_x,y2);
				break;
		default : break;
	}

	int num;
	double slope = n.slope(this);
	double slope2;
	Line temp;

	if(lines != null) {
		num = lines.size();
		for(int i=0; i<lines.size(); i++) {
			temp = (Line)(lines.elementAt(i));
			slope2 = temp.slope(this);
			if(slope2 < slope) {
				num = i;
				break;
			}
		}
		lines.insertElementAt(n,num);
	}

	rearrangeLines(quad);
					
	
/*	if (pos == 'x') {
		for (int i=1; i<n_lines; i++){
			before = (Line)(lines.elementAt(i-1));
			selected = (Line)(lines.elementAt(i));
			if (n_lines>0) {
				if(selected.x(0)==a){
					if (ForS==1){
						if (n.second.center_y<selected.y(selected.n()-1)) {
							if (i==0) {
								num = i;
							}
							else if (n.second.center_y>before.y(before.n()-1)) {
								num = i;
							}
						}
					}
					if (ForS==2){
						if (n.first.center_y<selected.y(selected.n()-1)) {
							if(i==0) {
								num = i;
							}
							//if ((i!=0) && (n.first.center_y>before.Ys[before.n_pts-1])) {
							else if (n.first.center_y>before.y(before.n()-1)) {
								num = i;
							}
						}
					}
				}
				if(selected.x(selected.n()-1)==a){
					if (ForS==1){
						if (n.second.center_y<selected.y(0)) {
							if(i==0){
								num = i;
							}
							else if (n.second.center_y>before.y(0)) {
								num = i;
							}
						}
					}
					if (ForS==2){
						if (n.first.center_y<selected.y(0)) {
							if(i==0) {
								num = i;
							}
							else if (n.first.center_y>before.y(0)) {
								num = i;
							}
						}
					}
				}
			}	
		}
	}
	if (pos == 'y') {
		if (j == 1) {
			
		}
		if (j == 2) {
			n_lines = LinesY2.size();
			a = y2;
			lines = LinesY2;
		}

		if (ForS == 1) {
			n.setY(0,a);
			n.setX(0,center_x);
		}
		if (ForS == 2) {
			n.setY(n.n()-1,a);
			n.setX(n.n()-1,center_x);
		}
		num= n_lines;
		
		for (int i=1; i<n_lines; i++){
			before = (Line)(lines.elementAt(i-1));
		//	after = ((Line)lines).elementAt(i+1);
			selected = (Line)(lines.elementAt(i));
			if (n_lines>0) {
				if(selected.y(0)==a){
					if (ForS==1){
						if (n.second.center_x<selected.x(selected.n()-1)) {
							if (i==0) {
								num = i;
							}
							else if (n.second.center_x>before.x(before.n()-1)) {
								num = i;
							}
						}
					}
					if (ForS==2){
						if (n.first.center_x<selected.x(selected.n()-1)) {
							if(i==0) {
								num = i;
							}
							else if (n.first.center_x>before.x(before.n()-1)) {
								num = i;
							}
						}
					}
				}
				if(selected.y(selected.n()-1)==a){
					if (ForS==1){
						if (n.second.center_x<selected.x(0)) {
							if(i==0){
								num = i;
							}
							else if (n.second.center_x>before.x(0)) {
								num = i;
							}
						}
					}
					if (ForS==2){
						if (n.first.center_x<selected.x(0)) {
							if(i==0) {
								num = i;
							}
							else if (n.first.center_x>before.x(0)) {
								num = i;
							}
						}
					}
				}
			}	
		}
		
	}
	lines.insertElementAt(n,num);
*/	
			
	/*if (pos == 'x') {
		if (j==1) {
			LinesX1=lines;
		//	n_linesx1 = n_lines+1;
		}
		if (j==2) {
			LinesX2=lines;
		//	n_linesx2 = n_lines+1;
		}
	}
	if (pos == 'y') {
		if (j==1) {
			LinesY1=lines;
		//	n_linesy1 = n_lines+1;
		}
		if (j==2) {
			LinesY2=lines;
		//	n_linesy2 = n_lines+1;
		}
	}*/
}
/**
 * This method was created in VisualAge.
 */
void addLoop(Line n, int quad) {
	// quad is my representation of the connection quadrent.
	// These will correspond to the legacy types pos,num.  
	//
	//						       quad1
	// quad 0 = 'x',1		      \_____/
	// quad 1 = 'y',1		quad0  |   | quad2
	// quad 2 = 'x',2		       |___|
	// quad 3 = 'y',2		      /     \
	//						       quad3

	switch(quad) {
		case 0: LinesX1.addElement(n); break;
		case 1: LinesY1.addElement(n); break;
		case 2: LinesX2.addElement(n); break;
		case 3: LinesY2.addElement(n); break;
		default : break;
	}
}
/**
 * Insert the method's description here.
 * Creation date: (7/12/00 4:04:44 PM)
 */
public int checkCorners(int x, int y) {
	if(Math.abs(x - x1) < 10 && Math.abs(y - y1) < 10) {
		return 0;
	} else if(Math.abs(x - x2) < 10 && Math.abs(y - y1) < 10) {
		return 1;
	} else if(Math.abs(x - x2) < 10 && Math.abs(y - y2) < 10) {
		return 2;
	} else if(Math.abs(x - x1) < 10 && Math.abs(y - y2) < 10) {
		return 3;
	} else { return -1;}
	
}
/**
 * Insert the method's description here.
 * Creation date: (2/12/01 11:33:28 AM)
 * @param x int
 * @param y int
 */
public int checkEdges(int x, int y) {
	if(Math.abs(x - x1) < 10 && y > y1 && y < y2) {
		return 0;
	} else if(Math.abs(y - y1) < 10 && x > x1 && x < x2) {
		return 1;
	} else if(Math.abs(x - x2) < 10 && y > y1 && y < y2) {
		return 2;
	} else if(Math.abs(y - y2) < 10 && x > x1 && x < x2) {
		return 3;
	} else { return -1;}
}
/**
 * Insert the method's description here.
 * Creation date: (6/29/00 1:45:37 PM)
 * @return boolean
 * @param sq system.Square
 */
public boolean connectedTo(Square sq, Line l) {
	java.util.Enumeration X1 = LinesX1.elements();
	java.util.Enumeration X2 = LinesX2.elements();
	java.util.Enumeration Y1 = LinesY1.elements();
	java.util.Enumeration Y2 = LinesY2.elements();
	Line choosen;
		
	while (X1.hasMoreElements()){
		choosen = (Line)X1.nextElement();
		if((choosen!=l)&&(choosen.areConnected(this,sq))){
			return true;
		}
	}
	while (X2.hasMoreElements()){
		choosen = (Line)X2.nextElement();
		if((choosen!=l)&&(choosen.areConnected(this,sq))){
			return true;
		}
	}
	while (Y1.hasMoreElements()){
		choosen = (Line)Y1.nextElement();
		if((choosen!=l)&&(choosen.areConnected(this,sq))){
			return true;
		}
	}	
	while (Y2.hasMoreElements()){
		choosen = (Line)Y2.nextElement();
		if((choosen!=l)&&(choosen.areConnected(this,sq))){
			return true;
		}
	}
	return false;
}
/**
 * This method was created in VisualAge.
 */
public void deleteLine(Line line, int quad) {
	// quad is my representation of the connection quadrent.
	// These will correspond to the legacy types pos,num.  
	//
	//						       quad1
	// quad 0 = 'x',1		      \_____/
	// quad 1 = 'y',1		quad0  |   | quad2
	// quad 2 = 'x',2		       |___|
	// quad 3 = 'y',2		      /     \
	//						       quad3

	switch(quad) {
		case 0 : LinesX1.removeElement(line);  break;
		case 1 : LinesY1.removeElement(line);  break;
		case 2 : LinesX2.removeElement(line);  break;
		case 3 : LinesY2.removeElement(line);  break;
		default : break;
	}
	
	rearrangeLines(quad);
}
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	// Calculate distance from center of line to a point in space
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	public boolean dist(int x, int y) {

		double dist = (center_x - x) * (center_x - x) +
			(center_y - y) * (center_y - y);

		if(((x1<x)&&(y1<y))&&((x<x2)&&(y<y2))){
			return true;
		} else {
			return false;
		}
		
	}
/**
 * This method was created in VisualAge.
 * @param XorY char
 * @param Num int
 */
public double dist(int quad, int a, int b) {
	// quad is my representation of the connection quadrent.
	// These will correspond to the legacy types pos,num.  
	//
	//						       quad1
	// quad 0 = 'x',1		      \_____/
	// quad 1 = 'y',1		quad0  |   | quad2
	// quad 2 = 'x',2		       |___|
	// quad 3 = 'y',2		      /     \
	//						       quad3
	
	int x = 0;
	int y = 0;
	double dist;

	switch(quad) {
		case 0: y = (y1+y2)/2;
				x = x1;
				break;
		case 1: x = (x1+x2)/2;
				y = y1;
				break;
		case 2: y = (y1+y2)/2;
				x = x2;
				break;
		case 3: x = (x1+x2)/2;
				y = y2;
				break;
		default : break;
	}
	
	dist = Math.sqrt((a-x)*(a-x)+(b-y)*(b-y));
	return dist;
}
/**
 * This method was created in VisualAge.
 */
public double dist(int x, int y, int i, int j) {
		int xi;
		int yj;
		if (i == 1) {xi = x1;}
		else if (i == 2) {xi = x2;}
		else {xi = 0;}
		
		if (j == 1) {yj = y1;}
		else if (j == 2) {yj = y2;}
		else {yj = 0;}
		
		double dist = Math.sqrt((xi - x) * (xi - x) +
			(yj - y) * (yj - y));
			
		return(dist);
	}
	//- - - - - - - - -
	// Draw a blue line
	//- - - - - - - - -
public abstract void drawObject(java.awt.Graphics g);
/**
 * Insert the method's description here.
 * Creation date: (10/25/99 1:09:26 PM)
 */
public int[] getCoords() {
	
	int[] c= new int[6];
		c[0]=center_x;
		c[1]=center_y;
		c[2]=width;
		c[3]=height;
		c[4]=x1;
		c[5]=y1;
	return c;
	}
/**
 * Insert the method's description here.
 * Creation date: (11/16/00 5:22:03 PM)
 * @return int
 */
public int h() {
	return height;
}
public int lineCount() {
	int count = LinesX1.size() + 
	            LinesX2.size() +
	            LinesY1.size() +
	            LinesY2.size();
	return count;
}
	//- - - - - - - - - - - - - -
	// Move line to new position
	//- - - - - - - - - - - - - -
	public void move(int dx, int dy) {
		move(dx,dy,FREE_MOVE);
	}
//- - - - - - - - - - - - - -
// Move line to new position
//- - - - - - - - - - - - - -
public void move(int dx, int dy, int mode) {
	// make sure that mode is a valid value
	boolean delta = false;
	if(mode == DELTA_MODE) delta = true;
	
	if (mode < FREE_MOVE || mode > VERTICAL) mode = FREE_MOVE;

	// Calculate new center
	if(mode == FREE_MOVE || mode == HORIZONTAL) {
		if(delta) {
			x1 = x1 + dx;
			x2 = x1 + width;
			center_x = x1 + (width/2);
		} else {
			center_x = dx;
			x1 = center_x - (width/2);
			x2 = x1 + width;
		}
	}
	if(mode == FREE_MOVE || mode == VERTICAL) {
		if(delta) {
			y1 = y1 + dy;
			y2 = y1 + height;
			center_y = y1 + (height/2);
		} else {
			center_y = dy;
			y1 = center_y - (height/2);
			y2 = y1 + height;		
		}
	}

	refresh();
}
/**
 * Insert the method's description here.
 * Creation date: (2/12/01 11:49:55 AM)
 * @param corner int
 * @param x int
 * @param y int
 */
public void moveCorner(int corner, int x, int y) {
	/* corners are numbered as follows.
	  c0       c1
		\_____/
		 |   |
		 |___|
		/     \
	  c3       c2
	*/

	switch(corner) {
		case -1: break;
		case 0: if(x < x2-75) x1 = x; else x1 = x2-75;
				if(y < y2-75) y1 = y; else y1 = y2-75;
				break;
		case 1: if(x > x1+75) x2 = x; else x2 = x1+75;
				if(y < y2-75) y1 = y; else y1 = y2-75;
				break;
		case 2: if(x > x1+75) x2 = x; else x2 = x1+75;
				if(y > y1+75) y2 = y; else y2 = y1+75;
				break;
		case 3: if(x < x2-75) x1 = x; else x1 = x2-75;
				if(y > y1+75) y2 = y; else y2 = y1+75;
				break;
		default : break;
	}
	
	width = x2-x1;
	height = y2-y1;
	center_x = (x1+x2)/2;
	center_y = (y1+y2)/2;
	
}
/**
 * Insert the method's description here.
 * Creation date: (2/12/01 11:49:31 AM)
 * @param edge int
 * @param x int
 * @param y int
 */
public void moveEdge(int edge, int x, int y) {
	/* edges corrolate to quad.
			edge1
			_____
	edge0	|   |  edge2
			|___|
			
			edge3
	*/

	switch(edge) {
		case -1: break;
		case 0: if(x < x2-75) x1 = x; else x1 = x2-75;
				//if(y < y2-75) y1 = y; else y1 = y2-75;
				break;
		case 1: //if(x > x1+75) x2 = x; else x2 = x1+75;
				if(y < y2-75) y1 = y; else y1 = y2-75;
				break;
		case 2: if(x > x1+75) x2 = x; else x2 = x1+75;
				//if(y > y1+75) y2 = y; else y2 = y1+75;
				break;
		case 3: //if(x < x2-75) x1 = x; else x1 = x2-75;
				if(y > y1+75) y2 = y; else y2 = y1+75;
				break;
		default : break;
	}
	
	width = x2-x1;
	height = y2-y1;
	center_x = (x1+x2)/2;
	center_y = (y1+y2)/2;
	
}
/**
 * Insert the method's description here.
 * Creation date: (12/12/00 4:09:44 PM)
 * @param n system.Line
 * @param quad_ori int
 * @param quad_fin int
 */
public void moveLine(Line n, int quad_ori, int quad_fin) {
	// quad_ori and quad_fin are my representation of original and final connection
	// quadrents.  These will correspond to the legacy types pos,num.  
	//
	//						       quad1
	// quad 0 = 'x',1		      \_____/
	// quad 1 = 'y',1		quad0  |   | quad2
	// quad 2 = 'x',2		       |___|
	// quad 3 = 'y',2		      /     \
	//						       quad3

	if(quad_ori != quad_fin) {
		
		switch(quad_ori) {
			case 0 : LinesX1.remove(n); break;
			case 1 : LinesY1.remove(n); break;
			case 2 : LinesX2.remove(n); break;
			case 3 : LinesY2.remove(n); break;
			default : break;
		}

		switch(quad_fin) {
			case 0 : LinesX1.add(n); break;
			case 1 : LinesY1.add(n); break;
			case 2 : LinesX2.add(n); break;
			case 3 : LinesY2.add(n); break;
			default : break;
		}
	}
}
	//- - - - - - - - - - - - - - - - - - - -
	// Place a new line in its first position
	//- - - - - - - - - - - - - - - - - - - -
	public void place(int fx1, int fy1, int fx2, int fy2) {
		x2 = fx1+fx2/2;
		y2 = fy1+fy2/2;
		x1 = fx1-fx2/2;
		y1 = fy1-fy2/2;
		
		center_x = fx1;
		center_y = fy1;
		width = fx2;;
		height = fy2;
	}
/**
 * This method was created in VisualAge.
 */
public void rearrangeLines(int quad) {
	// quad is my representation of the connection quadrent.
	// These will correspond to the legacy types pos,num.  
	//
	//						       quad1
	// quad 0 = 'x',1		      \_____/
	// quad 1 = 'y',1		quad0  |   | quad2
	// quad 2 = 'x',2		       |___|
	// quad 3 = 'y',2		      /     \
	//						       quad3


	Line selected;
	java.util.Enumeration lines;
	java.util.Vector temp = new Vector();
	double[][] slopes;
	int space;

	switch(quad){
		case 0: space = height / (LinesX1.size() + 1);
				slopes = new double[LinesX1.size()][2];
				for(int i=0; i<LinesX1.size(); i++) {
					selected = (Line)LinesX1.elementAt(i);
					slopes[i][0] = selected.slope(this);
					slopes[i][1] = (double)i;
				}
				selsort(slopes,quad);
				for(int i=0; i<slopes.length; i++) {
					selected = (Line)LinesX1.elementAt((int)slopes[i][1]);
					if(selected.first == this) {
						selected.setPoint(0,x1-1,y2-(space*(i+1)));
					} else {
						selected.setPoint(selected.n()-1,x1-1,y2-(space*(i+1)));
					}
					selected.Arrow();
				}
				break;
				
		case 1: space = width / (LinesY1.size() + 1);
				slopes = new double[LinesY1.size()][2];
				for(int i=0; i<LinesY1.size(); i++) {
					selected = (Line)LinesY1.elementAt(i);
					slopes[i][0] = selected.slope(this);
					slopes[i][1] = (double)i;
				}
				selsort(slopes,quad);
				for(int i=0; i<slopes.length; i++) {
					selected = (Line)LinesY1.elementAt((int)slopes[i][1]);
					if(selected.first == this) {
						selected.setPoint(0,x2-(space*(i+1)),y1-1);
					} else {
						selected.setPoint(selected.n()-1,x2-(space*(i+1)),y1-1);
					}
					selected.Arrow();
				}
				break;
				
		case 2: space = height / (LinesX2.size() + 1);
				slopes = new double[LinesX2.size()][2];
				for(int i=0; i<LinesX2.size(); i++) {
					selected = (Line)LinesX2.elementAt(i);
					slopes[i][0] = selected.slope(this);
					slopes[i][1] = (double)i;
				}
				selsort(slopes,quad);
				for(int i=0; i<slopes.length; i++) {
					selected = (Line)LinesX2.elementAt((int)slopes[i][1]);
					if(selected.first == this) {
						selected.setPoint(0,x2+1,y1+(space*(i+1)));
					} else {
						selected.setPoint(selected.n()-1,x2+1,y1+(space*(i+1)));
					}
					selected.Arrow();
				}
				break;
				
		case 3: space = width / (LinesY2.size() + 1);
				slopes = new double[LinesY2.size()][2];
				for(int i=0; i<LinesY2.size(); i++) {
					selected = (Line)LinesY2.elementAt(i);
					slopes[i][0] = selected.slope(this);
					slopes[i][1] = (double)i;
				}
				selsort(slopes,quad);
				for(int i=0; i<slopes.length; i++) {
					selected = (Line)LinesY2.elementAt((int)slopes[i][1]);
					if(selected.first == this) {
						selected.setPoint(0,x1+(space*(i+1)),y2+1);
					} else {
						selected.setPoint(selected.n()-1,x1+(space*(i+1)),y2+1);
					}
					selected.Arrow();
				}
				break;
				
		default : break;
	}
	
/*
	
//	java.util.Enumeration X1 = LinesX1.elements();
//	java.util.Enumeration X2 = LinesX2.elements();
//	java.util.Enumeration Y1 = LinesY1.elements();
//	java.util.Enumeration Y2 = LinesY2.elements();
//	java.util.Enumeration lines2;
//	int a,b;
//	int space;
//	int num;
//	int position = 1;


	if((pos == 'x')){//&&(j == 1)){
		a = y1;
		if(j==1){
			lines = X1;
			b=x1;
			num = LinesX1.size();
			space = (y2-y1)/(num+1);
		} else {
//		a = y1;
			lines = X2;
			b=x2;
			num = LinesX2.size();
			space = (y2-y1)/(num+1);
		}
	//int position = 1;
	//if(pos == 'x'){
		while (lines.hasMoreElements()){
			selected = (system.Line)lines.nextElement();
			if(selected.first == this){
				selected.setY(0,a+(position)*space);
				selected.setX(0,b);
				position++;
				selected.Arrow();
			} else if(selected.second == this){
				selected.setY(selected.n()-1,a+(position)*space);
				selected.setX(selected.n()-1,b);
				position++;
				selected.Arrow();
			}
		}
	}
	if(pos == 'y'){//&&(j==1)) {
		a=x1;
		if(j==1){
			lines2 = Y1;
			b=y1;
			num = LinesY1.size();
			space = (x2-x1)/(num + 1);
		} else {
//		a=x1;
			lines2 = Y2;
			b=y2;
			num = LinesY2.size();
			space = (x2-x1)/(num + 1);
		}
//	}
//	if(pos == 'y'){
		while (lines2.hasMoreElements()){
			selected = (system.Line)lines2.nextElement();
			if(selected.type() != "loop") {
				if(selected.first == this){
					selected.setX(0,a+(position)*space);
					selected.setY(0,b);
					position++;
					selected.Arrow();
				} else if(selected.second == this){
					selected.setX(selected.n()-1,a+(position)*space);
					selected.setY(selected.n()-1,b);
					position++;
					selected.Arrow();
				}
			} else{
				resizeLoop(pos,j);
			}
		}
	}
	System.out.println("pos" + pos);
	if (pos == 'x') {
		if (j == 1) {
			
			//add(n,pos,j,ForS);
			int space = (y2 - y1)/(LinesX1.size()+1);
			for (int line_no=1; line_no<LinesX1.size()+1; line_no++){
				selected = (Line)LinesX1.elementAt(line_no);
				if(selected.x(0) == x1){
					selected.y(0) = y1+(line_no+1)*space;
				}
				if(selected.x(selected.n()-1) == x1){
					selected.y(selected.n()-1) = y1+(line_no+1)*space;
				}
			}
		}
		if (j == 2) {
		
			//add(n,pos,j,ForS);
		
			int space = (y2 - y1)/(LinesX2.size()+1);
			for (int line_no=0; line_no<LinesX2.size(); line_no++){
				selected = (Line)LinesX2.elementAt(line_no);
				if(selected.x(0) == x2){
					selected.y(0) = y1+(line_no+1)*space;
				}
				if(selected.x(selected.n()-1) == x2){
					selected.y(selected.n()-1) = y1+(line_no+1)*space;
				}
			}
		}
	}
	if (pos == 'y') {
		if (j == 1) {
			//add(n,pos,j,ForS);
			
			int space = (x2 - x1)/(LinesY1.size()+1);
			for (int line_no=0; line_no<LinesY1.size(); line_no++){
				selected = (Line)LinesY1.elementAt(line_no);
				if(selected.y(0) == y1){
					selected.x(0) = x1+(line_no+1)*space;
				}
				if(selected.y(selected.n()-1) == y1){
					selected.x(selected.n()-1) = x1+(line_no+1)*space;
				}
			}
		}
		if (j == 2) {
			//add(n,pos,j,ForS);
			
			int space = (x2 - x1)/(LinesY2.size()+1);
			for (int line_no=0; line_no<LinesY2.size(); line_no++){
				selected = (Line)LinesY2.elementAt(line_no);
				if(selected.y(0) == y2){
					selected.x(0) = x1+(line_no+1)*space;
				}
				if(selected.y(selected.n()-1) == y2){
					selected.x(selected.n()-1) = x1+(line_no+1)*space;
				}
			}
		}
	}*/
}
/**
 * Insert the method's description here.
 * Creation date: (1/19/01 12:16:51 PM)
 */
public void refresh() {
	java.util.Enumeration X1 = LinesX1.elements();
	java.util.Enumeration X2 = LinesX2.elements();
	java.util.Enumeration Y1 = LinesY1.elements();
	java.util.Enumeration Y2 = LinesY2.elements();

	Vector OtherSquares = new Vector(20);
	OtherSquares.add(this);
	
	Line choosen;
	int num;
	while (X1.hasMoreElements()) {
		choosen = (Line) X1.nextElement();
		choosen.newSide(1);
		choosen.newSide(2);
		if(!OtherSquares.contains(choosen.first)) OtherSquares.add(choosen.first);
		if(!OtherSquares.contains(choosen.second)) OtherSquares.add(choosen.second);
		
	}
	while (X2.hasMoreElements()) {
		choosen = (Line) X2.nextElement();
		
		choosen.newSide(1);
		choosen.newSide(2);
		if(!OtherSquares.contains(choosen.first)) OtherSquares.add(choosen.first);
		if(!OtherSquares.contains(choosen.second)) OtherSquares.add(choosen.second);
		
	}
	while (Y1.hasMoreElements()) {
		choosen = (Line) Y1.nextElement();
		
		choosen.newSide(1);
		choosen.newSide(2);
		if(!OtherSquares.contains(choosen.first)) OtherSquares.add(choosen.first);
		if(!OtherSquares.contains(choosen.second)) OtherSquares.add(choosen.second);
		
	}
	while (Y2.hasMoreElements()) {
		choosen = (Line) Y2.nextElement();
		
		choosen.newSide(1);
		choosen.newSide(2);
		if(!OtherSquares.contains(choosen.first)) OtherSquares.add(choosen.first);
		if(!OtherSquares.contains(choosen.second)) OtherSquares.add(choosen.second);
		
	}

	java.util.Enumeration sqrs = OtherSquares.elements();
	Square temp;
	while(sqrs.hasMoreElements()) {
		temp = (Square)sqrs.nextElement();
		temp.rearrangeLines(0);
		if(!(temp instanceof Circle)) {
			temp.rearrangeLines(1);
			temp.rearrangeLines(2);
			temp.rearrangeLines(3);
		}
	}	
}
/**
 * Insert the method's description here.
 * Creation date: (1/26/01 2:28:47 PM)
 * @param l system.Line
 */
public void remove(Line n) {
	LinesX1.removeElement(n);
	LinesY1.removeElement(n);
	LinesX2.removeElement(n);
	LinesY2.removeElement(n);
}
/**
 * This method was created in VisualAge.
 */
public void resize(int newx, int newy) {
		int xi, yi;
		int dx, dy;
		if (x == 1) {xi = x1;}
		else if (x == 2) {xi = x2;}
		else {xi = 1; System.out.println("Did not select a corner.");}

		if (y == 1) {yi = y1;}
		else if (y == 2) {yi = y2;}
		else {yi = 1; System.out.println("Did not select a corner.");}
				
		if(x==1){dx = xi - newx;}
		else {dx = -xi + newx;}
		if(y==1){dy = yi - newy;}
		else {dy = -yi + newy;}
		
		// Apply offsets
		if(((x2>x1+40)&&(y2>y1+40))||((dx>0)&&(dy>0))){
			if(x==1){
				x1 = x1 - dx;
			} else {
				x2 = x2 + dx;
			}
			if(y==1){
				y1 = y1 - dy;
			} else {
				y2 = y2 + dy;
			}
			
			width = width + 2*dx;
			height = height + 2*dy;
			center_x = (x1+x2)/2;
			center_y = (y1+y2)/2;
	//		resize('x',1);
	//		resize('x',2);
	//		resize('y',1);
	//		resize('y',2);
		}
		
	}
/**
 * This method was created in VisualAge.
 */
public void resizeLoop(int quad) {
	// quad is my representation of the connection quadrent.
	// These will correspond to the legacy types pos,num.  
	//
	//						       quad1
	// quad 0 = 'x',1		      \_____/
	// quad 1 = 'y',1		quad0  |   | quad2
	// quad 2 = 'x',2		       |___|
	// quad 3 = 'y',2		      /     \
	//						       quad3

	Line selected;
	java.util.Enumeration lines;
	java.util.Vector temp = new Vector();
	double[][] slopes;
	int space;

	switch(quad){
		case 0: space = height / (LinesX1.size() + 1);
				for(int i=0; i<LinesX1.size(); i++) {
					selected = (Line)LinesX1.elementAt(i);
					if((selected.type()).equals("loop")) {
						selected.setPoint(0,x1-1,y2-(space*(i+1)));
					} 
				}
				break;
				
		case 1: space = width / (LinesY1.size() + 1);
				for(int i=0; i<LinesY1.size(); i++) {
					selected = (Line)LinesY1.elementAt(i);
					if((selected.type()).equals("loop")) {
						selected.setPoint(0,x2-(space*(i+1)),y1-1);
					} 
				}
				break;
				
		case 2: space = height / (LinesX2.size() + 1);
				for(int i=0; i<LinesX2.size(); i++) {
					selected = (Line)LinesX2.elementAt(i);
					if((selected.type()).equals("loop")) {
						selected.setPoint(0,x2+1,y1+(space*(i+1)));
					} 
				}
				break;
				
		case 3: space = width / (LinesY2.size() + 1);
				for(int i=0; i<LinesY2.size(); i++) {
					selected = (Line)LinesY2.elementAt(i);
					if((selected.type()).equals("loop")) {
						selected.setPoint(0,x1+(space*(i+1)),y2+1);
					} 
				}
				break;
				
		default : break;
	}

/*	Line choosen;
	java.util.Enumeration lineEnum;
	int interval;
	int count;
	
	System.out.println("Resize Loop");

	switch(quad) {
		case 0: lineEnum = LinesX1.elements();
				interval = y2-y1/(LinesX1.size()+1);
				count = 1;
				while(lineEnum.hasMoreElements()) {
					choosen = (Line)lineEnum.nextElement();
					if(choosen.type() == "loop"){
						choosen.setPoint(0,x1,y2-interval*(count));
					}
					count++;
				}
				break;
		case 1: lineEnum = LinesY1.elements();
				interval = x2-x1/(LinesY1.size()+1);
				count = 1;
				while(lineEnum.hasMoreElements()) {
					choosen = (Line)lineEnum.nextElement();
					if(choosen.type() == "loop"){
						choosen.setPoint(0,x2-interval*(count),y1);
					}
					count++;
				}
				break;
		case 2: lineEnum = LinesX2.elements();
				interval = y2-y1/(LinesX2.size()+1);
				count = 1;
				while(lineEnum.hasMoreElements()) {
					choosen = (Line)lineEnum.nextElement();
					if(choosen.type() == "loop"){
						choosen.setPoint(0,x2,y2-interval*(count));
					}
					count++;
				}
				break;
		case 3: lineEnum = LinesY2.elements();
				interval = x2-x1/(LinesY2.size()+1);
				count = 1;
				while(lineEnum.hasMoreElements()) {
					choosen = (Line)lineEnum.nextElement();
					if(choosen.type() == "loop"){
						choosen.setPoint(0,x2-interval*(count),y2);
					}
					count++;
				}
				break;
		default : break;
	}
*/	
}
/**
 * Insert the method's description here.
 * Creation date: (12/13/00 2:55:12 PM)
 * @param linecomps int[][]
 */
public void selsort(double[][] linecomps, int quad) {
	// quad is my representation of the connection quadrent.
	// These will correspond to the legacy types pos,num.  
	//
	//						       quad1
	// quad 0 = 'x',1		      \_____/
	// quad 1 = 'y',1		quad0  |   | quad2
	// quad 2 = 'x',2		       |___|
	// quad 3 = 'y',2		      /     \
	//						       quad3

	
	int sel;
	double tempslope;
	double tempindex;
	
	for(int i = 0; i < linecomps.length-1; i++) {
		sel = i;
		for(int j=i+1; j<linecomps.length; j++) {
			if(quad == 0 || quad == 2) {
				if((linecomps[sel][0] < 0 && linecomps[j][0] < 0 && linecomps[j][0] > linecomps[sel][0]) ||
				   (linecomps[sel][0] > 0 && linecomps[j][0] > 0 && linecomps[j][0] > linecomps[sel][0]) ||
				   (linecomps[sel][0] > 0 && linecomps[j][0] < 0))
					sel = j;
			} else {
				if(linecomps[j][0] < linecomps[sel][0])
					sel = j;
			}
		}

		tempslope = linecomps[sel][0];
		tempindex = linecomps[sel][1];
		linecomps[sel][0] = linecomps[i][0];
		linecomps[sel][1] = linecomps[i][1];
		linecomps[i][0] = tempslope;
		linecomps[i][1] = tempindex;
	}	
}
/**
 * Insert the method's description here.
 * Creation date: (11/29/00 2:11:30 PM)
 */
public int x1() {
	return x1;	
}
/**
 * Insert the method's description here.
 * Creation date: (11/29/00 1:57:50 PM)
 * @return int
 */
public int x2() {
	return x2;
}
/**
 * Insert the method's description here.
 * Creation date: (11/29/00 2:12:02 PM)
 * @return int
 */
public int y1() {
	return y1;
}
/**
 * Insert the method's description here.
 * Creation date: (11/29/00 1:58:05 PM)
 * @return int
 */
public int y2() {
	return y2;
}
}
